=== modified file '.bzrignore'
--- .bzrignore	2007-01-03 00:18:09 +0000
+++ .bzrignore	2007-01-14 05:43:15 +0000
@@ -1,3 +1,5 @@
 ./dist
 ./loggerhead.egg-info
 ./loggerhead.conf
+./loggerhead.pid
+./logs

=== modified file 'MANIFEST.in'
--- MANIFEST.in	2006-12-24 06:43:14 +0000
+++ MANIFEST.in	2008-06-22 18:04:15 +0000
@@ -1,4 +1,2 @@
-include dev.cfg loggerhead.conf
-recursive-include loggerhead/templates *.kid
-recursive-include loggerhead/config *.cfg
+include loggerhead.conf.example README.txt NEWS
 recursive-include loggerhead/static *

=== modified file 'Makefile'
--- Makefile	2006-12-24 06:43:14 +0000
+++ Makefile	2007-10-29 16:19:30 +0000
@@ -7,3 +7,6 @@
 clean:
 	rm -rf dist/
 
+check:
+	# XXX MichaelHudson 2007-10-29 bug=158361: We can't run the loggerhead
+	# tests in PQM yet :(

=== added file 'NEWS'
--- NEWS	1970-01-01 00:00:00 +0000
+++ NEWS	2008-06-22 23:47:59 +0000
@@ -0,0 +1,197 @@
+What's changed in loggerhead?
+=============================
+
+1.6 [unreleased]
+----------------
+
+    - Loggerhead is no longer a TurboGears application, but rather a
+      WSGI application built using Paste (see http://wsgi.org/ and
+      http://pythonpaste.org/ for more about WSGI and Paste). XXX more.
+
+    - zpt.cleaner_urls bug 138021 ("loggerhead should generate links
+      based on revision numbers and file paths").  XXX more.
+
+    - The scripts no longer insist on Python 2.4 -- loggerhead works
+      fine with 2.5.
+
+    - Bazaar as of version 1.5 has improved in performance enough that
+      the revision cache no longer gave any noticeable benefit, so it
+      was removed (the files-changed cache is still useful).
+
+    - The templates were rewritten in Zope's TAL markup, powered by
+      the simpleTAL library -- improving both the performance and
+      memory consumption of rendering by a factor of around 3 for
+      large pages over the old Kid templates.
+
+    - Loggerhead's poorly performing text index was disabled.
+
+    - Loggerhead no longer depends on bzrlib functions deprecated in
+      Bazaar 1.5 and removed in 1.6 (Martin Albisetti).
+
+    - The daemonization code was made more regular, fixing bugs
+      #139161 ("Starting loggerhead process may not close its stdin
+      and stdout properly") and #211526 ("Codebrowse log directory has
+      unnecessarily permissive permissions")
+
+    - Some confusion about what the 'file_id' query argument means was
+      cleared up: filter_file_id now means "filter revisions to those
+      that affect this file" in all views and file_id means "examine
+      this file/directory" in the annotate and inventory views.
+
+    - Dates are present more compactly.
+
+    - The loggerhead.conf file can specify which network interface to
+      bind to (Mattias Eriksson)
+
+1.2.1  [06mar2008]
+------------------
+
+    - The changelog view was out of order when not using the revision
+      cache.
+
+1.2  [04mar2008]
+----------------
+
+    - Michael Hudson <michael.hudson@canonical.com> has mostly taken
+      over the maintenance of loggerhead.
+
+    - loggerhead now has a simple test suite -- use 'nosetests' in the
+      loggerhead directory to run it.
+
+    - The rendering performance of pages that display large amounts of
+      text was improved by a factor of 4 or so.
+
+    - loggerhead no longer caches the text of the diffs between
+      revisions.  It rarely helped and wasted a lot of disk space.
+
+    - The layout of most pages was made more "tight" to waste less
+      screen real estate, and some other UI improvements (Kent
+      Gibson).
+
+    - Much dead code was removed.
+
+    - Loggerhead now computes the files changed between revisions only
+      when it needs to know this.  This is a fairly expensive
+      operation in Bazaar, and doing it less massively improves
+      performance and memory usage in some situations.
+
+    - Loggerhead now takes a read lock on the branch being viewed for
+      the duration of each request, which improves performance
+      significantly.
+
+    - Loggerhead no longer uses the corruption-prone Berkely DB-backed
+      shelve module for its caches, and rather (ab)uses a sqlite
+      database instead.
+
+    - The creation of History objects is much faster for large
+      branches (Aaron Bentley).
+
+    - Allow the construction of URLs using revnos and file paths as
+      well as revids and fileids (bug #98826):
+
+      - For changes pages, append the newest revno to display to the
+        URL, like http://.../changes/<revno>
+
+      - For annotate pages, append the revno to display to the URL,
+        followed by the path, like http://.../annotate/<revno>/<path>
+
+      - For file listing and revision pages append the revno to
+        display to the URL, like http://.../files/<revno>
+
+      Loggerhead still generates URLs using revision and file ids for
+      the moment.
+
+    - Many bugs were fixed:
+
+      - Loggerhead does not escape special characters when embedding a
+        revision ID in a URL (bug #88286)
+
+      - Improved robustness in the face of ghosts.
+
+      - Don't crash on displaying a commit with an empty message (bug
+        #86247)
+
+      - codebrowse fails with infinite redirections (James Henstridge,
+        bug #89854)
+
+      - Loggerhead fails to browse revisions that change binary files
+        (James Henstridge, bug #91686)
+
+      - Loggerhead atom feeds expose internal hostname (James
+        Henstridge, bug #93585)
+
+      - loggerhead don't like page break character (0x0C) in text
+        files (bug #113313)
+
+      - codebrowse source listings don't contain line number anchors
+        (bug #98826)
+
+      - only serve up unescaped user content with "Content-Disposition:
+        attachment"
+
+      - viewing the file listing consumes a lot memory (bug #116869)
+
+      - loggerhead can't handle empty branches (bug #119228)
+
+      - upgrading the format of a branch behind loggerhead could make
+        it fail for that branch (bug #118673)
+
+      - Error parsing non-ascii content (bug #117799)
+
+      - Loggerhead failed on whitespace-only commit messages.
+
+      - Links to diffs from within a revision do not work (bug
+        #119422)
+
+      - UTF-8 patches served as ISO-8859-1, fixed by served bundles as
+        application/octet-stream (bug #121336)
+
+      - TurboGears was turning query arguments into unicode, and bzr
+        stopped accepting unicode revids (bug #175228)
+
+
+1.1.1  [24jan2007]
+------------------
+
+    - fix broken inventory page (oops!)
+
+    - fix a few rendering problems with kid and safari
+
+
+1.1  [20jan2007]
+----------------
+
+    - new feature to compare two revisions to each other
+
+    - inserted text in diffs is now blue instead of green
+
+    - fixed to start and stop as a daemon now (use "-f" to run in the
+      foreground), and all config is in loggerhead.conf (no need to mess with
+      dev.cfg)
+
+    - renamed show/hide javascript buttons to expand/collapse, and made them
+      much faster
+
+    - added an atom-feed link to each branch on the browse page [elliot
+      murphy]
+
+    - auto-publish feature for multiple branches under a single folder (see
+      loggerhead.conf.example)
+
+    - added the ability to share cache files per-project instead of just
+      per-branch
+
+    - added side-by-side diff display for the revision page (which is the
+      default), with a button to switch between side-by-side and unified diff
+      format
+
+    - made caching use file locking, and close cleanly on shutdown
+
+    - miscellaneous speed and page-size improvements
+
+
+1.0  [23dec2006]
+----------------
+
+    - initial release
+

=== modified file 'README.txt'
--- README.txt	2006-12-23 19:34:20 +0000
+++ README.txt	2008-06-23 02:37:05 +0000
@@ -1,59 +1,104 @@
 LOGGERHEAD
 ==========
 
-[ version 1.0 for bazaar 0.13 ]
-
-Loggerhead is a web viewer for bazaar branches.  It can be used to navigate
-a branch history, annotate files, perform searches... all the usual things.
-
-This is a TurboGears (http://www.turbogears.org) project.  It can be
-started by running the 'start-loggerhead.py' script.
-
-If you're not familiar with turbogears, the easiest way to get this script
-started is to run it via::
-
-    $ nohup ./start-loggerhead.py &
-    
-and add the following lines to your apache configuration::
+[ Version 1.6 for Bazaar 1.6 ]
+
+Loggerhead is a web viewer for Bazaar branches.  It can be used to
+navigate a branch history, annotate files, perform searches... all the
+usual things.
+
+
+GETTING STARTED
+---------------
+
+Loggerhead depends on SimpleTAL for templating and Paste for the
+server.  So you need these installed -- on Ubuntu you want the
+'python-simpletal' and 'python-paste' packages installed.  You need
+version 1.2 or newer of Paste.
+
+Then simply run the 'serve-branches.py' with the branch you want to
+serve on the command line:
+
+    ./serve-branches.py ~/path/to/branch
+
+The script listens on port 8080 so head to http://localhost:8080/ in
+your browser to see the branch.  You can also pass a directory that
+contains branches to the script, and it will serve a very simple
+directory listing at other pages.
+
+You may update the Bazaar branches being viewed at any time.
+Loggerhead will notice and refresh, and Bazaar uses its own branch
+locking to prevent corruption.
+
+
+USING A CONFIG FILE
+-------------------
+
+Previous versions of Loggerhead read their configuration from a config
+file.  This mode of operation is still supported by the
+'start-loggerhead.py' script.  A 'loggerhead.conf.example' file is
+included in the source which has comments explaining the various
+options.
+
+Loggerhead can then be started by running::
+
+    $ ./start-loggerhead.py
+
+This will run loggerhead in the background, listening on port 8080 by
+default.
+
+To stop Loggerhead, run::
+
+    $ ./stop-loggerhead.py
+
+In the configuration file you can configure projects, and branches per
+project.  The idea is that you could be publishing several (possibly
+unrelated) projects through the same loggerhead instance, and several
+branches for the same project.  See the "loggerhead.conf.example" file
+included with the source.
+
+A debug and access log are stored in the logs/ folder, relative to
+the location of the start-loggerhead.py script.
+
+
+SERVING LOGGERHEAD FROM BEHIND APACHE
+-------------------------------------
+
+If you want to view Bazaar branches from your existing Apache
+installation, you'll need to configure Apache to proxy certain
+requests to Loggerhead.  Adding lines like this to you Apache
+configuration is one way to do this::
 
     <Location "/branches/">
         ProxyPass http://127.0.0.1:8080/
         ProxyPassReverse http://127.0.0.1:8080/
     </Location>
-    
-The port configuration is in "dev.cfg".
-
-The config file is "loggerhead.conf".  In there, you can configure projects,
-and branches per project.  The idea is that you could be publishing several
-(possibly unrelated) projects through the same loggerhead instance, and 
-several branches for the same project.
-
-
-CACHES
-------
-
-To speed up most operations, loggerhead will start creating two caches per
-branch when it first launches:
-
-    - a revision data cache
-    - a text searching cache
-
-You can put the cache folder anywhere, but I find that a folder under
-the branch's .bzr/ folder is the simplest place.
-
-The caches for a branch with 10,000 revisions take about 15 minutes each
-on my machine, but YMMV.  Once they are built, they update every six hours
-or so but usually finish quickly (or instantly) after the initial creation.
-Until the revision cache is built, all operations will be slow.
-
-You may update the bazaar branch at any time (for example, from a cron).
-Loggerhead will notice and refresh, and bazaar uses its own branch locking
-to prevent corruption.
+
+If Paste Deploy is installed, the 'serve-branches.py' script can be
+run behind a proxy at the root of a site, but if you're running it at
+some path into the site, you'll need to add a 'prefix' argument to the
+PrefixMiddleware call in the script.  More flexible configuration
+should be added soon...
+
+
+FILES CHANGED CACHE
+-------------------
+
+To speed up the display of the changelog view for large trees,
+loggerhead can be configured to cache the files changes between
+revisions.  Set the 'cachepath' value in the config file.
 
 
 SUPPORT
 -------
 
-This is loosely based on bazaar-webserve, which was loosely based on hgweb.
-Discussion should take place on the bazaar-dev mailing list.
-
+Loggerhead is loosely based on bazaar-webserve, which was loosely
+based on hgweb.  Discussion should take place on the bazaar-dev
+mailing list at bazaar@lists.canonical.com.  You can join the list at
+<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
+subscribe to post, but your first post will be held briefly for manual
+moderation.
+
+Bugs are tracked on Launchpad; start at:
+
+    https://bugs.launchpad.net/loggerhead

=== removed file 'dev.cfg'
--- dev.cfg	2006-12-19 02:19:42 +0000
+++ dev.cfg	1970-01-01 00:00:00 +0000
@@ -1,73 +0,0 @@
-[global]
-# This is where all of your settings go for your development environment
-# Settings that are the same for both development and production
-# (such as template engine, encodings, etc.) all go in 
-# loggerhead/config/app.cfg
-
-# DATABASE
-
-# pick the form for your database
-# sqlobject.dburi="postgres://username@hostname/databasename"
-# sqlobject.dburi="mysql://username:password@hostname:port/databasename"
-# sqlobject.dburi="sqlite:///file_name_and_path"
-
-# If you have sqlite, here's a simple default to get you started
-# in development
-sqlobject.dburi="sqlite://%(current_dir_uri)s/devdata.sqlite"
-
-
-# if you are using a database or table type without transactions
-# (MySQL default, for example), you should turn off transactions
-# by prepending notrans_ on the uri
-# sqlobject.dburi="notrans_mysql://username:password@hostname:port/databasename"
-
-# for Windows users, sqlite URIs look like:
-# sqlobject.dburi="sqlite:///drive_letter:/path/to/file"
-
-# SERVER
-
-# Some server parameters that you may want to tweak
-# server.socket_port=8080
-
-# Enable the debug output at the end on pages.
-# log_debug_info_filter.on = False
-
-#server.environment="development"
-server.environment="production"
-#autoreload.package="loggerhead"
-
-# session_filter.on = True
-
-# Set to True if you'd like to abort execution if a controller gets an
-# unexpected parameter. False by default
-tg.strict_parameters = True
-
-# turn on timer scheduling
-tg.scheduler = True
-
-# LOGGING
-# Logging configuration generally follows the style of the standard
-# Python logging module configuration. Note that when specifying
-# log format messages, you need to use *() for formatting variables.
-# Deployment independent log configuration is in loggerhead/config/log.cfg
-[logging]
-
-[[loggers]]
-[[[loggerhead]]]
-level='DEBUG'
-#qualname='loggerhead'
-handlers=['debug_out']
-
-#[[[allinfo]]]
-#level='INFO'
-#handlers=['debug_out']
-
-[[[access]]]
-level='INFO'
-qualname='turbogears.access'
-handlers=['access_out']
-propagate=0
-
-
-
-

=== removed directory 'homepage'
=== removed directory 'homepage/download'
=== removed file 'homepage/download/loggerhead-1.0-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.0-0.13.tar.gz and homepage/download/loggerhead-1.0-0.13.tar.gz differ
=== removed file 'homepage/index.html'
--- homepage/index.html	2006-12-29 02:24:03 +0000
+++ homepage/index.html	1970-01-01 00:00:00 +0000
@@ -1,58 +0,0 @@
-<html>
-<head>
-    <style type="text/css">
-@import "loggerhead.css";
-    </style>
-</head>
-<body>
-    <img src="loggerhead-logo-medium.png" />
-    
-    <p>
-    Loggerhead is a web viewer for projects in
-    <a href="http://www.bazaar-vcs.org/">bazaar</a>.
-    It can be used to navigate
-    a branch history, annotate files, view patches, perform searches, etc.
-    It's heavily based on 
-    <a href="https://launchpad.net/products/bzr-webserve">bazaar-webserve</a>,
-    which is itself based on
-    <a href="http://www.selenic.com/mercurial/wiki/index.cgi">hgweb</a> for
-    Mercurial.  The primary difference is that loggerhead is built on top of
-    <a href="http://www.turbogears.org/">TurboGears</a>.
-    </p>
-    
-    <p>
-    Loggerhead is released under the GPL license, and is written entirely
-    in python 2.4.
-    </p>
-    
-    <h2> Download </h2>
-    
-	<p>
-	The current version is 1.0-0.13 (meaning 1.0, based on bazaar 0.13),
-	released on 23 Dec 2006 at revision 64.
-    </p>
-    <ul class="downloads">
-    <li> <a href="download/loggerhead-1.0-0.13.tar.gz"> loggerhead-1.0-0.13.tar.gz </a>
-        <br /> <span class="md5"> MD5: 1b68c1dc6e13f9ed8f2b3ff0267cd8d9 </span>
-        </li>
-    </ul>
-    
-    <h2> Development </h2>
-    
-    <ul>
-    <li> project page on launchpad (for bug reports): <br />
-    <a class="link" href="https://launchpad.net/products/loggerhead/"> https://launchpad.net/products/loggerhead/ </a>
-	</li>
-	
-	<li> development branch in bazaar: <br />
-	<a class="link" href="http://www.lag.net/~robey/code/loggerhead/"> http://www.lag.net/~robey/code/loggerhead/ </a>
-	</li>
-	
-	<li> browse the source in loggerview: <br />
-	<a class="link" href="http://www.lag.net/branches/loggerhead/loggerhead_dev/"> http://www.lag.net/branches/loggerhead/loggerhead_dev/ </a>
-	</li>
-	</ul>
-	
-    
-</body>
-</html>

=== removed file 'homepage/loggerhead-background.png'
Binary files homepage/loggerhead-background.png and homepage/loggerhead-background.png differ
=== removed file 'homepage/loggerhead-logo-medium.png'
Binary files homepage/loggerhead-logo-medium.png and homepage/loggerhead-logo-medium.png differ
=== removed file 'homepage/loggerhead.css'
--- homepage/loggerhead.css	2006-12-24 06:54:21 +0000
+++ homepage/loggerhead.css	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-body {
-    background: url("loggerhead-background.png"); 
-    margin: 0px;
-    font-family: "Lucida Grande", Helvetica;
-    line-height: 1.4em;
-}
-img {
-    border: none;
-}
-p,ul {
-    margin-left: 2em;
-    width: 70%;
-}
-
-a {
-    text-decoration: none;
-    color: #204c90;
-}
-a:hover {
-    text-decoration: underline;
-}
-
-h2 {
-    font-size: 100%;
-    margin-left: 2em;
-    margin-right: 2em;
-    margin-top: 1.5em;
-    border-bottom: solid 1px black;
-}
-
-ul {
-    list-style: url(sphere.png);
-}
-ul.downloads .md5 {
-    font-family: monospace;
-    margin-left: 2em;
-}
-li {
-	margin-bottom: 1em;
-}
-
-.link {
-	margin-left: 1em;
-}

=== removed file 'homepage/sphere.png'
Binary files homepage/sphere.png and homepage/sphere.png differ
=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2007-01-02 07:34:15 +0000
+++ loggerhead.conf.example	2008-06-16 09:48:20 +0000
@@ -1,4 +1,13 @@
 
+# use this to change the server's port
+#server.socket_port = 8080
+
+# use this if you're mapping loggerhead within apache via proxy
+#server.webpath = 'http://example.com/branches'
+
+# use this if you want loggerhead to listen to another interface than 127.0.0.1
+# server.socket_host = 'your_hostname_or_ip'
+
 # where's bzrlib?
 # (you only need this if you don't install bzr.)
 #bzrpath = '/Users/robey/code/bzr/bzr'
@@ -6,6 +15,9 @@
 # if you want a special title on the front page, set it here:
 title = 'branches in loggerhead'
 
+# the access and debug logs can be set up to roll 'daily', 'weekly', or 'never':
+log.roll = 'weekly'
+
 # group branches by project:
 [bazaar]
 
@@ -15,8 +27,8 @@
     # for the top browsing page, you can include a description, in raw HTML.
     #description = 'Bazaar is a <i>revision control system</i>.'
 
-    # should we cache revisions and build a text index?  (HIGHLY recommended)
-    # this will be a folder containing a few files.  if the folder doesn't
+    # should we cache files changed? (recommended for large trees)
+    # this will be a folder containing one file.  if the folder doesn't
     # exist, it'll be created.
     #
     # all branches in this project will share the same cache, which is usually

=== modified file 'loggerhead/TODO'
--- loggerhead/TODO	2007-01-02 07:35:34 +0000
+++ loggerhead/TODO	2007-05-21 06:19:31 +0000
@@ -6,7 +6,15 @@
 
 * potentially do a 'bzr pull' on a branch on an interval timer
 
-* it would be cool to view 1 revision relative to another base, and view the
-  diff & download the bundle for that
-
-* maybe change "changes" to "history"?  -- asked on bazaar-dev@ for opinions.
+* browse view: sort by name, last change?
+
+* something is leaking on www.lag.net/branches
+
+* download tar archive of revision?
+
+* nicholas allen suggested the ability to change the # of context lines
+  in diffs (probably something inside bzrlib) and also the ability to see
+  an entire file in diff format
+
+* setup.py install doesn't work
+

=== added directory 'loggerhead/apps'
=== added file 'loggerhead/apps/__init__.py'
--- loggerhead/apps/__init__.py	1970-01-01 00:00:00 +0000
+++ loggerhead/apps/__init__.py	2008-06-18 07:48:17 +0000
@@ -0,0 +1,11 @@
+#
+import os
+
+from paste import urlparser, fileapp
+
+static = os.path.join(
+    os.path.dirname(os.path.dirname(__file__)), 'static')
+
+static_app = urlparser.make_static(None, static)
+
+favicon_app = fileapp.FileApp(os.path.join(static, 'images', 'favicon.ico'))

=== added file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	1970-01-01 00:00:00 +0000
+++ loggerhead/apps/branch.py	2008-06-19 19:28:16 +0000
@@ -0,0 +1,100 @@
+import logging
+import urllib
+
+from paste import request
+from paste import httpexceptions
+from paste.wsgiwrappers import WSGIRequest, WSGIResponse
+
+from loggerhead.apps import static_app
+from loggerhead.changecache import FileChangeCache
+from loggerhead.controllers.changelog_ui import ChangeLogUI
+from loggerhead.controllers.inventory_ui import InventoryUI
+from loggerhead.controllers.annotate_ui import AnnotateUI
+from loggerhead.controllers.revision_ui import RevisionUI
+from loggerhead.controllers.atom_ui import AtomUI
+from loggerhead.controllers.download_ui import DownloadUI
+from loggerhead.controllers.bundle_ui import BundleUI
+from loggerhead.history import History
+from loggerhead import util
+
+logging.basicConfig()
+logging.getLogger().setLevel(logging.DEBUG)
+
+class BranchWSGIApp(object):
+
+    def __init__(self, branch_url, friendly_name=None, config={}):
+        self.branch_url = branch_url
+        self._history = None
+        self._config = config
+        self.friendly_name = friendly_name
+        self.log = logging.getLogger(friendly_name)
+
+    @property
+    def history(self):
+        if (self._history is None) or self._history.out_of_date():
+            self.log.debug('Reload branch history...')
+            _history = self._history = History.from_folder(self.branch_url)
+            cache_path = self._config.get('cachepath', None)
+            if cache_path is not None:
+                _history.use_file_cache(FileChangeCache(_history, cache_path))
+        return self._history
+
+    def url(self, *args, **kw):
+        if isinstance(args[0], list):
+            args = args[0]
+        qs = []
+        for k, v in kw.iteritems():
+            if v is not None:
+                qs.append('%s=%s'%(k, urllib.quote(v)))
+        qs = '&'.join(qs)
+        return request.construct_url(
+            self._environ, script_name=self._url_base,
+            path_info='/'.join(args),
+            querystring=qs)
+
+    def context_url(self, *args, **kw):
+        kw = util.get_context(**kw)
+        return self.url(*args, **kw)
+
+    def static_url(self, path):
+        return self._static_url_base + path
+
+    controllers_dict = {
+        'annotate': AnnotateUI,
+        'changes': ChangeLogUI,
+        'files': InventoryUI,
+        'revision': RevisionUI,
+        'download': DownloadUI,
+        'atom': AtomUI,
+        'bundle': BundleUI,
+        }
+
+    def last_updated(self):
+        h = self.history
+        change = h.get_changes([ h.last_revid ])[0]
+        return change.date
+
+    def branch_url(self):
+        return self.history.get_config().get_user_option('public_branch')
+
+    def app(self, environ, start_response):
+        req = WSGIRequest(environ)
+        response = WSGIResponse()
+        response.headers['Content-Type'] = 'text/plain'
+        self._url_base = environ['SCRIPT_NAME']
+        self._static_url_base = environ.get('loggerhead.static.url')
+        if self._static_url_base is None:
+            self._static_url_base = self._url_base
+        self._environ = environ
+        path = request.path_info_pop(environ)
+        if not path:
+            raise httpexceptions.HTTPMovedPermanently(
+                self._url_base + '/changes')
+        if path == 'static':
+            return static_app(environ, start_response)
+        cls = self.controllers_dict.get(path)
+        if cls is None:
+            raise httpexceptions.HTTPNotFound()
+        c = cls(self)
+        c.default(req, response)
+        return response(environ, start_response)

=== added file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	1970-01-01 00:00:00 +0000
+++ loggerhead/apps/config.py	2008-06-23 01:03:34 +0000
@@ -0,0 +1,164 @@
+# A server that recreates (modulo cherrypy bugs :) the url parsing
+# from the old, loggerhead.conf approach.
+
+# It's all a bit horrible really.
+
+import logging
+import os
+import posixpath
+
+from configobj import ConfigObj
+
+from paste.request import path_info_pop
+from paste import httpexceptions
+from paste.wsgiwrappers import WSGIResponse
+
+from loggerhead.apps.branch import BranchWSGIApp
+from loggerhead.apps import favicon_app, static_app
+from loggerhead.templatefunctions import templatefunctions
+from loggerhead.zptsupport import load_template
+from loggerhead import util
+
+log = logging.getLogger("loggerhead.controllers")
+
+from loggerhead.history import is_branch
+
+class Project (object):
+    def __init__(self, name, config, root_config):
+        self.name = name
+        self.friendly_name = config.get('name', name)
+        self.description = config.get('description', '')
+        self.long_description = config.get('long_description', '')
+        self._config = config
+        self._root_config = root_config
+
+        self.views = []
+        self.views_by_name = {}
+        for view_name in config.sections:
+            log.debug('Configuring (project %s) branch %s...', name, view_name)
+            self._add_view(
+                view_name, config[view_name], config[view_name].get('folder'))
+
+        self._auto_folder = config.get('auto_publish_folder', None)
+        self._auto_list = []
+        if self._auto_folder is not None:
+            self._recheck_auto_folders()
+
+    def _recheck_auto_folders(self):
+        if self._auto_folder is None:
+            return
+        auto_list = []
+        # scan a folder for bazaar branches, and add them automatically
+        for path, folders, filenames in os.walk(self._auto_folder):
+            for folder in folders:
+                folder = os.path.join(path, folder)
+                if is_branch(folder):
+                    auto_list.append(folder)
+        auto_list.sort()
+        if auto_list == self._auto_list:
+            # nothing has changed; do nothing.
+            return
+
+        # rebuild views:
+        log.debug('Rescanning auto-folder for project %s ...', self.name)
+        self._views = []
+        for folder in auto_list:
+            view_name = os.path.basename(folder)
+            log.debug('Auto-configuring (project %s) branch %s...', self.name, view_name)
+            self._add_view(view_name, ConfigObj(), folder)
+        self._auto_list = auto_list
+
+    def _get_branch_url(self, view, view_config, folder):
+        url = view_config.get('url', None)
+        if url is not None:
+            return url
+        url = self._config.get('url_prefix', None)
+        if url is not None:
+            return posixpath.join(url, folder) + '/'
+        return None
+
+    def _get_description(self, view, view_config):
+        description = view_config.get('description', None)
+        if description is not None:
+            return description
+        description = view.history._branch.get_config().get_user_option('description')
+        return description
+
+    def _add_view(self, view_name, view_config, folder):
+        view = BranchWSGIApp(folder, view_name, view_config)
+        friendly_name = view_config.get('branch_name', None)
+        if friendly_name is None:
+            friendly_name = view.history.get_config().get_nickname()
+            if friendly_name is None:
+                friendly_name = view_name
+        view.friendly_name = friendly_name
+        view.name = view_name
+        branch_url = self._get_branch_url(view, view_config, view_name)
+        if branch_url is not None:
+            view.branch_url = branch_url
+        view.description = self._get_description(view, view_config)
+        view._src_folder = folder
+        view._view_config = view_config
+        self.views.append(view)
+        self.views_by_name[view_name] = view
+
+    def call(self, environ, start_response):
+        segment = path_info_pop(environ)
+        if not segment:
+            raise httpexceptions.HTTPNotFound()
+        else:
+            view = self.views_by_name.get(segment)
+            if view is None:
+                raise httpexceptions.HTTPNotFound()
+            return view.app(environ, start_response)
+
+
+class Root(object):
+
+    def __init__(self, config):
+        self.projects = []
+        self.config = config
+        self.projects_by_name = {}
+        for project_name in self.config.sections:
+            project = Project(
+                project_name, self.config[project_name], self.config)
+            self.projects.append(project)
+            self.projects_by_name[project_name] = project
+
+    def browse(self, response):
+        for p in self.projects:
+            p._recheck_auto_folders()
+        class branch:
+            @staticmethod
+            def static_url(path):
+                return self._static_url_base + path
+        vals = {
+            'projects': self.projects,
+            'util': util,
+            'title': self.config.get('title', None),
+            'branch': branch,
+        }
+        vals.update(templatefunctions)
+        response.headers['Content-Type'] = 'text/html'
+        template = load_template('loggerhead.templates.browse')
+        template.expand_into(response, **vals)
+
+    def __call__(self, environ, start_response):
+        self._static_url_base = environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
+        segment = path_info_pop(environ)
+        if segment is None:
+            raise httpexceptions.HTTPMovedPermanently(
+                environ['SCRIPT_NAME'] + '/')
+        elif segment == '':
+            response = WSGIResponse()
+            self.browse(response)
+            return response(environ, start_response)
+        elif segment == 'static':
+            return static_app(environ, start_response)
+        elif segment == 'favicon.ico':
+            return favicon_app(environ, start_response)
+        else:
+            project = self.projects_by_name.get(segment)
+            if project is None:
+                raise httpexceptions.HTTPNotFound()
+            return project.call(environ, start_response)

=== added file 'loggerhead/apps/filesystem.py'
--- loggerhead/apps/filesystem.py	1970-01-01 00:00:00 +0000
+++ loggerhead/apps/filesystem.py	2008-06-18 12:27:04 +0000
@@ -0,0 +1,82 @@
+import cgi
+import os
+import tempfile
+
+from bzrlib import branch, errors
+
+from paste.request import path_info_pop
+from paste.wsgiwrappers import WSGIRequest, WSGIResponse
+from paste import httpexceptions
+
+from loggerhead.apps.branch import BranchWSGIApp
+from loggerhead.apps import favicon_app, static_app
+
+
+sql_dir = tempfile.mkdtemp()
+
+class BranchesFromFileSystemServer(object):
+    def __init__(self, folder, root):
+        self.folder = folder
+        self.root = root
+
+    def directory_listing(self, path, environ, start_response):
+        request = WSGIRequest(environ)
+        response = WSGIResponse()
+        listing = [d for d in os.listdir(path) if not d.startswith('.')]
+        response.headers['Content-Type'] = 'text/html'
+        print >> response, '<html><body>'
+        for d in sorted(listing):
+            if os.path.isdir(os.path.join(path, d)):
+                d = cgi.escape(d)
+                print >> response, '<li><a href="%s/">%s</a></li>' % (d, d)
+        print >> response, '</body></html>'
+        return response(environ, start_response)
+
+    def app_for_branch(self, b, path):
+        if not self.folder:
+            name = os.path.basename(os.path.abspath(path))
+        else:
+            name = self.folder
+        h = BranchWSGIApp(path, name, {'cachepath': sql_dir})
+        self.root.cache[path] = h
+        return h.app
+
+    def __call__(self, environ, start_response):
+        path = os.path.join(self.root.folder, self.folder)
+        if not os.path.isdir(path):
+            raise httpexceptions.HTTPNotFound()
+        cached = self.root.cache.get(path)
+        if cached is not None:
+            return cached.app(environ, start_response)
+        try:
+            b = branch.Branch.open(path)
+        except errors.NotBranchError:
+            segment = path_info_pop(environ)
+            if segment is None:
+                raise httpexceptions.HTTPMovedPermanently(
+                    environ['SCRIPT_NAME'] + '/')
+            elif segment == '':
+                return self.directory_listing(path, environ, start_response)
+            else:
+                relpath = os.path.join(self.folder, segment)
+                return BranchesFromFileSystemServer(relpath, self.root)(
+                    environ, start_response)
+        else:
+            return self.app_for_branch(b, path)(environ, start_response)
+
+
+class BranchesFromFileSystemRoot(object):
+    def __init__(self, folder):
+        self.cache = {}
+        self.folder = folder
+    def __call__(self, environ, start_response):
+        environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
+        if environ['PATH_INFO'].startswith('/static/'):
+            segment = path_info_pop(environ)
+            assert segment == 'static'
+            return static_app(environ, start_response)
+        elif environ['PATH_INFO'] == '/favicon.ico':
+            return favicon_app(environ, start_response)
+        else:
+            return BranchesFromFileSystemServer(
+                '', self)(environ, start_response)

=== removed file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2007-01-02 07:17:25 +0000
+++ loggerhead/branchview.py	1970-01-01 00:00:00 +0000
@@ -1,168 +0,0 @@
-#
-# Copyright (C) 2006  Robey Pointer <robey@lag.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""
-collection of configuration and objects related to a bazaar branch.
-"""
-
-import logging
-import posixpath
-import threading
-
-import turbogears
-from cherrypy import HTTPRedirect
-
-from loggerhead import util
-from loggerhead.changecache import ChangeCache
-from loggerhead.history import History
-from loggerhead.textindex import TextIndex
-from loggerhead.controllers.changelog_ui import ChangeLogUI
-from loggerhead.controllers.atom_ui import AtomUI
-from loggerhead.controllers.revision_ui import RevisionUI
-from loggerhead.controllers.inventory_ui import InventoryUI
-from loggerhead.controllers.annotate_ui import AnnotateUI
-from loggerhead.controllers.download_ui import DownloadUI
-from loggerhead.controllers.bundle_ui import BundleUI
-
-
-with_history_lock = util.with_lock('_history_lock', 'History')
-
-
-class BranchView (object):
-    def __init__(self, group_name, name, subfolder, absfolder, config, project_config):
-        self._group_name = group_name
-        self._name = name
-        self._folder = subfolder
-        self._absfolder = absfolder
-        self._config = config
-        self._project_config = project_config
-        self.log = logging.getLogger('loggerhead.%s' % (name,))
-        
-        # branch history
-        self._history_lock = threading.RLock()
-        self._history = None
-        self._closed = False
-        
-        self.changes = ChangeLogUI(self)
-        self.revision = RevisionUI(self)
-        self.files = InventoryUI(self)
-        self.annotate = AnnotateUI(self)
-        self.download = DownloadUI(self)
-        self.atom = AtomUI(self)
-        self.bundle = BundleUI(self)
-        
-        # force history object to be loaded:
-        self.get_history()
-        
-        turbogears.startup.call_on_shutdown.append(self.close)
-    
-    @with_history_lock
-    def close(self):
-        # it's important that we cleanly detach the history, so the cache
-        # files can be closed correctly and hopefully remain uncorrupted.
-        # this should also stop any ongoing indexing.
-        self._history.detach()
-        self._history = None
-        self._closed = True
-            
-    config = property(lambda self: self._config)
-    
-    name = property(lambda self: self._name)
-
-    group_name = property(lambda self: self._group_name)
-    
-    def _get_friendly_name(self):
-        name = self._config.get('branch_name', None)
-        if name is not None:
-            return name
-        # try branch-specific config?
-        name = self.get_history().get_config().get_nickname()
-        if name is not None:
-            return name
-        return self._name
-
-    friendly_name = property(_get_friendly_name)
-
-    def _get_description(self):
-        description = self._config.get('description', None)
-        if description is not None:
-            return description
-        # try branch-specific config?
-        description = self.get_history().get_config().get_user_option('description')
-        return description
-        
-    description = property(_get_description)
-    
-    def _get_branch_url(self):
-        url = self._config.get('url', None)
-        if url is not None:
-            return url
-        # try to assemble one from the project, if an url_prefix was defined.
-        url = self._project_config.get('url_prefix', None)
-        if url is not None:
-            return posixpath.join(url, self._folder) + '/'
-        # try branch-specific config?
-        url = self.get_history().get_config().get_user_option('public_url')
-        return url
-        
-    branch_url = property(_get_branch_url)
-    
-    @turbogears.expose()
-    def index(self):
-        raise HTTPRedirect(self.url('/changes'))
-
-    @with_history_lock
-    def get_history(self):
-        """
-        get an up-to-date History object, safely.  each page-view calls this
-        method, and normally it will get the same History object as on previous
-        calls.  but if the bazaar branch on-disk has been updated since this
-        History was created, a new object will be created and returned.
-        """
-        if self._closed:
-            return None
-        if (self._history is None) or self._history.out_of_date():
-            self.log.debug('Reload branch history...')
-            if self._history is not None:
-                self._history.detach()
-            self._history = History.from_folder(self._absfolder, self._name)
-            cache_path = self._config.get('cachepath', None)
-            if cache_path is None:
-                # try the project config
-                cache_path = self._project_config.get('cachepath', None)
-            if cache_path is not None:
-                self._history.use_cache(ChangeCache(self._history, cache_path))
-                self._history.use_search_index(TextIndex(self._history, cache_path))
-        return self._history
-    
-    def check_rebuild(self):
-        h = self.get_history()
-        if h is not None:
-            h.check_rebuild()
-    
-    def url(self, elements, **kw):
-        if not isinstance(elements, list):
-            elements = [elements]
-        if elements[0].startswith('/'):
-            elements[0] = elements[0][1:]
-        return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
-
-    def last_updated(self):
-        h = self.get_history()
-        change = h.get_changes([ h.last_revid ])[0]
-        return change.date

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2007-01-02 07:14:03 +0000
+++ loggerhead/changecache.py	2008-06-16 09:51:29 +0000
@@ -25,149 +25,97 @@
 cached a change, it's good forever.
 """
 
-import logging
+import cPickle
 import os
-import shelve
-import threading
-import time
 
 from loggerhead import util
-from loggerhead.util import decorator
 from loggerhead.lockfile import LockFile
 
 
 with_lock = util.with_lock('_lock', 'ChangeCache')
-        
-
-class ChangeCache (object):
-    
+
+SQLITE_INTERFACE = os.environ.get('SQLITE_INTERFACE', 'sqlite')
+
+if SQLITE_INTERFACE == 'pysqlite2':
+    from pysqlite2 import dbapi2
+    _param_marker = '?'
+elif SQLITE_INTERFACE == 'sqlite':
+    import sqlite as dbapi2
+    _param_marker = '%s'
+else:
+    raise AssertionError("bad sqlite interface %r!?"%SQLITE_INTERFACE)
+
+_select_stmt = ("select data from revisiondata where revid = ?"
+                ).replace('?', _param_marker)
+_insert_stmt = ("insert into revisiondata (revid, data) "
+                "values (?, ?)").replace('?', _param_marker)
+
+
+
+
+class FakeShelf(object):
+    def __init__(self, filename):
+        create_table = not os.path.exists(filename)
+        self.connection = dbapi2.connect(filename)
+        self.cursor = self.connection.cursor()
+        if create_table:
+            self._create_table()
+    def _create_table(self):
+        self.cursor.execute(
+            "create table RevisionData "
+            "(revid binary primary key, data binary)")
+        self.connection.commit()
+    def _serialize(self, obj):
+        r = dbapi2.Binary(cPickle.dumps(obj, protocol=2))
+        return r
+    def _unserialize(self, data):
+        return cPickle.loads(str(data))
+    def get(self, revid):
+        self.cursor.execute(_select_stmt, (revid,))
+        filechange = self.cursor.fetchone()
+        if filechange is None:
+            return None
+        else:
+            return self._unserialize(filechange[0])
+    def add(self, revid_obj_pairs):
+        for  (r, d) in revid_obj_pairs:
+            self.cursor.execute(_insert_stmt, (r, self._serialize(d)))
+        self.connection.commit()
+
+
+class FileChangeCache(object):
     def __init__(self, history, cache_path):
         self.history = history
-        self.log = history.log
-        
+
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
 
-        # keep a separate cache for the diffs, because they're very time-consuming to fetch.
-        self._changes_filename = os.path.join(cache_path, 'changes')
-        self._changes_diffs_filename = os.path.join(cache_path, 'changes-diffs')
-        
-        # use a lockfile since the cache folder could be shared across different processes.
-        self._lock = LockFile(os.path.join(cache_path, 'lock'))
-        self._closed = False
-        
-        s1, s2 = self.sizes()
-        self.log.info('Using change cache %s; %d/%d entries.' % (cache_path, s1, s2))
-    
-    @with_lock
-    def close(self):
-        self.log.debug('Closing cache file.')
-        self._closed = True
-    
-    @with_lock
-    def closed(self):
-        return self._closed
-
-    @with_lock
-    def flush(self):
-        pass
-    
-    @with_lock
-    def get_changes(self, revid_list, get_diffs=False):
-        """
-        get a list of changes by their revision_ids.  any changes missing
-        from the cache are fetched by calling L{History.get_change_uncached}
-        and inserted into the cache before returning.
-        """
-        if get_diffs:
-            cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
-        else:
-            cache = shelve.open(self._changes_filename, 'c', protocol=2)
-
+        self._changes_filename = os.path.join(cache_path, 'filechanges.sql')
+
+        # use a lockfile since the cache folder could be shared across
+        # different processes.
+        self._lock = LockFile(os.path.join(cache_path, 'filechange-lock'))
+
+    @with_lock
+    def get_file_changes(self, entries):
         out = []
-        fetch_list = []
-        sfetch_list = []
-        for revid in revid_list:
-            # if the revid is in unicode, use the utf-8 encoding as the key
-            srevid = util.to_utf8(revid)
-            
-            if srevid in cache:
-                out.append(cache[srevid])
+        missing_entries = []
+        missing_entry_indices = []
+        cache = FakeShelf(self._changes_filename)
+        for entry in entries:
+            changes = cache.get(entry.revid)
+            if changes is not None:
+                out.append(changes)
             else:
-                #self.log.debug('Entry cache miss: %r' % (revid,))
+                missing_entries.append(entry)
+                missing_entry_indices.append(len(out))
                 out.append(None)
-                fetch_list.append(revid)
-                sfetch_list.append(srevid)
-        
-        if len(fetch_list) > 0:
-            # some revisions weren't in the cache; fetch them
-            changes = self.history.get_changes_uncached(fetch_list, get_diffs)
-            if changes is None:
-                return changes
-            for i in xrange(len(revid_list)):
-                if out[i] is None:
-                    cache[sfetch_list.pop(0)] = out[i] = changes.pop(0)
-        
-        cache.close()
+        if missing_entries:
+            missing_changes = self.history.get_file_changes_uncached(missing_entries)
+            revid_changes_pairs = []
+            for i, entry, changes in zip(
+                missing_entry_indices, missing_entries, missing_changes):
+                revid_changes_pairs.append((entry.revid, changes))
+                out[i] = changes
+            cache.add(revid_changes_pairs)
         return out
-    
-    @with_lock
-    def full(self, get_diffs=False):
-        if get_diffs:
-            cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
-        else:
-            cache = shelve.open(self._changes_filename, 'c', protocol=2)
-        try:
-            return (len(cache) >= len(self.history.get_revision_history())) and (util.to_utf8(self.history.last_revid) in cache)
-        finally:
-            cache.close()
-
-    @with_lock
-    def sizes(self):
-        cache = shelve.open(self._changes_filename, 'c', protocol=2)
-        s1 = len(cache)
-        cache.close()
-        cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
-        s2 = len(cache)
-        cache.close()
-        return s1, s2
-        
-    def check_rebuild(self, max_time=3600):
-        """
-        check if we need to fill in any missing pieces of the cache.  pull in
-        any missing changes, but don't work any longer than C{max_time}
-        seconds.
-        """
-        if self.closed() or self.full():
-            return
-        
-        self.log.info('Building revision cache...')
-        start_time = time.time()
-        last_update = time.time()
-        count = 0
-
-        work = list(self.history.get_revision_history())
-        jump = 100
-        for i in xrange(0, len(work), jump):
-            r = work[i:i + jump]
-            # must call into history so we grab the branch lock (otherwise, lock inversion)
-            self.history.get_changes(r)
-            if self.closed():
-                self.flush()
-                return
-            count += jump
-            now = time.time()
-            if now - start_time > max_time:
-                self.log.info('Cache rebuilding will pause for now.')
-                self.flush()
-                return
-            if now - last_update > 60:
-                self.log.info('Revision cache rebuilding continues: %d/%d' % (min(count, len(work)), len(work)))
-                last_update = time.time()
-                self.flush()
-            # give someone else a chance at the lock
-            time.sleep(1)
-        self.log.info('Revision cache rebuild completed.')
-        self.flush()
-
-

=== removed directory 'loggerhead/config'
=== removed file 'loggerhead/config/__init__.py'
=== removed file 'loggerhead/config/app.cfg'
--- loggerhead/config/app.cfg	2006-12-11 06:44:19 +0000
+++ loggerhead/config/app.cfg	1970-01-01 00:00:00 +0000
@@ -1,42 +0,0 @@
-[global]
-# The settings in this file should not vary depending on the deployment
-# environment. dev.cfg and prod.cfg are the locations for
-# the different deployment settings. Settings in this file will
-# be overridden by settings in those other files.
-
-# The commented out values below are the defaults
-
-# VIEW
-
-# which view (template engine) to use if one is not specified in the
-# template name
-# tg.defaultview = "kid"
-
-# The following kid settings determine the settings used by the kid serializer.
-
-# One of (html|xml|json)
-# kid.outputformat="html"
-
-# kid.encoding="utf-8"
-
-# The sitetemplate is used for overall styling of a site that
-# includes multiple TurboGears applications
-# tg.sitetemplate="<packagename.templates.templatename>"
-
-# Allow every exposed function to be called as json,
-# tg.allow_json = False
-
-# List of Widgets to include on every page.
-# for exemple ['turbogears.mochikit']
-# tg.include_widgets = []
-
-# Set to True if the scheduler should be started
-# tg.scheduler = False
-
-[/static]
-static_filter.on = True
-static_filter.dir = "%(top_level_dir)s/static"
-
-[/favicon.ico]
-static_filter.on = True
-static_filter.file = "%(top_level_dir)s/static/images/favicon.ico"

=== removed file 'loggerhead/config/log.cfg'
--- loggerhead/config/log.cfg	2006-12-11 06:44:19 +0000
+++ loggerhead/config/log.cfg	1970-01-01 00:00:00 +0000
@@ -1,29 +0,0 @@
-# LOGGING
-# Logging is often deployment specific, but some handlers and
-# formatters can be defined here.
-
-[logging]
-[[formatters]]
-[[[message_only]]]
-format='*(message)s'
-
-[[[full_content]]]
-format='*(asctime)s *(name)s *(levelname)s *(message)s'
-
-[[handlers]]
-[[[debug_out]]]
-class='StreamHandler'
-level='DEBUG'
-args='(sys.stdout,)'
-formatter='full_content'
-
-[[[access_out]]]
-class='StreamHandler'
-level='INFO'
-args='(sys.stdout,)'
-formatter='message_only'
-
-[[[error_out]]]
-class='StreamHandler'
-level='ERROR'
-args='(sys.stdout,)'

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2007-01-03 00:18:09 +0000
+++ loggerhead/controllers/__init__.py	2008-06-19 01:18:01 +0000
@@ -15,110 +15,54 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
 
-import logging
-import os
-import re
-import sys
 import time
 
-from configobj import ConfigObj
-
-import turbogears
-from turbogears import controllers
-from cherrypy import HTTPRedirect, NotFound
-
-my_config = ConfigObj('loggerhead.conf', encoding='utf-8')
-extra_path = my_config.get('bzrpath', None)
-if extra_path:
-    sys.path.insert(0, extra_path)
+from paste.request import path_info_pop
 
 from loggerhead import util
-from loggerhead.branchview import BranchView
-from loggerhead.history import History, is_branch
-
-log = logging.getLogger("loggerhead.controllers")
-
-
-def cherrypy_friendly(s):
-    """
-    convert a config section name into a name that pleases cherrypy.
-    """
-    return re.sub(r'[^\w\d_]', '_', s)
-
-
-class Project (object):
-    def __init__(self, name, config):
-        self.name = name
-        self.friendly_name = config.get('name', name)
-        self.description = config.get('description', '')
-        self.long_description = config.get('long_description', '')
-        self._config = config
-        
-        self._views = []
-        for view_name in config.sections:
-            log.debug('Configuring (project %r) branch %r...', name, view_name)
-            self._add_view(view_name, config[view_name], config[view_name].get('folder'))
-        
-        auto_folder = config.get('auto_publish_folder', None)
-        if auto_folder is not None:
-            auto_list = []
-            # scan a folder for bazaar branches, and add them automatically
-            for path, folders, filenames in os.walk(auto_folder):
-                for folder in folders:
-                    folder = os.path.join(path, folder)
-                    if is_branch(folder):
-                        auto_list.append(folder)
-            auto_list.sort()
-            for folder in auto_list:
-                view_name = os.path.basename(folder)
-                log.debug('Auto-configuring (project %r) branch %r...', name, view_name)
-                self._add_view(view_name, ConfigObj(), folder)
-    
-    def _add_view(self, view_name, view_config, folder):
-        c_view_name = cherrypy_friendly(view_name)
-        view = BranchView(self.name, c_view_name, view_name, folder, view_config, self._config)
-        self._views.append(view)
-        setattr(self, c_view_name, view)
-        
-    views = property(lambda self: self._views)
-
-
-class Root (controllers.RootController):
-    def __init__(self):
-        global my_config
-        self._projects = []
-        for project_name in my_config.sections:
-            c_project_name = cherrypy_friendly(project_name)
-            project = Project(c_project_name, my_config[project_name])
-            self._projects.append(project)
-            setattr(self, c_project_name, project)
-        
-    @turbogears.expose(template='loggerhead.templates.browse')
-    def index(self):
-        return {
-            'projects': self._projects,
-            'util': util,
-            'title': my_config.get('title', ''),
-        }
-
-    def _check_rebuild(self):
-        for p in self._projects:
-            for v in p.views:
-                v.check_rebuild()
-
-
-# singleton:
-Root = Root()
-
-# re-index every 6 hours
-index_freq = 6 * 3600
-
-turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
-
-# for use in profiling the very-slow get_change() method:
-#h = util.get_history()
-#w = list(h.get_revision_history())
-#h._get_changes_profiled(w[:100])
+from loggerhead.templatefunctions import templatefunctions
+from loggerhead.zptsupport import load_template
+
+class TemplatedBranchView(object):
+
+    template_path = None
+
+    def __init__(self, branch):
+        self._branch = branch
+        self.log = branch.log
+
+    def default(self, request, response):
+        z = time.time()
+        h = self._branch.history
+        kw = request.GET
+        util.set_context(kw)
+
+        h._branch.lock_read()
+        try:
+            args = []
+            while 1:
+                arg = path_info_pop(request.environ)
+                if arg is None:
+                    break
+                args.append(arg)
+
+            vals = {
+                'branch': self._branch,
+                'util': util,
+                'history': h,
+                'url': self._branch.context_url,
+            }
+            vals.update(templatefunctions)
+            del response.headers['Content-Type']
+            vals.update(self.get_values(h, args, kw, response))
+
+            self.log.info('/%s: %r secs' % (
+                self.__class__.__name__, time.time() - z,))
+            if 'Content-Type' not in response.headers:
+                response.headers['Content-Type'] = 'text/html'
+            template = load_template(self.template_path)
+            template.expand_into(response, **vals)
+        finally:
+            h._branch.unlock()
 

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2006-12-20 09:29:42 +0000
+++ loggerhead/controllers/annotate_ui.py	2008-06-18 12:27:04 +0000
@@ -17,74 +17,58 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import datetime
-import logging
 import os
 import posixpath
-import textwrap
-import time
-
-import turbogears
-from cherrypy import HTTPRedirect, session
-
+
+from paste.httpexceptions import HTTPBadRequest
+
+from loggerhead.controllers import TemplatedBranchView
 from loggerhead import util
 
 
-log = logging.getLogger("loggerhead.controllers")
-
 def dirname(path):
     while path.endswith('/'):
         path = path[:-1]
     path = posixpath.dirname(path)
     return path
 
-        
-class AnnotateUI (object):
-
-    def __init__(self, branch):
-        # BranchView object
-        self._branch = branch
-        self.log = branch.log
-
-    @turbogears.expose(html='loggerhead.templates.annotate')
-    def default(self, *args, **kw):
-        z = time.time()
-        h = self._branch.get_history()
-        
+
+class AnnotateUI (TemplatedBranchView):
+
+    template_path = 'loggerhead.templates.annotate'
+
+    def get_values(self, h, args, kw, response):
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
-            revid = None
-        
+            revid = h.last_revid
+
+        path = None
+        if len(args) > 1:
+            path = '/'.join(args[1:])
+            if not path.startswith('/'):
+                path = '/' + path
+
         file_id = kw.get('file_id', None)
+        if (file_id is None) and (path is None):
+            raise HTTPBadRequest('No file_id or filename provided to annotate')
+
         if file_id is None:
-            raise HTTPRedirect(self._branch.url('/changes'))
+            file_id = h.get_file_id(revid, path)
 
-        try:
-            revid_list, revid = h.get_file_view(revid, file_id)
-        except Exception, x:
-            self.log.error('Exception fetching changes: %s' % (x,))
-            util.log_exception(self.log)
-            raise HTTPRedirect(self._branch.url('/changes'))
-            
         # no navbar for revisions
         navigation = util.Container()
-        
-        path = h.get_path(revid, file_id)
+
+        if path is None:
+            path = h.get_path(revid, file_id)
         filename = os.path.basename(path)
 
-        vals = {
-            'branch': self._branch,
-            'util': util,
+        return {
             'revid': revid,
             'file_id': file_id,
             'path': path,
             'filename': filename,
-            'history': h,
             'navigation': navigation,
             'change': h.get_changes([ revid ])[0],
             'contents': list(h.annotate_file(file_id, revid)),
         }
-        h.flush_cache()
-        self.log.info('/annotate: %r secs' % (time.time() - z,))
-        return vals

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2006-12-20 21:17:53 +0000
+++ loggerhead/controllers/atom_ui.py	2008-06-19 19:28:10 +0000
@@ -17,35 +17,23 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import cherrypy
-import turbogears
-
-from loggerhead import util
-
-
-class AtomUI (object):
-    
-    def __init__(self, branch):
-        # BranchView object
-        self._branch = branch
-        self.log = branch.log
-
-    @turbogears.expose(template='loggerhead.templates.atom', format="xml", content_type="application/atom+xml")
-    def default(self, *args):
-        h = self._branch.get_history()
-        pagesize = int(self._branch.config.get('pagesize', '20'))
-
-        revid_list, start_revid = h.get_file_view(None, None)
+from loggerhead.controllers import TemplatedBranchView
+
+
+class AtomUI (TemplatedBranchView):
+
+    template_path = 'loggerhead.templates.atom'
+
+    def get_values(self, h, args, kw, response):
+        h = self._branch.history
+
+        pagesize = int(20)#self._branch.config.get('pagesize', '20'))
+
+        revid_list = h.get_file_view(h.last_revid, None)
         entries = list(h.get_changes(list(revid_list)[:pagesize]))
 
-        vals = {
-            'external_url': cherrypy.request.base,
-            'branch': self._branch,
+        response.headers['Content-Type'] = 'application/atom+xml'
+        return {
             'changes': entries,
-            'util': util,
-            'history': h,
-            'scan_url': '/changes',
             'updated': entries[0].date.isoformat() + 'Z',
         }
-        h.flush_cache()
-        return vals

=== modified file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	2006-12-20 22:00:14 +0000
+++ loggerhead/controllers/bundle_ui.py	2008-06-18 06:34:10 +0000
@@ -16,13 +16,10 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import os
 import time
 
-import turbogears
-from cherrypy import HTTPRedirect, response
-
-from loggerhead import util
+from paste import httpexceptions
+from paste.request import path_info_pop
 
 
 class BundleUI (object):
@@ -32,25 +29,36 @@
         self._branch = branch
         self.log = branch.log
 
-    @turbogears.expose()
-    def default(self, *args, **kw):
-        # /bundle/<rev_id>/filename
+    def default(self, request, response):
+        # /bundle/<rev_id>/[<compare_rev_id>/]filename
         z = time.time()
-        h = self._branch.get_history()
-
-        if len(args) < 1:
-            raise HTTPRedirect(self._branch.url('/changes'))
-        revid = h.fix_revid(args[0])
-
+        h = self._branch.history
+
+        h._branch.lock_read()
         try:
-            bundle_data = h.get_bundle(revid)
-        except Exception, x:
-            self.log.error('Exception fetching bundle: %s' % (x,))
-            util.log_exception(self.log)
-            raise HTTPRedirect(self._branch.url('/changes'))
-            
-        response.headers['Content-Type'] = 'text/plain'
-        response.headers['Content-Length'] = len(bundle_data)
-        response.body = bundle_data
-        self.log.info('/bundle: %r seconds' % (time.time() - z,))
-        return response.body
+            args = []
+            while 1:
+                arg = path_info_pop(request.environ)
+                if arg is None:
+                    break
+                args.append(arg)
+            if len(args) < 1:
+                raise httpexceptions.HTTPMovedPermanently('../changes')
+            revid = h.fix_revid(args[0])
+            if len(args) >= 3:
+                compare_revid = h.fix_revid(args[1])
+            else:
+                compare_revid = None
+
+            try:
+                bundle_data = h.get_bundle(revid, compare_revid)
+            except:
+                self.log.exception('Exception fetching bundle')
+                raise httpexceptions.HTTPServerError('Could not fetch bundle')
+
+            response.headers['Content-Type'] = 'application/octet-stream'
+            response.headers['Content-Length'] = len(bundle_data)
+            response.write(bundle_data)
+            self.log.info('/bundle: %r seconds' % (time.time() - z,))
+        finally:
+            h._branch.unlock()

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2006-12-24 07:02:43 +0000
+++ loggerhead/controllers/changelog_ui.py	2008-06-18 12:27:04 +0000
@@ -17,95 +17,87 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import os
-import time
-
-import turbogears
-from cherrypy import HTTPRedirect, session
+from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util
-
-
-# just thinking out loud here...
-#
-# so, when browsing around, there are 3 pieces of context:
-#     - starting revid 
-#         the current beginning of navigation (navigation continues back to
-#         the original revision) -- this may not be along the primary revision
-#         path since the user may have navigated into a branch
-#     - file_id
-#         if navigating the revisions that touched a file
-#     - current revid
-#         current location along the navigation path (while browsing)
-#
-# current revid is given on the url path.  'file_id' and 'starting revid' are
-# handed along as params.
-
-
-class ChangeLogUI (object):
-    
-    def __init__(self, branch):
-        # BranchView object
-        self._branch = branch
-        self.log = branch.log
-        
-    @turbogears.expose(html='loggerhead.templates.changelog')
-    def default(self, *args, **kw):
-        z = time.time()
-        h = self._branch.get_history()
-        config = self._branch.config
-        
-        if len(args) > 0:
+from loggerhead.controllers import TemplatedBranchView
+
+
+class ChangeLogUI(TemplatedBranchView):
+
+    template_path = 'loggerhead.templates.changelog'
+
+    def get_values(self, h, args, kw, response):
+        if args:
             revid = h.fix_revid(args[0])
         else:
             revid = None
 
-        file_id = kw.get('file_id', None)
+        filter_file_id = kw.get('filter_file_id', None)
         query = kw.get('q', None)
         start_revid = h.fix_revid(kw.get('start_revid', None))
         orig_start_revid = start_revid
-        pagesize = int(config.get('pagesize', '20'))
+        pagesize = 20#int(config.get('pagesize', '20'))
         search_failed = False
-        
+
         try:
-            revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
+            revid, start_revid, revid_list = h.get_view(
+                revid, start_revid, filter_file_id, query)
+            util.set_context(kw)
+
             if (query is not None) and (len(revid_list) == 0):
                 search_failed = True
 
             if len(revid_list) == 0:
                 scan_list = revid_list
             else:
-                scan_list = revid_list[h.get_revid_sequence(revid_list, revid):]
-            entry_list = scan_list[:pagesize]
-            entries = h.get_changes(entry_list)
-        except Exception, x:
-            self.log.error('Exception fetching changes: %s' % (x,))
-            util.log_exception(self.log)
-            raise HTTPRedirect(self._branch.url('/changes'))
+                if revid in revid_list: # XXX is this always true?
+                    i = revid_list.index(revid)
+                else:
+                    i = None
+                scan_list = revid_list[i:]
+            change_list = scan_list[:pagesize]
+            changes = list(h.get_changes(change_list))
+            h.add_changes(changes)
+        except:
+            self.log.exception('Exception fetching changes')
+            raise HTTPServerError('Could not fetch changes')
 
-        navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revid_list=revid_list,
-                                    file_id=file_id, scan_url='/changes', branch=self._branch, feed=True)
+        navigation = util.Container(
+            pagesize=pagesize, revid=revid, start_revid=start_revid,
+            revid_list=revid_list, filter_file_id=filter_file_id,
+            scan_url='/changes', branch=self._branch, feed=True)
         if query is not None:
             navigation.query = query
-        util.fill_in_navigation(h, navigation)
-        
-        entries = list(entries)
+        util.fill_in_navigation(navigation)
+
         # add parent & merge-point branch-nick info, in case it's useful
-        h.get_branch_nicks(entries)
-
-        vals = {
+        h.get_branch_nicks(changes)
+
+        # does every change on this page have the same committer?  if so,
+        # tell the template to show committer info in the "details block"
+        # instead of on each line.
+        all_same_author = True
+
+        if changes:
+            author = changes[0].author
+            for e in changes[1:]:
+                if e.author != author:
+                    all_same_author = False
+                    break
+
+        return {
             'branch': self._branch,
-            'changes': list(entries),
+            'changes': changes,
             'util': util,
             'history': h,
             'revid': revid,
             'navigation': navigation,
-            'file_id': file_id,
+            'filter_file_id': filter_file_id,
             'start_revid': start_revid,
             'viewing_from': (orig_start_revid is not None) and (orig_start_revid != h.last_revid),
             'query': query,
             'search_failed': search_failed,
+            'all_same_author': all_same_author,
+            'url': self._branch.context_url,
         }
-        h.flush_cache()
-        self.log.info('/changes %r: %r secs' % (revid, time.time() - z))
-        return vals

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2006-12-20 09:29:42 +0000
+++ loggerhead/controllers/download_ui.py	2008-06-16 08:08:33 +0000
@@ -17,19 +17,12 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import datetime
 import logging
 import mimetypes
-import os
-import posixpath
-import textwrap
 import time
 
-import turbogears
-from cherrypy import HTTPRedirect, response, session
-
-from loggerhead import util
-
+from paste import httpexceptions
+from paste.request import path_info_pop
 
 log = logging.getLogger("loggerhead.controllers")
 
@@ -41,23 +34,34 @@
         self._branch = branch
         self.log = branch.log
 
-    @turbogears.expose()
-    def default(self, *args, **kw):
+    def default(self, request, response):
         # /download/<rev_id>/<file_id>/[filename]
         z = time.time()
-        h = self._branch.get_history()
-        
-        if len(args) < 2:
-            raise HTTPRedirect(self._branch.url('/changes'))
-        
-        revid = h.fix_revid(args[0])
-        file_id = args[1]
-        filename, content = h.get_file(file_id, revid)
-        mime_type, encoding = mimetypes.guess_type(filename)
-        if mime_type is None:
-            mime_type = 'application/octet-stream'
-        
-        response.headers['Content-Type'] = mime_type
-        response.headers['Content-Length'] = len(content)
-        response.body = content
-        return response.body
+        h = self._branch.history
+
+        h._branch.lock_read()
+        try:
+            args = []
+            while 1:
+                arg = path_info_pop(request.environ)
+                if arg is None:
+                    break
+                args.append(arg)
+
+            if len(args) < 2:
+                raise httpexceptions.HTTPMovedPermanently(self._branch.url('../changes'))
+
+            revid = h.fix_revid(args[0])
+            file_id = args[1]
+            path, filename, content = h.get_file(file_id, revid)
+            mime_type, encoding = mimetypes.guess_type(filename)
+            if mime_type is None:
+                mime_type = 'application/octet-stream'
+
+            self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
+            response.headers['Content-Type'] = mime_type
+            response.headers['Content-Length'] = len(content)
+            response.headers['Content-Disposition'] = 'attachment; filename=%s'%(filename,)
+            response.write(content)
+        finally:
+            h._branch.unlock()

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2006-12-20 09:29:42 +0000
+++ loggerhead/controllers/inventory_ui.py	2008-06-18 12:27:04 +0000
@@ -17,17 +17,13 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import datetime
 import logging
-import os
 import posixpath
-import textwrap
-import time
 
-import turbogears
-from cherrypy import HTTPRedirect, session
+from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util
+from loggerhead.controllers import TemplatedBranchView
 
 
 log = logging.getLogger("loggerhead.controllers")
@@ -38,35 +34,26 @@
     path = posixpath.dirname(path)
     return path
 
-        
-class InventoryUI (object):
-
-    def __init__(self, branch):
-        # BranchView object
-        self._branch = branch
-        self.log = branch.log
-
-    @turbogears.expose(html='loggerhead.templates.inventory')
-    def default(self, *args, **kw):
-        z = time.time()
-        h = self._branch.get_history()
-        
+
+class InventoryUI(TemplatedBranchView):
+
+    template_path = 'loggerhead.templates.inventory'
+
+    def get_values(self, h, args, kw, response):
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
-            revid = None
-        
-        file_id = kw.get('file_id', None)
-        sort_type = kw.get('sort', None)
+            revid = h.last_revid
 
         try:
-            revid_list, revid = h.get_file_view(revid, file_id)
-            rev = h.get_revision(revid)
             inv = h.get_inventory(revid)
-        except Exception, x:
-            self.log.error('Exception fetching changes: %s' % (x,))
-            util.log_exception(self.log)
-            raise HTTPRedirect(self._branch.url('/changes'))
+        except:
+            self.log.exception('Exception fetching changes')
+            raise HTTPServerError('Could not fetch changes')
+
+        file_id = kw.get('file_id', inv.root.file_id)
+        start_revid = kw.get('start_revid', None)
+        sort_type = kw.get('sort', None)
 
         # no navbar for revisions
         navigation = util.Container()
@@ -74,7 +61,7 @@
         change = h.get_changes([ revid ])[0]
         # add parent & merge-point branch-nick info, in case it's useful
         h.get_branch_nicks([ change ])
-        
+
         path = inv.id2path(file_id)
         if not path.startswith('/'):
             path = '/' + path
@@ -88,7 +75,7 @@
         if updir == '/':
             updir_file_id = None
 
-        vals = {
+        return {
             'branch': self._branch,
             'util': util,
             'revid': revid,
@@ -97,11 +84,10 @@
             'path': path,
             'updir': updir,
             'updir_file_id': updir_file_id,
-            'filelist': h.get_filelist(inv, path, sort_type),
+            'filelist': h.get_filelist(inv, file_id, sort_type),
             'history': h,
             'posixpath': posixpath,
             'navigation': navigation,
+            'url': self._branch.context_url,
+            'start_revid': start_revid,
         }
-        h.flush_cache()
-        self.log.info('/inventory %r: %r secs' % (revid, time.time() - z))
-        return vals

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2006-12-29 02:24:03 +0000
+++ loggerhead/controllers/revision_ui.py	2008-06-18 12:27:04 +0000
@@ -17,73 +17,76 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import datetime
-import logging
-import os
-import textwrap
-import time
-
-import turbogears
-from cherrypy import HTTPRedirect, session
+from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util
-
-
-class RevisionUI (object):
-
-    def __init__(self, branch):
-        # BranchView object
-        self._branch = branch
-        self.log = branch.log
-
-    @turbogears.expose(html='loggerhead.templates.revision')
-    def default(self, *args, **kw):
-        z = time.time()
-        h = self._branch.get_history()
-        
+from loggerhead.controllers import TemplatedBranchView
+
+
+DEFAULT_LINE_COUNT_LIMIT = 3000
+
+
+class RevisionUI(TemplatedBranchView):
+
+    template_path = 'loggerhead.templates.revision'
+
+    def get_values(self, h, args, kw, response):
+
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
             revid = None
-        
-        file_id = kw.get('file_id', None)
+
+        filter_file_id = kw.get('filter_file_id', None)
         start_revid = h.fix_revid(kw.get('start_revid', None))
         query = kw.get('q', None)
-        
+        remember = h.fix_revid(kw.get('remember', None))
+        compare_revid = h.fix_revid(kw.get('compare_revid', None))
+
         try:
-            revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
-        except Exception, x:
-            self.log.error('Exception fetching changes: %s' % (x,))
-            util.log_exception(self.log)
-            raise HTTPRedirect(self._branch.url('/changes'))
-        
-        navigation = util.Container(revid_list=revid_list, revid=revid, start_revid=start_revid, file_id=file_id,
-                                    pagesize=1, scan_url='/revision', branch=self._branch, feed=True)
+            revid, start_revid, revid_list = h.get_view(revid, start_revid, filter_file_id, query)
+        except:
+            self.log.exception('Exception fetching changes')
+            raise HTTPServerError('Could not fetch changes')
+
+        navigation = util.Container(
+            revid_list=revid_list, revid=revid, start_revid=start_revid,
+            filter_file_id=filter_file_id, pagesize=1,
+            scan_url='/revision', branch=self._branch, feed=True)
         if query is not None:
             navigation.query = query
-        util.fill_in_navigation(h, navigation)
+        util.fill_in_navigation(navigation)
 
-        change = h.get_changes([ revid ], get_diffs=True)[0]
+        change = h.get_change_with_diff(revid, compare_revid)
         # add parent & merge-point branch-nick info, in case it's useful
         h.get_branch_nicks([ change ])
 
+        line_count_limit = DEFAULT_LINE_COUNT_LIMIT
+        line_count = 0
+        for file in change.changes.modified:
+            for chunk in file.chunks:
+                line_count += len(chunk.diff)
+
         # let's make side-by-side diff be the default
         side_by_side = not kw.get('unified', False)
         if side_by_side:
-            h.make_side_by_side([ change ])
-        
-        vals = {
+            h.add_side_by_side([ change ])
+
+        return {
             'branch': self._branch,
             'revid': revid,
             'change': change,
             'start_revid': start_revid,
-            'file_id': file_id,
+            'filter_file_id': filter_file_id,
             'util': util,
             'history': h,
             'navigation': navigation,
             'query': query,
+            'remember': remember,
+            'compare_revid': compare_revid,
             'side_by_side': side_by_side,
+            'url': self._branch.context_url,
+            'line_count': line_count,
+            'line_count_limit': line_count_limit,
+            'show_plain_diffs': line_count > line_count_limit,
         }
-        h.flush_cache()
-        self.log.info('/revision: %r seconds' % (time.time() - z,))
-        return vals

=== added file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	1970-01-01 00:00:00 +0000
+++ loggerhead/daemon.py	2008-04-15 03:10:32 +0000
@@ -0,0 +1,72 @@
+# daemon code from ASPN
+
+import os
+
+
+def daemonize(pidfile, home):
+    """
+    Detach this process from the controlling terminal and run it in the
+    background as a daemon.
+    """
+
+    WORKDIR = "/"
+    REDIRECT_TO = getattr(os, 'devnull', '/dev/null')
+    MAXFD = 1024
+
+    try:
+        pid = os.fork()
+    except OSError, e:
+        raise Exception("%s [%d]" % (e.strerror, e.errno))
+
+    if pid == 0:      # The first child.
+        os.setsid()
+
+        try:
+            pid = os.fork()     # Fork a second child.
+        except OSError, e:
+            raise Exception, "%s [%d]" % (e.strerror, e.errno)
+
+        if pid == 0:  # The second child.
+            os.chdir(WORKDIR)
+        else:
+            os._exit(0) # Exit parent (the first child) of the second child.
+    else:
+        os._exit(0)     # Exit parent of the first child.
+
+    import resource            # Resource usage information.
+    maxfd = resource.getrlimit(resource.RLIMIT_NOFILE)[1]
+    if (maxfd == resource.RLIM_INFINITY):
+        maxfd = MAXFD
+
+    fd = os.open(REDIRECT_TO, os.O_RDONLY)
+    os.dup2(fd, 0)
+    fd = os.open(REDIRECT_TO, os.O_WRONLY)
+    os.dup2(fd, 1)
+    os.dup2(fd, 2)
+
+    # Iterate through and close all other file descriptors.
+    for fd in range(3, maxfd):
+        try:
+            os.close(fd)
+        except OSError:        # ERROR, fd wasn't open to begin with (ignored)
+            pass
+
+    f = open(pidfile, 'w')
+    f.write('%d\n' % (os.getpid(),))
+    f.write('%s\n' % (home,))
+    f.close()
+
+
+def is_running(pidfile):
+    try:
+        f = open(pidfile, 'r')
+    except IOError:
+        return False
+    pid = int(f.readline())
+    f.close()
+    try:
+        os.kill(pid, 0)
+    except OSError:
+        # no such process
+        return False
+    return True

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-01-02 07:17:25 +0000
+++ loggerhead/history.py	2008-06-20 02:20:05 +0000
@@ -27,14 +27,9 @@
 
 
 import bisect
-import cgi
 import datetime
 import logging
-import os
-import posixpath
 import re
-import shelve
-import sys
 import textwrap
 import threading
 import time
@@ -44,19 +39,19 @@
 from loggerhead.util import decorator
 
 import bzrlib
-import bzrlib.annotate
 import bzrlib.branch
 import bzrlib.bundle.serializer
 import bzrlib.diff
 import bzrlib.errors
 import bzrlib.progress
-import bzrlib.textfile
+import bzrlib.revision
 import bzrlib.tsort
 import bzrlib.ui
 
 
 with_branch_lock = util.with_lock('_lock', 'branch')
 
+
 @decorator
 def with_bzrlib_read_lock(unbound):
     def bzrlib_read_locked(self, *args, **kw):
@@ -99,7 +94,7 @@
     """
     turn a normal unified-style diff (post-processed by parse_delta) into a
     side-by-side diff structure.  the new structure is::
-    
+
         chunks: list(
             diff: list(
                 old_lineno: int,
@@ -140,6 +135,41 @@
         return False
 
 
+def clean_message(message):
+    """Clean up a commit message and return it and a short (1-line) version.
+
+    Commit messages that are long single lines are reflowed using the textwrap
+    module (Robey, the original author of this code, apparently favored this
+    style of message).
+    """
+    message = message.splitlines()
+
+    if len(message) == 1:
+        message = textwrap.wrap(message[0])
+
+    if len(message) == 0:
+        # We can end up where when (a) the commit message was empty or (b)
+        # when the message consisted entirely of whitespace, in which case
+        # textwrap.wrap() returns an empty list.
+        return [''], ''
+
+    # Make short form of commit message.
+    short_message = message[0]
+    if len(short_message) > 60:
+        short_message = short_message[:60] + '...'
+
+    return message, short_message
+
+
+def rich_filename(path, kind):
+    if kind == 'directory':
+        path += '/'
+    if kind == 'symlink':
+        path += '@'
+    return path
+
+
+
 # from bzrlib
 class _RevListToTimestamps(object):
     """This takes a list of revisions, and allows you to bisect by date"""
@@ -159,104 +189,102 @@
 
 
 class History (object):
-    
+
     def __init__(self):
-        self._change_cache = None
-        self._index = None
+        self._file_change_cache = None
         self._lock = threading.RLock()
-    
+
     @classmethod
-    def from_branch(cls, branch, name=None):
+    def from_branch(cls, branch):
         z = time.time()
         self = cls()
         self._branch = branch
-        self._history = branch.revision_history()
-        self._last_revid = self._history[-1]
-        self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
-        
-        if name is None:
-            name = self._branch.nick
-        self._name = name
-        self.log = logging.getLogger('loggerhead.%s' % (name,))
-        
+        self._last_revid = self._branch.last_revision()
+
+        self.log = logging.getLogger('loggerhead.%s' % (self._branch.nick,))
+
+        graph = branch.repository.get_graph()
+        parent_map = dict(((key, value) for key, value in
+             graph.iter_ancestry([self._last_revid]) if value is not None))
+
+        self._revision_graph = self._strip_NULL_ghosts(parent_map)
         self._full_history = []
         self._revision_info = {}
         self._revno_revid = {}
-        self._merge_sort = bzrlib.tsort.merge_sort(self._revision_graph, self._last_revid, generate_revno=True)
-        count = 0
+        if bzrlib.revision.is_null(self._last_revid):
+            self._merge_sort = []
+        else:
+            self._merge_sort = bzrlib.tsort.merge_sort(
+                self._revision_graph, self._last_revid, generate_revno=True)
+
         for (seq, revid, merge_depth, revno, end_of_merge) in self._merge_sort:
             self._full_history.append(revid)
             revno_str = '.'.join(str(n) for n in revno)
             self._revno_revid[revno_str] = revid
-            self._revision_info[revid] = (seq, revid, merge_depth, revno_str, end_of_merge)
-            count += 1
-        self._count = count
+            self._revision_info[revid] = (
+                seq, revid, merge_depth, revno_str, end_of_merge)
 
         # cache merge info
         self._where_merged = {}
+
         for revid in self._revision_graph.keys():
-            if not revid in self._full_history: 
+            if self._revision_info[revid][2] == 0:
                 continue
             for parent in self._revision_graph[revid]:
                 self._where_merged.setdefault(parent, set()).add(revid)
 
         self.log.info('built revision graph cache: %r secs' % (time.time() - z,))
         return self
-    
+
+    @staticmethod
+    def _strip_NULL_ghosts(revision_graph):
+        """
+        Copied over from bzrlib meant as a temporary workaround deprecated 
+        methods.
+        """
+
+        # Filter ghosts, and null:
+        if bzrlib.revision.NULL_REVISION in revision_graph:
+            del revision_graph[bzrlib.revision.NULL_REVISION]
+        for key, parents in revision_graph.items():
+            revision_graph[key] = tuple(parent for parent in parents if parent
+                in revision_graph)
+        return revision_graph
+
     @classmethod
-    def from_folder(cls, path, name=None):
+    def from_folder(cls, path):
         b = bzrlib.branch.Branch.open(path)
-        return cls.from_branch(b, name)
+        b.lock_read()
+        try:
+            return cls.from_branch(b)
+        finally:
+            b.unlock()
 
     @with_branch_lock
     def out_of_date(self):
-        if self._branch.revision_history()[-1] != self._last_revid:
-            return True
-        return False
-
-    def use_cache(self, cache):
-        self._change_cache = cache
-    
-    def use_search_index(self, index):
-        self._index = index
-
-    @with_branch_lock
-    def detach(self):
-        # called when a new history object needs to be created, because the
-        # branch history has changed.  we need to immediately close and stop
-        # using our caches, because a new history object will be created to
-        # replace us, using the same cache files.
-        # (may also be called during server shutdown.)
-        if self._change_cache is not None:
-            self._change_cache.close()
-            self._change_cache = None
-        if self._index is not None:
-            self._index.close()
-            self._index = None
-
-    def flush_cache(self):
-        if self._change_cache is None:
-            return
-        self._change_cache.flush()
-    
-    def check_rebuild(self):
-        if self._change_cache is not None:
-            self._change_cache.check_rebuild()
-        if self._index is not None:
-            self._index.check_rebuild()
-    
+        # the branch may have been upgraded on disk, in which case we're stale.
+        newly_opened = bzrlib.branch.Branch.open(self._branch.base)
+        if self._branch.__class__ is not \
+               newly_opened.__class__:
+            return True
+        if self._branch.repository.__class__ is not \
+               newly_opened.repository.__class__:
+            return True
+        return self._branch.last_revision() != self._last_revid
+
+    def use_file_cache(self, cache):
+        self._file_change_cache = cache
+
+    @property
+    def has_revisions(self):
+        return not bzrlib.revision.is_null(self.last_revid)
+
     last_revid = property(lambda self: self._last_revid, None, None)
-    
-    count = property(lambda self: self._count, None, None)
 
     @with_branch_lock
     def get_config(self):
         return self._branch.get_config()
-    
-    @with_branch_lock
-    def get_revision(self, revid):
-        return self._branch.repository.get_revision(revid)
-    
+
     def get_revno(self, revid):
         if revid not in self._revision_info:
             # ghost parent?
@@ -264,40 +292,36 @@
         seq, revid, merge_depth, revno_str, end_of_merge = self._revision_info[revid]
         return revno_str
 
-    def get_sequence(self, revid):
-        seq, revid, merge_depth, revno_str, end_of_merge = self._revision_info[revid]
-        return seq
-    
     def get_revision_history(self):
         return self._full_history
-    
-    def get_revid_sequence(self, revid_list, revid):
-        """
-        given a list of revision ids, return the sequence # of this revid in
-        the list.
-        """
-        seq = 0
-        for r in revid_list:
-            if revid == r:
-                return seq
-            seq += 1
-    
-    def get_revids_from(self, revid_list, revid):
-        """
-        given a list of revision ids, yield revisions in graph order,
-        starting from revid.  the list can be None if you just want to travel
-        across all revisions.
-        """
-        while True:
-            if (revid_list is None) or (revid in revid_list):
+
+    def get_revids_from(self, revid_list, start_revid):
+        """
+        Yield the mainline (wrt start_revid) revisions that merged each
+        revid in revid_list.
+        """
+        if revid_list is None:
+            revid_list = self._full_history
+        revid_set = set(revid_list)
+        revid = start_revid
+        def introduced_revisions(revid):
+            r = set([revid])
+            seq, revid, md, revno, end_of_merge = self._revision_info[revid]
+            i = seq + 1
+            while i < len(self._merge_sort) and self._merge_sort[i][2] > md:
+                r.add(self._merge_sort[i][1])
+                i += 1
+            return r
+        while 1:
+            if bzrlib.revision.is_null(revid):
+                return
+            if introduced_revisions(revid) & revid_set:
                 yield revid
-            if not self._revision_graph.has_key(revid):
-                return
             parents = self._revision_graph[revid]
             if len(parents) == 0:
                 return
             revid = parents[0]
-    
+
     @with_branch_lock
     def get_short_revision_history_by_fileid(self, file_id):
         # wow.  is this really the only way we can get this list?  by
@@ -322,37 +346,12 @@
         revid_list.reverse()
         index = -index
         return revid_list[index:]
-    
-    @with_branch_lock
-    def get_revision_history_matching(self, revid_list, text):
-        self.log.debug('searching %d revisions for %r', len(revid_list), text)
-        z = time.time()
-        # this is going to be painfully slow. :(
-        out = []
-        text = text.lower()
-        for revid in revid_list:
-            change = self.get_changes([ revid ])[0]
-            if text in change.comment.lower():
-                out.append(revid)
-        self.log.debug('searched %d revisions for %r in %r secs', len(revid_list), text, time.time() - z)
-        return out
 
-    def get_revision_history_matching_indexed(self, revid_list, text):
-        self.log.debug('searching %d revisions for %r', len(revid_list), text)
-        z = time.time()
-        if self._index is None:
-            return self.get_revision_history_matching(revid_list, text)
-        out = self._index.find(text, revid_list)
-        self.log.debug('searched %d revisions for %r in %r secs: %d results', len(revid_list), text, time.time() - z, len(out))
-        # put them in some coherent order :)
-        out = [r for r in self._full_history if r in out]
-        return out
-    
     @with_branch_lock
     def get_search_revid_list(self, query, revid_list):
         """
         given a "quick-search" query, try a few obvious possible meanings:
-        
+
             - revision id or # ("128.1.3")
             - date (US style "mm/dd/yy", earth style "dd-mm-yy", or iso style "yyyy-mm-dd")
             - comment text as a fallback
@@ -362,14 +361,16 @@
         # FIXME: there is some silliness in this action.  we have to look up
         # all the relevant changes (time-consuming) only to return a list of
         # revids which will be used to fetch a set of changes again.
-        
+
         # if they entered a revid, just jump straight there; ignore the passed-in revid_list
         revid = self.fix_revid(query)
         if revid is not None:
+            if isinstance(revid, unicode):
+                revid = revid.encode('utf-8')
             changes = self.get_changes([ revid ])
             if (changes is not None) and (len(changes) > 0):
                 return [ revid ]
-        
+
         date = None
         m = self.us_date_re.match(query)
         if m is not None:
@@ -387,12 +388,7 @@
                 # if no limit to the query was given, search only the direct-parent path.
                 revid_list = list(self.get_revids_from(None, self._last_revid))
             return self.get_revision_history_since(revid_list, date)
-        
-        # check comment fields.
-        if revid_list is None:
-            revid_list = self._full_history
-        return self.get_revision_history_matching_indexed(revid_list, query)
-    
+
     revno_re = re.compile(r'^[\d\.]+$')
     # the date regex are without a final '$' so that queries like
     # "2006-11-30 12:15" still mostly work.  (i think it's better to give
@@ -405,79 +401,83 @@
         # if a "revid" is actually a dotted revno, convert it to a revid
         if revid is None:
             return revid
+        if revid == 'head:':
+            return self._last_revid
         if self.revno_re.match(revid):
             revid = self._revno_revid[revid]
         return revid
-    
+
     @with_branch_lock
     def get_file_view(self, revid, file_id):
         """
-        Given an optional revid and optional path, return a (revlist, revid)
-        for navigation through the current scope: from the revid (or the
-        latest revision) back to the original revision.
-        
+        Given a revid and optional path, return a (revlist, revid) for
+        navigation through the current scope: from the revid (or the latest
+        revision) back to the original revision.
+
         If file_id is None, the entire revision history is the list scope.
-        If revid is None, the latest revision is used.
         """
         if revid is None:
             revid = self._last_revid
         if file_id is not None:
-            # since revid is 'start_revid', possibly should start the path tracing from revid... FIXME
-            inv = self._branch.repository.get_revision_inventory(revid)
+            # since revid is 'start_revid', possibly should start the path
+            # tracing from revid... FIXME
             revlist = list(self.get_short_revision_history_by_fileid(file_id))
             revlist = list(self.get_revids_from(revlist, revid))
         else:
             revlist = list(self.get_revids_from(None, revid))
-        if revid is None:
-            revid = revlist[0]
-        return revlist, revid
-    
+        return revlist
+
     @with_branch_lock
     def get_view(self, revid, start_revid, file_id, query=None):
         """
         use the URL parameters (revid, start_revid, file_id, and query) to
         determine the revision list we're viewing (start_revid, file_id, query)
         and where we are in it (revid).
-        
-        if a query is given, we're viewing query results.
-        if a file_id is given, we're viewing revisions for a specific file.
-        if a start_revid is given, we're viewing the branch from a
-            specific revision up the tree.
-        (these may be combined to view revisions for a specific file, from
-            a specific revision, with a specific search query.)
-            
-        returns a new (revid, start_revid, revid_list, scan_list) where:
-        
+
+            - if a query is given, we're viewing query results.
+            - if a file_id is given, we're viewing revisions for a specific
+              file.
+            - if a start_revid is given, we're viewing the branch from a
+              specific revision up the tree.
+
+        these may be combined to view revisions for a specific file, from
+        a specific revision, with a specific search query.
+
+        returns a new (revid, start_revid, revid_list) where:
+
             - revid: current position within the view
             - start_revid: starting revision of this view
             - revid_list: list of revision ids for this view
-        
+
         file_id and query are never changed so aren't returned, but they may
         contain vital context for future url navigation.
         """
+        if start_revid is None:
+            start_revid = self._last_revid
+
         if query is None:
-            revid_list, start_revid = self.get_file_view(start_revid, file_id)
+            revid_list = self.get_file_view(start_revid, file_id)
             if revid is None:
                 revid = start_revid
             if revid not in revid_list:
                 # if the given revid is not in the revlist, use a revlist that
                 # starts at the given revid.
-                revid_list, start_revid = self.get_file_view(revid, file_id)
+                revid_list = self.get_file_view(revid, file_id)
+                start_revid = revid
             return revid, start_revid, revid_list
-        
+
         # potentially limit the search
-        if (start_revid is not None) or (file_id is not None):
-            revid_list, start_revid = self.get_file_view(start_revid, file_id)
+        if file_id is not None:
+            revid_list = self.get_file_view(start_revid, file_id)
         else:
             revid_list = None
 
         revid_list = self.get_search_revid_list(query, revid_list)
-        if len(revid_list) > 0:
+        if revid_list and len(revid_list) > 0:
             if revid not in revid_list:
                 revid = revid_list[0]
             return revid, start_revid, revid_list
         else:
-            # no results
             return None, None, []
 
     @with_branch_lock
@@ -492,23 +492,23 @@
         if (len(path) > 0) and not path.startswith('/'):
             path = '/' + path
         return path
-    
-    def get_where_merged(self, revid):
-        try:
-            return self._where_merged[revid]
-        except:
-            return []
-    
+
+    @with_branch_lock
+    def get_file_id(self, revid, path):
+        if (len(path) > 0) and not path.startswith('/'):
+            path = '/' + path
+        return self._branch.repository.get_revision_inventory(revid).path2id(path)
+
     def get_merge_point_list(self, revid):
         """
         Return the list of revids that have merged this node.
         """
-        if revid in self._history:
+        if '.' not in self.get_revno(revid):
             return []
-        
+
         merge_point = []
         while True:
-            children = self.get_where_merged(revid)
+            children = self._where_merged.get(revid, [])
             nexts = []
             for child in children:
                 child_parents = self._revision_graph[child]
@@ -528,7 +528,7 @@
                 merge_point.extend(merge_point_next)
 
             revid = nexts[0]
-            
+
     def simplify_merge_point_list(self, revids):
         """if a revision is already merged, don't show further merge points"""
         d = {}
@@ -560,121 +560,165 @@
         p_changes = self.get_changes(list(fetch_set))
         p_change_dict = dict([(c.revid, c) for c in p_changes])
         for change in changes:
+            # arch-converted branches may not have merged branch info :(
             for p in change.parents:
-                p.branch_nick = p_change_dict[p.revid].branch_nick
+                if p.revid in p_change_dict:
+                    p.branch_nick = p_change_dict[p.revid].branch_nick
+                else:
+                    p.branch_nick = '(missing)'
             for p in change.merge_points:
-                p.branch_nick = p_change_dict[p.revid].branch_nick
-    
+                if p.revid in p_change_dict:
+                    p.branch_nick = p_change_dict[p.revid].branch_nick
+                else:
+                    p.branch_nick = '(missing)'
+
     @with_branch_lock
-    def get_changes(self, revid_list, get_diffs=False):
-        if self._change_cache is None:
-            changes = self.get_changes_uncached(revid_list, get_diffs)
-        else:
-            changes = self._change_cache.get_changes(revid_list, get_diffs)
-        if changes is None:
+    def get_changes(self, revid_list):
+        """Return a list of changes objects for the given revids.
+
+        Revisions not present and NULL_REVISION will be ignored.
+        """
+        changes = self.get_changes_uncached(revid_list)
+        if len(changes) == 0:
             return changes
-        
+
         # some data needs to be recalculated each time, because it may
         # change as new revisions are added.
-        for i in xrange(len(revid_list)):
-            revid = revid_list[i]
-            change = changes[i]
-            merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
+        for change in changes:
+            merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(change.revid))
             change.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
-        
+            if len(change.parents) > 0:
+                change.parents = [util.Container(revid=r, 
+                    revno=self.get_revno(r)) for r in change.parents]
+            change.revno = self.get_revno(change.revid)
+
+        parity = 0
+        for change in changes:
+            change.parity = parity
+            parity ^= 1
+
         return changes
 
-    # alright, let's profile this sucka.
-    def _get_changes_profiled(self, revid_list, get_diffs=False):
-        from loggerhead.lsprof import profile
-        import cPickle
-        ret, stats = profile(self.get_changes_uncached, revid_list, get_diffs)
-        stats.sort()
-        stats.freeze()
-        cPickle.dump(stats, open('lsprof.stats', 'w'), 2)
-        return ret
-
     @with_branch_lock
     @with_bzrlib_read_lock
-    def get_changes_uncached(self, revid_list, get_diffs=False):
+    def get_changes_uncached(self, revid_list):
+        # FIXME: deprecated method in getting a null revision
+        revid_list = filter(lambda revid: not bzrlib.revision.is_null(revid),
+                            revid_list)
+        parent_map = self._branch.repository.get_graph().get_parent_map(revid_list)
+        # We need to return the answer in the same order as the input,
+        # less any ghosts.
+        present_revids = [revid for revid in revid_list
+                          if revid in parent_map]
+        rev_list = self._branch.repository.get_revisions(present_revids)
+
+        return [self._change_from_revision(rev) for rev in rev_list]
+
+    def _get_deltas_for_revisions_with_trees(self, revisions):
+        """Produce a list of revision deltas.
+
+        Note that the input is a sequence of REVISIONS, not revision_ids.
+        Trees will be held in memory until the generator exits.
+        Each delta is relative to the revision's lefthand predecessor.
+        (This is copied from bzrlib.)
+        """
+        required_trees = set()
+        for revision in revisions:
+            required_trees.add(revision.revid)
+            required_trees.update([p.revid for p in revision.parents[:1]])
+        trees = dict((t.get_revision_id(), t) for
+                     t in self._branch.repository.revision_trees(required_trees))
+        ret = []
+        self._branch.repository.lock_read()
         try:
-            rev_list = self._branch.repository.get_revisions(revid_list)
-        except (KeyError, bzrlib.errors.NoSuchRevision):
-            return None
-        
-        delta_list = self._branch.repository.get_deltas_for_revisions(rev_list)
-        combined_list = zip(rev_list, delta_list)
-        
-        tree_map = {}
-        if get_diffs:
-            # lookup the trees for each revision, so we can calculate diffs
-            lookup_set = set()
-            for rev in rev_list:
-                lookup_set.add(rev.revision_id)
-                if len(rev.parent_ids) > 0:
-                    lookup_set.add(rev.parent_ids[0])
-            tree_map = dict((t.get_revision_id(), t) for t in self._branch.repository.revision_trees(lookup_set))
-            # also the root tree, in case we hit the origin:
-            tree_map[None] = self._branch.repository.revision_tree(None)
-        
-        entries = []
-        for rev, delta in combined_list:
-            commit_time = datetime.datetime.fromtimestamp(rev.timestamp)
-            
-            parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in rev.parent_ids]
-    
-            if len(parents) == 0:
-                left_parent = None
+            for revision in revisions:
+                if not revision.parents:
+                    old_tree = self._branch.repository.revision_tree(
+                        bzrlib.revision.NULL_REVISION)
+                else:
+                    old_tree = trees[revision.parents[0].revid]
+                tree = trees[revision.revid]
+                ret.append(tree.changes_from(old_tree))
+            return ret
+        finally:
+            self._branch.repository.unlock()
+
+    def _change_from_revision(self, revision):
+        """
+        Given a bzrlib Revision, return a processed "change" for use in
+        templates.
+        """
+        commit_time = datetime.datetime.fromtimestamp(revision.timestamp)
+
+        parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in revision.parent_ids]
+
+        message, short_message = clean_message(revision.message)
+
+        entry = {
+            'revid': revision.revision_id,
+            'date': commit_time,
+            'author': revision.committer,
+            'branch_nick': revision.properties.get('branch-nick', None),
+            'short_comment': short_message,
+            'comment': revision.message,
+            'comment_clean': [util.html_clean(s) for s in message],
+            'parents': revision.parent_ids,
+        }
+        return util.Container(entry)
+
+    def get_file_changes_uncached(self, entries):
+        delta_list = self._get_deltas_for_revisions_with_trees(entries)
+
+        return [self.parse_delta(delta) for delta in delta_list]
+
+    @with_branch_lock
+    def get_file_changes(self, entries):
+        if self._file_change_cache is None:
+            return self.get_file_changes_uncached(entries)
+        else:
+            return self._file_change_cache.get_file_changes(entries)
+
+    def add_changes(self, entries):
+        changes_list = self.get_file_changes(entries)
+
+        for entry, changes in zip(entries, changes_list):
+            entry.changes = changes
+
+    @with_branch_lock
+    def get_change_with_diff(self, revid, compare_revid=None):
+        change = self.get_changes([revid])[0]
+
+        if compare_revid is None:
+            if change.parents:
+                compare_revid = change.parents[0].revid
             else:
-                left_parent = rev.parent_ids[0]
-            
-            message = rev.message.splitlines()
-            if len(message) == 1:
-                # robey-style 1-line long message
-                message = textwrap.wrap(message[0])
-            
-            # make short form of commit message
-            short_message = message[0]
-            if len(short_message) > 60:
-                short_message = short_message[:60] + '...'
-    
-            old_tree, new_tree = None, None
-            if get_diffs:
-                new_tree = tree_map[rev.revision_id]
-                old_tree = tree_map[left_parent]
-
-            entry = {
-                'revid': rev.revision_id,
-                'revno': self.get_revno(rev.revision_id),
-                'date': commit_time,
-                'author': rev.committer,
-                'branch_nick': rev.properties.get('branch-nick', None),
-                'short_comment': short_message,
-                'comment': rev.message,
-                'comment_clean': [util.html_clean(s) for s in message],
-                'parents': parents,
-                'changes': self.parse_delta(delta, get_diffs, old_tree, new_tree),
-            }
-            entries.append(util.Container(entry))
-        
-        return entries
+                compare_revid = 'null:'
+
+        rev_tree1 = self._branch.repository.revision_tree(compare_revid)
+        rev_tree2 = self._branch.repository.revision_tree(revid)
+        delta = rev_tree2.changes_from(rev_tree1)
+
+        change.changes = self.parse_delta(delta)
+        change.changes.modified = self._parse_diffs(rev_tree1, rev_tree2, delta)
+
+        return change
 
     @with_branch_lock
     def get_file(self, file_id, revid):
-        "returns (filename, data)"
-        inv_entry = self.get_inventory(revid)[file_id]
+        "returns (path, filename, data)"
+        inv = self.get_inventory(revid)
+        inv_entry = inv[file_id]
         rev_tree = self._branch.repository.revision_tree(inv_entry.revision)
-        return inv_entry.name, rev_tree.get_file_text(file_id)
-    
-    @with_branch_lock
-    def parse_delta(self, delta, get_diffs=True, old_tree=None, new_tree=None):
+        path = inv.id2path(file_id)
+        if not path.startswith('/'):
+            path = '/' + path
+        return path, inv_entry.name, rev_tree.get_file_text(file_id)
+
+    def _parse_diffs(self, old_tree, new_tree, delta):
         """
-        Return a nested data structure containing the changes in a delta::
-        
-            added: list((filename, file_id)),
-            renamed: list((old_filename, new_filename, file_id)),
-            deleted: list((filename, file_id)),
-            modified: list(
+        Return a list of processed diffs, in the format::
+
+            list(
                 filename: str,
                 file_id: str,
                 chunks: list(
@@ -686,135 +730,152 @@
                     ),
                 ),
             )
-        
-        if C{get_diffs} is false, the C{chunks} will be omitted.
+        """
+        process = []
+        out = []
+
+        for old_path, new_path, fid, kind, text_modified, meta_modified in delta.renamed:
+            if text_modified:
+                process.append((old_path, new_path, fid, kind))
+        for path, fid, kind, text_modified, meta_modified in delta.modified:
+            process.append((path, path, fid, kind))
+
+        for old_path, new_path, fid, kind in process:
+            old_lines = old_tree.get_file_lines(fid)
+            new_lines = new_tree.get_file_lines(fid)
+            buffer = StringIO()
+            if old_lines != new_lines:
+                try:
+                    bzrlib.diff.internal_diff(old_path, old_lines,
+                                              new_path, new_lines, buffer)
+                except bzrlib.errors.BinaryFile:
+                    diff = ''
+                else:
+                    diff = buffer.getvalue()
+            else:
+                diff = ''
+            out.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=self._process_diff(diff), raw_diff=diff))
+
+        return out
+
+    def _process_diff(self, diff):
+        # doesn't really need to be a method; could be static.
+        chunks = []
+        chunk = None
+        for line in diff.splitlines():
+            if len(line) == 0:
+                continue
+            if line.startswith('+++ ') or line.startswith('--- '):
+                continue
+            if line.startswith('@@ '):
+                # new chunk
+                if chunk is not None:
+                    chunks.append(chunk)
+                chunk = util.Container()
+                chunk.diff = []
+                lines = [int(x.split(',')[0][1:]) for x in line.split(' ')[1:3]]
+                old_lineno = lines[0]
+                new_lineno = lines[1]
+            elif line.startswith(' '):
+                chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=new_lineno,
+                                                 type='context', line=util.fixed_width(line[1:])))
+                old_lineno += 1
+                new_lineno += 1
+            elif line.startswith('+'):
+                chunk.diff.append(util.Container(old_lineno=None, new_lineno=new_lineno,
+                                                 type='insert', line=util.fixed_width(line[1:])))
+                new_lineno += 1
+            elif line.startswith('-'):
+                chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=None,
+                                                 type='delete', line=util.fixed_width(line[1:])))
+                old_lineno += 1
+            else:
+                chunk.diff.append(util.Container(old_lineno=None, new_lineno=None,
+                                                 type='unknown', line=util.fixed_width(repr(line))))
+        if chunk is not None:
+            chunks.append(chunk)
+        return chunks
+
+    def parse_delta(self, delta):
+        """
+        Return a nested data structure containing the changes in a delta::
+
+            added: list((filename, file_id)),
+            renamed: list((old_filename, new_filename, file_id)),
+            deleted: list((filename, file_id)),
+            modified: list(
+                filename: str,
+                file_id: str,
+            )
         """
         added = []
         modified = []
         renamed = []
         removed = []
-        
-        def rich_filename(path, kind):
-            if kind == 'directory':
-                path += '/'
-            if kind == 'symlink':
-                path += '@'
-            return path
-        
-        def process_diff(diff):
-            chunks = []
-            chunk = None
-            for line in diff.splitlines():
-                if len(line) == 0:
-                    continue
-                if line.startswith('+++ ') or line.startswith('--- '):
-                    continue
-                if line.startswith('@@ '):
-                    # new chunk
-                    if chunk is not None:
-                        chunks.append(chunk)
-                    chunk = util.Container()
-                    chunk.diff = []
-                    lines = [int(x.split(',')[0][1:]) for x in line.split(' ')[1:3]]
-                    old_lineno = lines[0]
-                    new_lineno = lines[1]
-                elif line.startswith(' '):
-                    chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=new_lineno,
-                                                     type='context', line=util.html_clean(line[1:])))
-                    old_lineno += 1
-                    new_lineno += 1
-                elif line.startswith('+'):
-                    chunk.diff.append(util.Container(old_lineno=None, new_lineno=new_lineno,
-                                                     type='insert', line=util.html_clean(line[1:])))
-                    new_lineno += 1
-                elif line.startswith('-'):
-                    chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=None,
-                                                     type='delete', line=util.html_clean(line[1:])))
-                    old_lineno += 1
-                else:
-                    chunk.diff.append(util.Container(old_lineno=None, new_lineno=None,
-                                                     type='unknown', line=util.html_clean(repr(line))))
-            if chunk is not None:
-                chunks.append(chunk)
-            return chunks
-                    
-        def handle_modify(old_path, new_path, fid, kind):
-            if not get_diffs:
-                modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid))
-                return
-            old_lines = old_tree.get_file_lines(fid)
-            new_lines = new_tree.get_file_lines(fid)
-            buffer = StringIO()
-            bzrlib.diff.internal_diff(old_path, old_lines, new_path, new_lines, buffer)
-            diff = buffer.getvalue()
-            modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=process_diff(diff), raw_diff=diff))
 
         for path, fid, kind in delta.added:
             added.append((rich_filename(path, kind), fid))
-        
+
         for path, fid, kind, text_modified, meta_modified in delta.modified:
-            handle_modify(path, path, fid, kind)
-        
-        for oldpath, newpath, fid, kind, text_modified, meta_modified in delta.renamed:
-            renamed.append((rich_filename(oldpath, kind), rich_filename(newpath, kind), fid))
+            modified.append(util.Container(filename=rich_filename(path, kind), file_id=fid))
+
+        for old_path, new_path, fid, kind, text_modified, meta_modified in delta.renamed:
+            renamed.append((rich_filename(old_path, kind), rich_filename(new_path, kind), fid))
             if meta_modified or text_modified:
-                handle_modify(oldpath, newpath, fid, kind)
-        
+                modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid))
+
         for path, fid, kind in delta.removed:
             removed.append((rich_filename(path, kind), fid))
-        
+
         return util.Container(added=added, renamed=renamed, removed=removed, modified=modified)
 
     @staticmethod
-    def make_side_by_side(changes):
+    def add_side_by_side(changes):
         # FIXME: this is a rotten API.
         for change in changes:
             for m in change.changes.modified:
-                m.chunks = _make_side_by_side(m.chunks)
-    
+                m.sbs_chunks = _make_side_by_side(m.chunks)
+
     @with_branch_lock
-    def get_filelist(self, inv, path, sort_type=None):
+    def get_filelist(self, inv, file_id, sort_type=None):
         """
         return the list of all files (and their attributes) within a given
         path subtree.
         """
-        while path.endswith('/'):
-            path = path[:-1]
-        if path.startswith('/'):
-            path = path[1:]
-        
-        entries = inv.entries()
-        
-        fetch_set = set()
-        for filepath, entry in entries:
-            fetch_set.add(entry.revision)
-        change_dict = dict([(c.revid, c) for c in self.get_changes(list(fetch_set))])
-        
+
+        dir_ie = inv[file_id]
+        path = inv.id2path(file_id)
         file_list = []
-        for filepath, entry in entries:
-            if posixpath.dirname(filepath) != path:
-                continue
-            filename = posixpath.basename(filepath)
-            rich_filename = filename
+
+        revid_set = set()
+
+        for filename, entry in dir_ie.children.iteritems():
+            revid_set.add(entry.revision)
+
+        change_dict = {}
+        for change in self.get_changes(list(revid_set)):
+            change_dict[change.revid] = change
+
+        for filename, entry in dir_ie.children.iteritems():
             pathname = filename
             if entry.kind == 'directory':
                 pathname += '/'
-            
-            # last change:
+
             revid = entry.revision
-            change = change_dict[revid]
-            
-            file = util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
-                                  pathname=pathname, file_id=entry.file_id, size=entry.text_size, revid=revid, change=change)
+
+            file = util.Container(
+                filename=filename, executable=entry.executable, kind=entry.kind,
+                pathname=pathname, file_id=entry.file_id, size=entry.text_size,
+                revid=revid, change=change_dict[revid])
             file_list.append(file)
-        
-        if sort_type == 'filename':
+
+        if sort_type == 'filename' or sort_type is None:
             file_list.sort(key=lambda x: x.filename)
         elif sort_type == 'size':
             file_list.sort(key=lambda x: x.size)
         elif sort_type == 'date':
             file_list.sort(key=lambda x: x.change.date)
-        
+
         parity = 0
         for file in file_list:
             file.parity = parity
@@ -823,35 +884,32 @@
         return file_list
 
 
-    _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b-\x0c\x0e-\x1f]')
+    _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b\x0e-\x1f]')
 
     @with_branch_lock
     def annotate_file(self, file_id, revid):
         z = time.time()
         lineno = 1
         parity = 0
-        
+
         file_revid = self.get_inventory(revid)[file_id].revision
         oldvalues = None
-        
-        # because we cache revision metadata ourselves, it's actually much
-        # faster to call 'annotate_iter' on the weave directly than it is to
-        # ask bzrlib to annotate for us.
-        w = self._branch.repository.weave_store.get_weave(file_id, self._branch.repository.get_transaction())
-        
+        tree = self._branch.repository.revision_tree(file_revid)
         revid_set = set()
-        for line_revid, text in w.annotate_iter(file_revid):
+
+        for line_revid, text in tree.annotate_iter(file_id):
             revid_set.add(line_revid)
             if self._BADCHARS_RE.match(text):
                 # bail out; this isn't displayable text
                 yield util.Container(parity=0, lineno=1, status='same',
-                                     text='<i>' + util.html_clean('(This is a binary file.)') + '</i>',
+                                     text='(This is a binary file.)',
                                      change=util.Container())
                 return
-        change_cache = dict([(c.revid, c) for c in self.get_changes(list(revid_set))])
-        
+        change_cache = dict([(c.revid, c) \
+                for c in self.get_changes(list(revid_set))])
+
         last_line_revid = None
-        for line_revid, text in w.annotate_iter(file_revid):
+        for line_revid, text in tree.annotate_iter(file_id):
             if line_revid == last_line_revid:
                 # remember which lines have a new revno and which don't
                 status = 'same'
@@ -863,22 +921,21 @@
                 trunc_revno = change.revno
                 if len(trunc_revno) > 10:
                     trunc_revno = trunc_revno[:9] + '...'
-                
+
             yield util.Container(parity=parity, lineno=lineno, status=status,
-                                 change=change, text=util.html_clean(text))
+                                 change=change, text=util.fixed_width(text))
             lineno += 1
-        
+
         self.log.debug('annotate: %r secs' % (time.time() - z,))
 
     @with_branch_lock
-    @with_bzrlib_read_lock
-    def get_bundle(self, revid):
-        parents = self._revision_graph[revid]
-        if len(parents) > 0:
-            parent_revid = parents[0]
-        else:
-            parent_revid = None
+    def get_bundle(self, revid, compare_revid=None):
+        if compare_revid is None:
+            parents = self._revision_graph[revid]
+            if len(parents) > 0:
+                compare_revid = parents[0]
+            else:
+                compare_revid = None
         s = StringIO()
-        bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, parent_revid, s)
+        bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, compare_revid, s)
         return s.getvalue()
-

=== removed file 'loggerhead/json.py'
--- loggerhead/json.py	2006-12-11 06:44:19 +0000
+++ loggerhead/json.py	1970-01-01 00:00:00 +0000
@@ -1,12 +0,0 @@
-# This module provides helper functions for the JSON part of your
-# view, if you are providing a JSON-based API for your app.
-
-# Here's what most rules would look like:
-# @jsonify.when("isinstance(obj, YourClass)")
-# def jsonify_yourclass(obj):
-#     return [obj.val1, obj.val2]
-# The goal is to break your objects down into simple values:
-# lists, dicts, numbers and strings
-
-from turbojson.jsonify import jsonify
-

=== modified file 'loggerhead/lockfile.py'
--- loggerhead/lockfile.py	2007-01-02 04:34:09 +0000
+++ loggerhead/lockfile.py	2008-02-27 03:36:09 +0000
@@ -25,6 +25,8 @@
 
 with_lock = util.with_lock('_tlock', 'LockFile')
 
+MAX_STALE_TIME = 5 * 60
+
 
 class LockFile (object):
     """
@@ -33,7 +35,7 @@
     lock may be acquired multiple times by the same thread, as long as it's
     released an equal number of times.  unlike threading.Lock, this lock can
     be used across processes.
-    
+
     this uses os.open(O_CREAT|O_EXCL), which apparently works even on windows,
     but will not work over NFS, if anyone still uses that.  so don't put the
     cache folder on an NFS server...
@@ -44,7 +46,11 @@
         # thread lock to maintain internal consistency
         self._tlock = threading.Lock()
         self._count = 0
-    
+        if os.path.exists(filename):
+            # remove stale locks left over from a previous run
+            if time.time() - os.stat(filename).st_mtime > MAX_STALE_TIME:
+                os.remove(filename)
+
     @with_lock
     def _try_acquire(self):
         if self._count > 0:
@@ -57,7 +63,7 @@
             return True
         except OSError:
             return False
-    
+
     def acquire(self):
         # try over and over, sleeping on exponential backoff with an upper limit of about 5 seconds
         pause = 0.1

=== modified file 'loggerhead/lsprof.py'
--- loggerhead/lsprof.py	2006-12-15 01:14:05 +0000
+++ loggerhead/lsprof.py	2008-02-27 03:36:09 +0000
@@ -36,7 +36,7 @@
         for pp in _g_threadmap.values():
             pp.disable()
         threading.setprofile(None)
-    
+
     threads = {}
     for tid, pp in _g_threadmap.items():
         threads[tid] = Stats(pp.getstats(), {})
@@ -112,7 +112,7 @@
         self.out_file = None
 
     def output(self, out_file):
-        self.out_file = out_file        
+        self.out_file = out_file
         print >> out_file, 'events: Ticks'
         self._print_summary()
         for entry in self.data:

=== removed file 'loggerhead/model.py'
--- loggerhead/model.py	2006-12-11 06:44:19 +0000
+++ loggerhead/model.py	1970-01-01 00:00:00 +0000
@@ -1,10 +0,0 @@
-from sqlobject import *
-
-from turbogears.database import PackageHub
-
-hub = PackageHub("loggerhead")
-__connection__ = hub
-
-# class YourDataClass(SQLObject):
-#     pass
-

=== modified file 'loggerhead/release.py'
--- loggerhead/release.py	2006-12-23 19:29:05 +0000
+++ loggerhead/release.py	2008-03-06 01:59:26 +0000
@@ -1,6 +1,6 @@
 # Release information about loggerhead
 
-version = "1.0-0.13"
+version = "1.2.1"
 
 description = "Loggerhead is a web viewer for projects in bazaar."
 
@@ -8,5 +8,5 @@
 email = "robey@lag.net"
 
 license = "GPL"
-url = "http://www.lag.net/loggerhead/"
-download_url = "http://www.lag.net/loggerhead/download/..."
+url = "http://launchpad.net/loggerhead"
+download_url = "https://launchpad.net/loggerhead/trunk/1.2/+download/loggerhead-1.2.tar.gz"

=== removed directory 'loggerhead/sqlobject-history'
=== removed file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2007-01-05 16:09:43 +0000
+++ loggerhead/static/css/style.css	1970-01-01 00:00:00 +0000
@@ -1,625 +0,0 @@
-
-/* from launchpad */
-body {
-    background-color: #fcfcfc;
-    color: black;
-    font-family: "Lucida Grande", "Trebuchet MS", sans-serif;
-    font-size: 12pt;
-    padding: 0px;
-    text-align: left;
-}
-
-a {
-    text-decoration: none;
-    color: #000088;
-}
-a:hover {
-    color: black;
-}
-
-img {
-    border: none;
-}
-
-h1 {
-    color: #708a96;
-    font-weight: normal;
-    font-size: 1.6em;
-    margin-bottom: 1.5em;
-}
-h1 .filename {
-    font-family: monospace;
-}
-
-.branch-name {
-    color: #47626e;
-}
-
-.footer {
-	margin-top: 1em;
-	margin-bottom: 1em;
-}
-.footer .banner {
-	margin-right: 5px;
-}
-.footer .banner img {
-	border: 1px solid #8cacbb;
-}
-
-
-/* ----- navigation bar at the top ----- */
-
-.navbar {
-}
-
-.navbar table, .bar table {
-    width: 100%;
-}
-
-.bar {
-    background-color: #dee7ec;
-    border: 1px solid #8cacbb;
-    font-size: smaller;
-    padding-top: 0px;
-    padding-bottom: 0px;
-}
-
-/* revision navigation buttons (the ones at the top right) */
-.navbuttons {
-    padding: 2px;
-    bottom: 0px;
-    text-align: right;
-    width: auto;
-    border-left: 1px dotted #8cacbb;
-    padding-left: 0.5em;
-    padding-right: 0.5em;
-}
-
-.navbuttons a {
-    font-weight: normal;
-    margin-left: 2px;
-    margin-right: 2px;
-}
-
-.navbuttons a:hover {
-    padding: 0;
-    color: blue;
-}
-
-/* navigation button in the pages (the ones at the top left, and bottom) */
-.buttons {
-}
-
-.buttons a,.buttons .search {
-    font-weight: normal;
-    color: #000088;
-    font-size: 12pt;
-    padding-left: 10px;
-    padding-right: 7px;
-    border-right: 1px dotted #8cacbb;
-}
-
-.buttons a:hover,.rbuttons a:hover {
-    font-weight: normal;
-    color: blue;
-}
-
-.feed img {
-    vertical-align: text-top;
-}
-
-.rbuttons a {
-    font-weight: normal;
-    color: #000088;
-    font-size: 12pt;
-    padding-right: 7px;
-    padding-left: 10px;
-    border-left: 1px dotted #8cacbb;
-    text-align: right;
-    width: auto;
-}
-
-/* ----- revision display in various places ----- */
-
-.revision .revno {
-    font-weight: bold;
-}
-
-.revision .revid {
-    font-family: monospace;
-    font-size: smaller;
-    padding-left: 1em;
-}
-
-.revision .log {
-    font-size: smaller;
-}
-
-
-/* ---- sub-links underneath the headline on some pages ----- */
-
-div.links {
-    padding-top: 0.5em;
-    padding-left: 3em;
-    font-size: 50%;
-}
-
-div.links div {
-    margin-bottom: 3px;
-}
-
-
-/* ----- list of merge points for a revision ----- */
-
-.info-entry {
-    font-size: smaller;
-    margin-bottom: 2em;
-    padding: 0px;
-    background-color: #f4f5f8;
-    border: 1px solid #8cacbb;
-    width: 60%;
-}
-
-.info-entry th {
-    background-color: #dee7ec;
-    font-weight: normal;
-    color: black;
-    text-align: right;
-    vertical-align: top;
-
-    padding-left: 0.5em;
-    padding-right: 0.5em;
-    padding-top: 2px;
-    padding-bottom: 2px;
-}
-
-.info-entry td {
-    font-weight: normal;
-    padding-left: 0.5em;
-    padding-top: 2px;
-    padding-bottom: 2px;
-}
-
-
-/* ----- changelog page ----- */
-
-.hide-all {
-    font-size: smaller;
-}
-
-/* secret css-jutsu to make hidden margins vanish on a table */
-.log-entries table {
-    border-collapse: collapse;
-    width: 100%;
-}
-
-.log-entries .revision-header {
-    background-color: #dee7ec;
-    padding: 3px;
-    width: 80%;
-    margin-top: 1em;
-    margin-left: 1em;
-}
-
-.log-entries .revision-header td.expand-button {
-    width: 20px;
-}
-
-.log-entries .revision-header .revision-number {
-    width: 6em;
-    padding-left: 0.5em;
-}
-
-.log-entries .revision-header .inventory-link {
-    font-size: smaller;
-    vertical-align: middle;
-    width: 4em;
-    text-align: right;
-    padding-right: 0.5em;
-}
-
-.log-entries .revision-details-block {
-    width: 80%;
-    border: none;
-    margin-left: 8em;
-    margin-bottom: 1.5em;
-}
-
-.log-entries .revision-details table {
-    font-size: smaller;
-    width: 100%;
-}
-
-.log-entries .revision-details th {
-    width: 8em;
-    text-align: right;
-    padding-right: 0.5em;
-    vertical-align: top;
-}
-
-.log-entries .revision-details td.date {
-/*    font-family: monospace; */
-}
-
-.log-entries .revision-details th.files {
-    padding-top: 1em;
-}
-
-.log-entries .revision-details td.files {
-    padding-top: 1em;
-}
-
-.log-entries .revision-details td.files .filename {
-    font-family: monospace;
-}
-
-.log-entries .revision-details td.files .jump {
-    font-size: smaller;
-}
-
-.log-entries .revision-details th.description {
-    padding-top: 1em;
-}
-.log-entries .revision-details td.description {
-    font-family: monospace;
-    padding-top: 1em;
-}
-
-/* default state: hide all */
-.show-button { display: none; }
-.hidden-details { display: none; }
-.hide-all#hide-all { display: none; }
-
-
-/* ----- revision page ----- */
-
-.revision-info {
-    border: none;
-    font-size: smaller;
-    margin-bottom: 1em;
-    padding: 0;
-    background-color: #f4f5f8;
-    border: 1px solid #8cacbb;
-    width: 80%;
-}
-
-/* secret css-jutsu to make hidden margins vanish on a table */
-.revision-info table {
-    border-collapse: collapse;
-    width: 100%;
-}
-
-.revision-info th {
-    background-color: #dee7ec;
-    color: black;
-    font-weight: normal;
-    text-align: right;
-    vertical-align: top;
-    
-    padding-left: 0.5em;
-    padding-right: 0.5em;
-    padding-top: 2px;
-    padding-bottom: 2px;
-}
-
-.revision-info td {
-    font-weight: normal;
-    padding-left: 0.5em;
-    padding-top: 2px;
-    padding-bottom: 2px;
-}
-
-.revision-info table td.date {
-    font-family: monospace;
-}
-
-.revision-info table td.description {
-    font-family: monospace;
-}
-
-.revision-info table td.files .filename {
-    font-family: monospace;
-}
-
-.revision-info table td.files a.jump {
-    font-size: smaller;
-}
-    
-.revision-info table tr.divider {
-    border-top: 1px solid #8cacbb;
-}
-
-
-/* ----- overly complex diff display ----- */
-
-.diff {
-    margin-bottom: 1em;
-    padding-top: 10px;
-    width: 100%;
-    background-color: #fcfcfc;
-    font-family: monospace;
-}
-
-
-.diff-block {
-    border-collapse: collapse;
-    width: 100%;
-    margin-bottom: 1em;
-}
-
-.diff-block th.filename {
-    font-family: monospace;
-    font-weight: normal;
-    font-size: smaller;
-    padding-left: 1em;
-    padding-top: 1em;
-    padding-bottom: 1em;
-    text-align: left;
-    background-color: #dee7ec;
-}
-
-.diff-block .diff-chunk {
-    font-size: 66%;
-    margin-top: 0px;
-    margin-bottom: 2em;
-}
-
-.diff-block th.lineno {
-    font-weight: bold;
-    border-bottom: 1px solid #8cacbb;
-    border-top: 1px solid #dee7ec;
-}
-
-.diff-block .diff-spacing {
-	line-height: 1em;
-}
-
-.diff-insert {
-    background-color: #b0efb0;
-}
-.diff-delete {
-    background-color: #ffa0a0;
-}
-.diff-chunk td.text {
-    padding-left: 1em;
-}
-
-.diff-key {
-    margin-top: 20px;
-    font-size: smaller;
-    line-height: 1em;
-    padding-left: 1em;
-}
-
-.diff-key-block {
-    width: 0.7em;
-    height: 0.7em;
-    border: 1px solid #8cacbb;
-    margin-right: 5em;
-}
-
-.diff-key .label {
-    position: relative;
-    left: 1.3em;
-    top: -1em;
-    line-height: 1em;
-}
-
-.diff .lineno {
-    color: purple;
-    background-color: #dee7ec; 
-    width: 4em;
-    text-align: right;
-    padding-right: 3px;
-    border-bottom: 1px solid #8cacbb;
-}
-.diff .lineno-skip {
-    width: 4em;
-    background-color: #dee7ec; 
-}
-.diff .info {
-    color: blue;
-    background-color: #dee7ec;
-    margin-top: 15px;
-}
-
-
-/* ----- file inventory ----- */
-
-.inventory-path {
-    margin-top: 2em;
-}
-
-table.inventory {
-    border-collapse: collapse;
-    width: 80%;
-    font-size: smaller;
-    margin-top: 1em;
-    border: 1px solid #8cacbb;
-}
-
-table.inventory td {
-    padding-top: 3px;
-    padding-bottom: 3px;
-    vertical-align: middle;
-}
-
-table.inventory th {
-    background-color: #8cacbb;
-    padding-top: 3px;
-    padding-bottom: 3px;
-    text-align: left;
-}
-
-table.inventory th.permissions {
-    padding-left: 0.5em;
-}
-
-.parity0 { background-color: #dee7ec; }
-.parity1 { background-color: #eff8fd; }
-
-.inventory td.permissions {
-    font-family: monospace;
-    width: 9em;
-    padding-left: 0.5em;
-}
-
-.inventory td.filename {
-    font-family: monospace;
-}
-
-.inventory td.size {
-	font-family: monospace;
-	font-size: smaller;
-	width: 5em;
-}
-
-.inventory td.revision {
-    width: 8em;
-    padding-right: 1.5em;
-}
-
-.inventory td.date {
-    font-family: monospace;
-    font-size: smaller;
-    width: 10em;
-    padding-right: 1.5em;
-}
-
-.inventory td.changes-link {
-    width: 6em;
-    font-size: smaller;
-}
-
-.inventory td.download-link {
-    width: 8em;
-    font-size: smaller;
-}
-
-span.folder {
-    font-family: monospace;
-}
-
-
-/* ----- file annotation ----- */
-
-.annotate-path {
-    font-family: monospace;
-}
-
-.annotate table {
-    border-collapse: collapse;
-    width: 100%;
-    font-size: 66%;
-}
-
-.annotate td {
-    padding-top: 2px;
-    padding-bottom: 2px;
-    vertical-align: bottom;
-}
-
-.annotate td.lineno {
-    font-family: monospace;
-    text-align: right;
-    width: 4em;
-    padding-right: 5px;
-    font-weight: bold;
-    border-bottom: 1px solid #8cacbb;
-}
-
-.annotate td.revno {
-    font-family: monospace;
-    text-align: right;
-    width: 8em;
-    padding-right: 5px;
-    border-right: 1px solid #8cacbb;
-}
-
-.annotate td.text {
-    font-family: monospace;
-    padding-left: 1em;
-}
-
-.annotate th {
-    background-color: #8cacbb;
-    padding-top: 3px;
-    padding-bottom: 3px;
-    text-align: left;
-}
-
-.annotate th.lineno {
-    text-align: right;
-}
-
-.annotate th.revision {
-    text-align: right;
-    padding-right: 5px;
-}
-
-.annotate th.text {
-    padding-left: 1em;
-}
-
-
-/* ----- top-level browse page ----- */
-
-.browse-project-name {
-    background-color: #dee7ec;
-    padding-top: 5px;
-    padding-bottom: 5px;
-    margin-left: 1em;
-    margin-right: 1em;
-    padding-left: 1em;
-    width: 90%;
-    font-weight: bold;
-}
-
-.browse-project-description {
-	padding-top: 1em;
-	padding-bottom: 1em;
-	margin-left: 2em;
-    width: 90%;
-}
-	
-.browse-view {
-	margin-top: 1em;
-	margin-bottom: 1em;
-	margin-left: 2em;
-}
-
-.browse-view table {
-    border-collapse: collapse;
-    width: 90%;
-    margin-bottom: 2em;
-}
-
-.browse-view table tr.heading {
-    background-color: #8cacbb;
-    border-bottom: solid 1px #8cacbb;
-    font-size: smaller;
-}
-
-.browse-view td,.browse-view th {
-	padding: 0.25em 0.5em 0.25em 0.5em;
-}
-
-.browse-view td.name {
-	width: 15%;
-}
-
-.browse-view td.last-update {
-	font-size: smaller;
-	width: 15%;
-}
-
-.browse-view td.url {
-	font-family: monospace;
-	font-size: smaller;
-	padding-left: 3em;
-	padding-top: 0px;
-}
-
-.browse-view td.feed {
-	width: 1%;
-}

=== added file 'loggerhead/static/css/zptstyle.css'
--- loggerhead/static/css/zptstyle.css	1970-01-01 00:00:00 +0000
+++ loggerhead/static/css/zptstyle.css	2008-06-11 03:53:53 +0000
@@ -0,0 +1,670 @@
+
+/* from launchpad */
+body {
+    background-color: #fcfcfc;
+    color: black;
+    font-family: "Lucida Grande", "Trebuchet MS", sans-serif;
+    font-size: 12pt;
+    padding: 0px;
+    text-align: left;
+}
+
+a {
+    text-decoration: none;
+    color: #000088;
+}
+a:hover {
+    color: black;
+}
+
+img {
+    border: none;
+}
+
+h1 {
+    color: #708a96;
+    font-weight: normal;
+    font-size: 1.6em;
+    margin-bottom: 0em;
+}
+h1 .filename {
+    font-family: monospace;
+}
+
+.branch-name {
+    color: #47626e;
+}
+
+.footer {
+    margin-top: 1em;
+    margin-bottom: 1em;
+}
+.footer .banner {
+    margin-right: 5px;
+}
+.footer .banner img {
+    border: 1px solid #8cacbb;
+}
+
+.collapse-triangle {
+    padding-right: 0.5em;
+}
+
+.hide-all {
+    font-size: smaller;
+    padding: 0.25em 0.75em 0.25em 0.75em;
+}
+
+
+
+/* ----- navigation bar at the top ----- */
+
+.navbar {
+}
+
+.bar table {
+    width: 100%;
+    border-collapse: collapse;
+}
+
+/* safari gives forms a big default margin, to vex me */
+.bar form {
+    margin: 0px;
+}
+
+.bar {
+    background-color: #dee7ec;
+    border: 1px solid #8cacbb;
+    font-size: smaller;
+    padding-top: 0px;
+    padding-bottom: 0px;
+}
+
+/* revision navigation buttons (the ones at the top right) */
+.navbuttons {
+    padding: 2px;
+    bottom: 0px;
+    text-align: right;
+    width: auto;
+    border-left: 1px dotted #8cacbb;
+    padding-left: 0.5em;
+    padding-right: 0.5em;
+}
+
+.navbuttons a {
+    font-weight: normal;
+    margin-left: 2px;
+    margin-right: 2px;
+}
+
+.navbuttons a:hover {
+    padding: 0;
+    color: blue;
+}
+
+/* navigation button in the pages (the ones at the top left, and bottom) */
+.buttons {
+}
+
+.buttons a,.buttons .search {
+    font-weight: normal;
+    color: #000088;
+    font-size: 12pt;
+    padding-left: 10px;
+    padding-right: 7px;
+    border-right: 1px dotted #8cacbb;
+}
+
+.buttons a:hover,.rbuttons a:hover {
+    font-weight: normal;
+    color: blue;
+}
+
+.feed img {
+    vertical-align: text-top;
+}
+
+.rbuttons a {
+    font-weight: normal;
+    color: #000088;
+    font-size: 12pt;
+    padding-right: 7px;
+    padding-left: 10px;
+    border-left: 1px dotted #8cacbb;
+    text-align: right;
+    width: auto;
+}
+
+
+/* ----- revision display in various places ----- */
+
+.revision .revno {
+    font-weight: bold;
+}
+
+.revision .revid {
+    font-family: monospace;
+    font-size: smaller;
+    padding-left: 1em;
+}
+
+.revision .log {
+    font-size: smaller;
+}
+
+
+/* ---- sub-links underneath the headline on some pages ----- */
+
+div.links {
+    color: #708a96;
+    padding-top: 0.5em;
+    padding-left: 3em;
+    font-size: 0.8em;
+    margin-bottom: 2em;
+}
+
+div.links div {
+    margin-bottom: 3px;
+}
+
+
+/* ----- list of merge points for a revision ----- */
+
+.info-entry {
+    font-size: smaller;
+    margin-bottom: 2em;
+    padding: 0px;
+    background-color: #f4f5f8;
+    border: 1px solid #8cacbb;
+    width: 60%;
+}
+
+.info-entry th {
+    background-color: #dee7ec;
+    font-weight: normal;
+    color: black;
+    text-align: right;
+    vertical-align: top;
+
+    padding-left: 0.5em;
+    padding-right: 0.5em;
+    padding-top: 2px;
+    padding-bottom: 2px;
+}
+
+.info-entry td {
+    font-weight: normal;
+    padding-left: 0.5em;
+    padding-top: 2px;
+    padding-bottom: 2px;
+}
+
+
+/* ----- changelog page ----- */
+
+/* secret css-jutsu to make hidden margins vanish on a table */
+.log-entries {
+    border-collapse: collapse;
+    width: 98%;
+    margin-top: 0.5em;
+    margin-left: 1em;
+    font-size: 1em;
+}
+
+.log-entries .log-header {
+    background-color: #8cacbb;
+    padding-top: 3px;
+    padding-bottom: 3px;
+    text-align: left;
+}
+
+.log-entries .revision-header {
+    font-size: normal;
+}
+
+.log-entries .revision-header td {
+    padding-top: 2px;
+    padding-bottom: 2px;
+}
+
+.log-entries .revision-header td.expand-button {
+    width: 20px;
+}
+
+.log-entries .revision-number {
+    padding-left: 0.5em;
+}
+
+.log-entries .revision-header td.date {
+    font-size: smaller;
+}
+
+.log-entries .revision-header td.author {
+    font-size: smaller;
+    padding-right: 0.5em;
+}
+
+.log-entries .revision-header .inventory-link {
+    font-size: smaller;
+    vertical-align: middle;
+    text-align: left;
+    padding-right: 0.5em;
+}
+
+.log-entries table.revision-details {
+    font-size: smaller;
+    margin-bottom: 1.0em;
+}
+
+.log-entries table.revision-details th {
+    text-align: right;
+    padding-right: 0.5em;
+    vertical-align: top;
+}
+
+.log-entries table.revision-details td.files .filename {
+    font-family: monospace;
+}
+
+td.files {
+    padding-top: 0em;
+    padding-bottom: 0em;
+}
+th.files {
+    padding-top: 0em;
+    padding-bottom: 0em;
+}
+
+.log-entries .revision-details td.files .jump {
+    font-size: smaller;
+}
+
+.log-entries .revision-details td.description {
+    font-family: monospace;
+}
+
+/* default state: hide all */
+.revision-header .hide-button { display: none; }
+.hidden-details { display: none; }
+.changelog .collapse-cl-hideall { display: none; }
+
+
+/* ----- revision page ----- */
+
+.revision-info {
+    border: none;
+    margin-bottom: 1em;
+    padding: 0;
+    background-color: #f4f5f8;
+    border: 1px solid #8cacbb;
+    width: 80%;
+}
+
+/* secret css-jutsu to make hidden margins vanish on a table */
+.revision-info table {
+    border-collapse: collapse;
+    width: 100%;
+}
+
+.revision-info th {
+    background-color: #dee7ec;
+    color: black;
+    font-weight: normal;
+    text-align: right;
+    vertical-align: top;
+    font-size: 0.8em;
+    padding-left: 0.5em;
+    padding-right: 0.5em;
+    padding-top: 2px;
+    padding-bottom: 2px;
+}
+
+.revision-info td {
+    font-weight: normal;
+    font-size: 0.8em;
+    padding-left: 0.5em;
+    padding-top: 2px;
+    padding-bottom: 2px;
+}
+
+.revision-info table td.date {
+    font-family: monospace;
+    font-size: 1em;
+}
+
+.revision-info table td.description {
+    font-family: monospace;
+    font-size: 1em;
+}
+
+.revision-info table td.files {
+    font-family: monospace;
+    font-size: 1em;
+}
+
+.revision-info table td.files a.jump {
+    font-size: smaller;
+}
+    
+.revision-info table tr.divider {
+    border-top: 1px solid #8cacbb;
+}
+
+
+/* ----- overly complex diff display ----- */
+
+.diff {
+    margin-bottom: 1em;
+    padding-top: 10px;
+    width: 100%;
+    background-color: #fcfcfc;
+    font-family: monospace;
+}
+
+
+.diff-block {
+    border-collapse: collapse;
+    width: 100%;
+    margin-bottom: 1em;
+}
+
+.diff-block th.filename {
+    font-family: monospace;
+    font-weight: normal;
+    font-size: 1em;
+    padding-left: 1em;
+    padding-top: 1em;
+    padding-bottom: 1em;
+    text-align: left;
+    background-color: #dee7ec;
+}
+
+.diff-block .diff-chunk {
+    font-size: 0.9em;
+    margin-top: 0px;
+    margin-bottom: 2em;
+}
+
+.diff-block th.lineno {
+    font-weight: bold;
+    border-bottom: 1px solid #8cacbb;
+    border-top: 1px solid #dee7ec;
+}
+
+.diff-block .diff-spacing {
+    line-height: 1em;
+}
+
+.diff-option-buttons {
+    margin-top: 1.0em;
+    margin-bottom: 1.0em;
+    border-collapse: collapse;
+}
+.diff-option-buttons td {
+    line-height: 1em;
+    height: 1em;
+    vertical-align: middle;
+    padding: 0px;
+}
+.diff-option-buttons .label {
+    font-size: smaller;
+    padding-left: 0.75em;
+    padding-right: 2em;
+    line-height: 1em;
+}
+.diff-option-buttons .spacey {
+    padding-right: 5em;
+}
+
+.diff-option-buttons .collapse-file-showall { display: none; }
+
+.diff-block .show-button { display: none; }
+.collapse-style-unified-content { display: none; }
+.collapse-style-sbs-show { display: none; }
+
+.diff-insert {
+    background-color: #9cc8ff;
+}
+.diff-delete {
+    background-color: #ffa0a0;
+}
+.diff-chunk td.text {
+    padding-left: 1em;
+}
+
+.diff-key {
+    display: inline;
+    font-size: smaller;
+}
+
+.diff-key-block {
+    width: 1em;
+    height: 1em;
+    border: 1px solid #8cacbb;
+}
+
+.diff-key .label {
+    padding-right: 2em;
+}
+
+.diff .lineno {
+    color: purple;
+    background-color: #dee7ec; 
+    width: 4em;
+    text-align: right;
+    padding-right: 3px;
+    border-bottom: 1px solid #8cacbb;
+}
+.diff .lineno-skip {
+    width: 4em;
+    background-color: #dee7ec;
+}
+.diff .info {
+    color: blue;
+    background-color: #dee7ec;
+    margin-top: 15px;
+}
+/*
+.diff-context-skip {
+    background-color: #dee7ec;
+}*/
+
+
+/* ----- file inventory ----- */
+
+.inventory-path {
+    margin-top: 2em;
+}
+
+table.inventory {
+    border-collapse: collapse;
+    width: 100%;
+    font-size: smaller;
+    margin-top: 1em;
+    border: 1px solid #8cacbb;
+}
+
+table.inventory td {
+    padding-top: 3px;
+    padding-bottom: 3px;
+    vertical-align: middle;
+}
+
+table.inventory th {
+    background-color: #8cacbb;
+    padding-top: 3px;
+    padding-bottom: 3px;
+    text-align: left;
+}
+
+table.inventory th.permissions {
+    padding-left: 0.5em;
+}
+
+.parity0 { background-color: #dee7ec; }
+.parity1 { background-color: #eff8fd; }
+
+.inventory td.permissions {
+    font-family: monospace;
+    padding-left: 0.5em;
+    width: 9em;
+}
+
+.inventory td.filename {
+    font-family: monospace;
+}
+
+.inventory td.size {
+    font-family: monospace;
+    font-size: smaller;
+    width: 5em;
+}
+
+.inventory td.revision {
+    padding-right: 1em;
+    text-align: left;
+    width: 8em;
+}
+
+.inventory td.date {
+    padding-right: 1em;
+    width: 11em;
+}
+
+.inventory td.changes-link {
+    font-size: smaller;
+    width: 6em;
+}
+
+.inventory td.download-link {
+    font-size: smaller;
+    width: 8em;
+}
+
+span.folder {
+    font-family: monospace;
+}
+
+
+/* ----- file annotation ----- */
+
+.annotate-path {
+    font-family: monospace;
+}
+
+.annotate table {
+    border-collapse: collapse;
+    width: 100%;
+    font-size: 66%;
+}
+
+.annotate td {
+    padding-top: 2px;
+    padding-bottom: 2px;
+    vertical-align: bottom;
+}
+
+.annotate td.lineno {
+    font-family: monospace;
+    text-align: right;
+    width: 4em;
+    padding-right: 5px;
+    font-weight: bold;
+    border-bottom: 1px solid #8cacbb;
+}
+
+.annotate td.revno {
+    font-family: monospace;
+    text-align: right;
+    width: 8em;
+    padding-right: 5px;
+    border-right: 1px solid #8cacbb;
+}
+
+.annotate td.text {
+    font-family: monospace;
+    padding-left: 1em;
+}
+
+.annotate th {
+    background-color: #8cacbb;
+    padding-top: 3px;
+    padding-bottom: 3px;
+    text-align: left;
+}
+
+.annotate th.lineno {
+    text-align: right;
+}
+
+.annotate th.revision {
+    text-align: right;
+    padding-right: 5px;
+}
+
+.annotate th.text {
+    padding-left: 1em;
+}
+
+
+/* ----- top-level browse page ----- */
+
+.browse-project-name {
+    background-color: #dee7ec;
+    padding-top: 5px;
+    padding-bottom: 5px;
+    margin-left: 1em;
+    margin-right: 1em;
+    padding-left: 1em;
+    width: 90%;
+    font-weight: bold;
+}
+
+.browse-project-description {
+	padding-top: 1em;
+	padding-bottom: 1em;
+	margin-left: 2em;
+    width: 90%;
+}
+	
+.browse-view {
+	margin-top: 1em;
+	margin-bottom: 1em;
+	margin-left: 2em;
+}
+
+.browse-view table {
+    border-collapse: collapse;
+    width: 90%;
+    margin-bottom: 2em;
+}
+
+.browse-view table tr.heading {
+    background-color: #8cacbb;
+    border-bottom: solid 1px #8cacbb;
+    font-size: smaller;
+}
+
+.browse-view td,.browse-view th {
+    padding: 0.25em 0.5em 0.25em 0.5em;
+}
+
+.browse-view td.name {
+    width: 20%;
+}
+
+.browse-view td.last-update {
+    font-size: smaller;
+    width: 20em;
+}
+
+.browse-view td.url {
+    font-family: monospace;
+    font-size: smaller;
+    padding-left: 3em;
+    padding-top: 0px;
+}
+
+.browse-view td.feed {
+	width: 16px;
+}

=== added file 'loggerhead/static/images/nav-small-in.gif'
Binary files loggerhead/static/images/nav-small-in.gif and loggerhead/static/images/nav-small-in.gif differ
=== added file 'loggerhead/static/images/nav-small-out.gif'
Binary files loggerhead/static/images/nav-small-out.gif and loggerhead/static/images/nav-small-out.gif differ
=== added file 'loggerhead/static/javascript/collapse.js'
--- loggerhead/static/javascript/collapse.js	1970-01-01 00:00:00 +0000
+++ loggerhead/static/javascript/collapse.js	2008-06-11 02:26:38 +0000
@@ -0,0 +1,126 @@
+
+/* reusable implementation of expand/collapse buttons, used to show/hide
+ * "more detailed" sections of the page.
+ */
+
+
+var collapse_cache = new Object();
+var collapse_all_cache = new Object();
+
+function cacheElement(group, name, remainder, element) {
+    var g = collapse_cache[group];
+    if (typeof(g) == "undefined") {
+        g = new Object();
+        collapse_cache[group] = g;
+    }
+    var n = g[name];
+    if (typeof(n) == "undefined") {
+        n = new Array();
+        g[name] = n;
+    }
+    n.push(new Array(remainder, element));
+}
+
+function cacheAllElement(group, name, element) {
+    var g = collapse_all_cache[group];
+    if (typeof(g) == "undefined") {
+        g = new Array();
+        collapse_all_cache[group] = g;
+    }
+    g.push(new Array(name, element));
+}
+
+/*
+ * cache all the elements that have a collapse-<group>-<name>-* class on them.
+ * javascript can be very slow so this should make the UI more responsive.
+ */
+function sortCollapseElements() {
+    var elements = document.getElementsByTagName("*");
+    for (var i = 0; i < elements.length; i++) {
+        var classes = elements[i].className.split(' ');
+        for (var j = 0; j < classes.length; j++) {
+            if (classes[j].indexOf("collapse-") == 0) {
+                var segments = classes[j].split('-');
+                if (segments.length == 4) {
+                    cacheElement(segments[1], segments[2], segments[3], elements[i]);
+                }
+                if (segments.length == 3) {
+                    cacheAllElement(segments[1], segments[2], elements[i]);
+                }
+            }
+        }
+    }
+}
+
+
+function collapseContent(group, name) {
+    return 'collapse-' + group + '-' + name + '-content';
+}
+
+function collapseDisplay(group, name, display) {
+    // display mode for the disclosure triangles:
+    var dthide = 'inline', dtshow = 'none';
+    if (display == 'none') { dthide = 'none'; dtshow = 'inline'; }
+
+    var elements = collapse_cache[group][name];
+    for (var i in elements) {
+        var kind = elements[i][0], node = elements[i][1];
+        if (kind == "show") {
+            node.style.display = dtshow;
+        } else if (kind == "hide") {
+            node.style.display = dthide;
+        } else if (kind == "content") {
+            node.style.display = display;
+        }
+    }
+}
+
+function collapseAllDisplay(group, display) {
+    for (var name in collapse_cache[group]) {
+        collapseDisplay(group, name, display);
+    }
+    
+    var dthide = 'inline', dtshow = 'none';
+    if (display == 'none') { dthide = 'none'; dtshow = 'inline'; }
+    for (var element in collapse_all_cache[group]) {
+        var x = collapse_all_cache[group][element];
+        var name = x[0], node = x[1];
+        if (name == "showall") {
+            node.style.display = dtshow;
+        } else if (name == "hideall") {
+            node.style.display = dthide;
+        }
+    }
+}
+
+
+// for debugging
+function debug(s) {
+    var d = new Date();
+    var hh = d.getHours(), mm = d.getMinutes(), ss = d.getSeconds(), ms = d.getMilliseconds();
+    var ds = ((hh < 10) ? "0" + hh : hh) + ":" + ((mm < 10) ? "0" + mm : mm) + ":" + ((ss < 10) ? "0" + ss : ss) + "." + ((ms < 10) ? "00" + ms : ((ms < 100) ? "0" + ms : ms));
+    console.log("[" + ds + "] " + s);
+}
+
+function diff_url(url) {
+    if (document.cookie.indexOf('diff=unified') >= 0) {
+        this.location.href = url + "-u";
+    } else {
+        this.location.href = url + "-s";
+    }
+}
+
+function show_sbs() {
+	collapseDisplay('style', 'sbs', 'table');
+	collapseDisplay('style', 'unified', 'none');
+	document.cookie='diff=sbs';
+}
+function show_unified() {
+	collapseDisplay('style', 'unified', 'table');
+	collapseDisplay('style', 'sbs', 'none');
+	document.cookie='diff=unified';
+}
+function load() {
+	sortCollapseElements();
+	if (document.cookie.indexOf('diff=unified') >= 0) { show_unified(); }
+}

=== added file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	1970-01-01 00:00:00 +0000
+++ loggerhead/templatefunctions.py	2008-06-20 02:26:54 +0000
@@ -0,0 +1,61 @@
+import os
+from loggerhead.zptsupport import zpt
+
+templatefunctions = {}
+def templatefunc(func):
+    templatefunctions[func.__name__] = func
+    return func
+
+
+_base = os.path.dirname(__file__)
+def _pt(name):
+    return zpt(os.path.join(_base, 'templates', name + '.pt'))
+
+
+templatefunctions['macros'] = _pt('macros').macros
+
+@templatefunc
+def file_change_summary(url, entry, modified_file_link):
+    return _pt('revisionfilechanges').expand(
+        url=url, entry=entry, modified_file_link=modified_file_link,
+        **templatefunctions)
+
+@templatefunc
+def revisioninfo(url, branch, entry, modified_file_link=None):
+    from loggerhead import util
+    return _pt('revisioninfo').expand(
+        url=url, change=entry, branch=branch, util=util,
+        modified_file_link=modified_file_link,
+        **templatefunctions)
+
+@templatefunc
+def collapse_button(group, name, branch, normal='block'):
+    return _pt('collapse-button').expand(
+        group=group, name=name, normal=normal, branch=branch,
+        **templatefunctions)
+
+@templatefunc
+def collapse_all_button(group, branch, normal='block'):
+    return _pt('collapse-all-button').expand(
+        group=group, normal=normal, branch=branch,
+        **templatefunctions)
+
+@templatefunc
+def revno_with_nick(entry):
+    if entry.branch_nick:
+        extra = ' ' + entry.branch_nick
+    else:
+        extra = ''
+    return '(%s%s)'%(entry.revno, extra)
+
+@templatefunc
+def modified_file_link_rev(url, entry, item):
+    return _pt('modified-file-link-rev').expand(
+        url=url, entry=entry, item=item,
+        **templatefunctions)
+
+@templatefunc
+def modified_file_link_log(url, entry, item):
+    return _pt('modified-file-link-log').expand(
+        url=url, entry=entry, item=item,
+        **templatefunctions)

=== removed file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2006-12-20 09:29:42 +0000
+++ loggerhead/templates/annotate.kid	1970-01-01 00:00:00 +0000
@@ -1,42 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
-    py:extends="'master.kid'">
-<head>
-    <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> ${branch.friendly_name} : contents of ${path} at revision ${change.revno} </title>
-</head>
-
-<body>
-
-${navbar()}
-
-<h1> <span class="branch-name">${branch.friendly_name}</span> : <span class="annotate-path">${path}</span> (revision ${change.revno})
-	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ])}"> browse files </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', start_revid=revid)}"> view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', start_revid=revid, file_id=file_id)}"> view changes to this file </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> view/download file </a> </div>
-	</div>
-</h1>
-
-<div class="annotate">
-    <table>
-        <tr>
-            <th class="lineno"> Line# </th>
-            <th class="revision"> Revision </th>
-            <th class="text"> Contents </th>
-        </tr>
-
-        <tr py:for="line in contents" class="parity${line.parity}">
-            <td class="lineno ${line.status}"> ${line.lineno} </td>
-            <td class="revno ${line.status}">
-                <a py:if="line.status=='changed'" href="${branch.url('/revision', start_revid=line.change.revid, file_id=file_id)}"
-                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
-            </td>
-            <td class="text ${line.status}"> ${XML(line.text)} </td>
-        </tr>
-    </table>
-</div>
-
-</body>
-</html>

=== added file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/annotate.pt	2008-06-18 08:42:36 +0000
@@ -0,0 +1,69 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
+          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+  <head>
+    <title metal:fill-slot="title"
+           tal:content="string:${branch/friendly_name} : contents of ${path}
+                        at revision ${change/revno}">
+    </title>
+  </head>
+
+  <body>
+
+    <h1 metal:fill-slot="heading">
+      <span class="branch-name" tal:content="branch/friendly_name"></span>
+      :
+      <span class="annotate-path" tal:content="path"></span>
+      (revision <tal:revno content="change/revno"></tal:revno>)
+    </h1>
+
+    <div metal:fill-slot="content">
+      <div class="links">
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/files', change.revno], clear=1)">browse files</a>
+        </div>
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/revision'], clear=1, start_revid=change.revno)">view revision</a>
+        </div>
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/changes'], clear=1, start_revid=change.revno, filter_file_id=file_id)">view changes to this file</a>
+        </div>
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/download', change.revno, file_id, filename])">download file</a>
+        </div>
+      </div>
+
+      <div class="annotate">
+        <table>
+          <tr>
+            <th class="lineno"> Line# </th>
+            <th class="revision"> Revision </th>
+            <th class="text"> Contents </th>
+          </tr>
+
+          <tr tal:repeat="line contents"
+              tal:attributes="class string:parity${line/parity}">
+            <td tal:attributes="class string:lineno ${line/status}">
+              <a tal:attributes="name string:L${line/lineno}"
+                 tal:content="line/lineno"></a>
+            </td>
+            <td tal:attributes="class string:revno ${line/status}">
+              <a tal:condition="python:line.status=='changed'"
+                 tal:content="python:util.trunc(line.change.revno)"
+                 tal:attributes="href python:url(['/revision'], clear=1, start_revid=line.change.revno, filter_file_id=file_id);
+                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, util.hide_email(line.change.author), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
+            </td>
+            <td tal:attributes="class string:text ${line/status}"
+                tal:content="line/text">
+            </td>
+          </tr>
+        </table>
+      </div>
+
+    </div>
+  </body>
+</html>

=== removed file 'loggerhead/templates/atom.kid'
--- loggerhead/templates/atom.kid	2006-12-20 21:24:32 +0000
+++ loggerhead/templates/atom.kid	1970-01-01 00:00:00 +0000
@@ -1,18 +0,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<feed xmlns="http://www.w3.org/2005/Atom" xmlns:py="http://purl.org/kid/ns#">
-    <title> bazaar changes for ${branch.friendly_name} </title>
-    <updated>${updated}</updated>
-    <id>${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}</id>
-    <link rel="self" href="${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}" />
-
-	<entry py:for="entry in changes">
-	    <title> ${entry.revno}: ${entry.short_comment} </title>
-	    <updated>${entry.date.isoformat() + 'Z'}</updated>
-	    <id>${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}</id>
-	    <author> <name> ${util.hide_email(entry.author)} </name> </author>
-	    <content type="text">
-            ${entry.comment}
-	    </content>
-	    <link rel="alternate" href="${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}" />
-	</entry>
-</feed>

=== added file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/atom.pt	2008-06-11 04:41:08 +0000
@@ -0,0 +1,31 @@
+<?xml version="1.0" encoding="utf-8"?>
+<feed xmlns="http://www.w3.org/2005/Atom" xmlns:tal="http://xml.zope.org/namespaces/tal">
+  <title>
+    bazaar changes for <tal:branch-name content="branch/friendly_name">branch name</tal:branch-name>
+  </title>
+  <updated tal:content="updated">${updated}</updated>
+  <id tal:content="python:branch.url(['atom'])">url</id>
+  <link rel="self" tal:attributes="href python:branch.url([''])" />
+
+  <entry tal:repeat="entry changes">
+    <title tal:content="string: ${entry/revno}: ${entry/short_comment}">
+      ${entry/revno}: ${entry/short_comment}
+    </title>
+    <updated tal:content="entry/date/isoformat">
+    Z
+    </updated>
+    <id tal:content="python:branch.url(['revision', entry.revno])">
+      ID
+    </id>
+    <author>
+      <name tal:content="python:util.hide_email(entry.author)">
+        author
+      </name>
+    </author>
+    <content type="text" tal:content="entry/comment">
+      comment
+    </content>
+    <link rel="alternate"
+          tal:attributes="href python:branch.url(['revision', entry.revno])" />
+  </entry>
+</feed>

=== removed file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2007-01-05 16:09:43 +0000
+++ loggerhead/templates/browse.kid	1970-01-01 00:00:00 +0000
@@ -1,51 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
-    py:extends="'master.kid'">
-<head>
-    <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> loggerhead branches </title>
-</head>
-
-<body>
-
-<h1>
-    <span py:if="title">${title}</span>
-    <span py:if="not title"> bazaar branches in loggerhead </span>
-</h1>
-
-<div class="browse-project" py:for="project in projects">
-    <div class="browse-project-name">
-        ${project.friendly_name}
-    </div>
-    
-    <div class="browse-project-description" py:if="len(project.long_description) > 0">
-    ${XML(project.long_description)}
-    </div>
-    
-    <div class="browse-view">
-        <table>
-        <tr class="heading">
-            <th> Name </th>
-            <th> Description </th>
-            <th> Last change </th>
-            <th />
-        </tr>
-        <span py:for="view in project.views">
-            <tr>
-            <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
-            <td class="description"> ${view.description} </td>
-            <td class="last-update"> <!--${view.last_updated().strftime('%d %b %Y')} &nbsp;--> ${util.ago(view.last_updated())} </td>
-            <td class="feed"> <a href="${tg.url(['/' + project.name, view.name, 'atom'])}"><img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a></td>
-            </tr>
-            <tr py:if="view.branch_url is not None">
-                <td class="name"> </td>
-                <td class="description url" colspan="2"> <a href="${view.branch_url}">${view.branch_url}</a> </td>
-            </tr>
-        </span>
-        </table>
-    </div>
-
-</div>
-
-</body>
-</html>

=== added file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/browse.pt	2008-06-18 04:16:21 +0000
@@ -0,0 +1,87 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+  <head>
+    <title metal:fill-slot="title">
+      loggerhead branches
+    </title>
+  </head>
+
+  <body>
+
+    <h1 metal:fill-slot="heading" style="padding-bottom: 1em">
+      <tal:title condition="title" content="title">
+        ${title}
+      </tal:title>
+      <tal:no-title condition="not:title">
+        bazaar branches in loggerhead
+      </tal:no-title>
+    </h1>
+
+    <div metal:fill-slot="content">
+      <div class="browse-project"
+           tal:repeat="project projects">
+        <div class="browse-project-name"
+             tal:content="project/friendly_name">
+          ${project.friendly_name}
+        </div>
+
+        <div class="browse-project-description"
+             tal:condition="python:len(project.long_description) > 0"
+             tal:content="structure project/long_description">
+          ${XML(project.long_description)}
+        </div>
+
+        <div class="browse-view">
+          <table>
+            <tr class="heading">
+              <th>
+                Name
+              </th>
+              <th>
+                Description
+              </th>
+              <th>
+                Last change
+              </th>
+              <th />
+            </tr>
+            <tal:block repeat="view project/views">
+              <tr>
+                <td class="name">
+                  <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)"
+                     tal:content="view/friendly_name">
+                    ${view.friendly_name}
+                  </a>
+                </td>
+                <td class="description"
+                    tal:content="view/description">
+                  ${view.description}
+                </td>
+                <td class="last-update"
+                    tal:content="python:view.history.has_revisions and util._approximatedate(view.last_updated()) or '(no revisions)'"></td>
+                <td class="feed">
+                  <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name + '/atom')"
+                     title="atom feed">
+                    <img tal:attributes="src python:branch.static_url('/static/images/feed-icon-16x16.gif')"
+                         alt="atom feed" />
+                  </a>
+                </td>
+              </tr>
+              <tr tal:condition="view/branch_url">
+                <td class="name">
+                </td>
+                <td class="description url" colspan="2">
+                  <a tal:attributes="href view/branch_url"
+                     tal:content="view/branch_url">
+                    ${view.branch_url}
+                  </a>
+                </td>
+              </tr>
+            </tal:block>
+          </table>
+        </div>
+
+      </div>
+    </div>
+  </body>
+</html>

=== removed file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2006-12-21 00:29:58 +0000
+++ loggerhead/templates/changelog.kid	1970-01-01 00:00:00 +0000
@@ -1,166 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
-    py:extends="'master.kid'">
-<head>
-    <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> ${branch.friendly_name} : changes </title>
-    <link rel="alternate" type="application/atom+xml" href="${branch.url('/atom')}" title="RSS feed for ${branch.friendly_name}" />
-    
-    <span py:def="loglink(revid, text)">
-        <a title="Show history" href="${branch.url('/changes', start_revid=revid)}" class="revlink"> ${text} </a>
-    </span>
-
-    <span py:def="file_link(filename, file_id, revid)">
-        <a href="${branch.url([ '/annotate', revid ], file_id=file_id)}" title="Annotate ${filename}">${filename}</a>
-    </span>
-
-    <!-- this is totally matty's fault.  i don't like javacsript. ;) -->
-    <script type="text/javascript"> // <!--
-    function displayDetails(name, hide, show) {
-        if (show == '') { show = 'inline'; }
-        var bhide = hide, ihide = hide;
-        if (hide == '') { bhide = 'block'; ihide = 'inline'; }
-        document.getElementById('details-' + name).style.display = bhide;
-        document.getElementById('hide-' + name).style.display = ihide;
-        document.getElementById('show-' + name).style.display = show;
-    }
-    function displayAll(hide, show) {
-        if (show == '') { show = 'inline'; }
-        var bhide = hide, ihide = hide;
-        if (hide == '') { bhide = 'block'; ihide = 'inline'; }
-        var nodes = document.getElementsByTagName('div');
-        for (var i = 0; i < nodes.length; i++) {
-            var id = nodes[i].id;
-            if ((id.length > 8) && (id.substring(0, 8) == 'details-')) {
-                nodes[i].style.display = bhide;
-                var revno = id.substring(8);
-                document.getElementById('hide-' + revno).style.display = ihide;
-                document.getElementById('show-' + revno).style.display = show;
-            }
-        }
-        document.getElementById('hide-all').style.display = ihide;
-        document.getElementById('show-all').style.display = show;
-    }
-    // -->
-	</script>
-</head>
-
-<body>
-
-${navbar()}
-
-<h1> <span class="branch-name">${branch.friendly_name}</span> : changes
-<span py:if="file_id"> to <span class="filename">${history.get_path(revid, file_id)}</span></span>
-<span py:if="viewing_from"> from ${history.get_revno(start_revid)} </span>
-<span py:if="query"> matching "${query}"</span>
-</h1>
-
-<span py:if="search_failed">
-    Sorry, no results found for your search.
-</span>
-
-<span py:if="not search_failed">
-<a class="hide-all" id="hide-all" href="javascript:displayAll('none', '')"> (hide all) </a>
-<a class="hide-all" id="show-all" href="javascript:displayAll('', 'none')"> (show all) </a>
-</span>
-
-<div class="log-entries">
-    <div py:for="entry in changes" class="revision">
-        <a name="entry-${entry.revno}" />
-        <div class="revision-header">
-            <table>
-                <tr>
-                    <td class="revision-number"> ${revlink_q(entry.revid, start_revid, file_id, query, util.trunc(entry.revno))} </td>
-                    <td class="expand-button">
-                        <a href="javascript:displayDetails('${entry.revno}', 'none', '')" id="hide-${entry.revno}" class="show-button">
-                            <img src="${tg.url('/static/images/nav-small-down.gif')}" width="10" height="10" />
-                        </a>
-                        <a href="javascript:displayDetails('${entry.revno}', '', 'none')" id="show-${entry.revno}" class="hide-button">
-                        	<img src="${tg.url('/static/images/nav-small-right.gif')}" witdh="10" height="10" />
-                        </a>
-                    </td>
-					<td class="summary"> ${revlink_q(entry.revid, start_revid, file_id, query, entry.short_comment)} </td>
-					<td class="inventory-link"> <a href="${branch.url([ '/files', entry.revid ])}">&#8594; files</a> </td>
-				</tr>
-			</table>
-        </div>
-        
-        <div class="revision-details-block">
-            <div class="revision-details">
-			    <table>
-			        <tr>
-			            <th class="author">committed by:</th>
-			            <td class="author"> ${util.hide_email(entry.author)} </td>
-			        </tr>
-			        <tr>
-			            <th class="date">date:</th>
-			            <td class="date"> ${entry.date.strftime('%d %b %Y %H:%M')} &nbsp; (${util.ago(entry.date)}) </td>
-			        </tr>
-			    </table>
-			</div>
-	        <div class="revision-details hidden-details" id="details-${entry.revno}">
-		        <table>
-			        <tr py:if="len(entry.merge_points) > 0">
-			            <th class="children"> merged in: </th>
-			            <td class="children">
-			                <span py:for="child in entry.merge_points">
-			                    ${loglink(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br />
-			                </span>
-			            </td>
-			        </tr>
-			        <tr py:if="len(entry.parents) > 1">
-			        	<th class="parents"> merged from: </th>
-			        	<td class="parents">
-			        	    <span py:for="parent in entry.parents"><span py:if="parent.revid != entry.parents[0].revid">
-			        	        ${loglink(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
-			        	    </span></span>
-			        	</td>
-			        </tr>
-
-			        <tr py:if="entry.changes.added">
-			            <th class="files"> files added: </th>
-			            <td class="files"> <span py:for="filename, fid in entry.changes.added" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
-			        </tr>
-			        <tr py:if="entry.changes.removed">
-			            <th class="files"> files removed: </th>
-			            <td class="files"> <span py:for="filename, fid in entry.changes.removed" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
-			        </tr>
-			        <tr py:if="entry.changes.renamed">
-			            <th class="files"> files renamed: </th>
-			            <td class="files"> <span py:for="old_filename, new_filename, fid in entry.changes.renamed" class="filename">
-			                ${file_link(old_filename, fid, entry.revid)} => ${file_link(new_filename, fid, entry.revid)}<br />
-			            </span> </td>
-			        </tr>
-			        <tr py:if="entry.changes.modified">
-			            <th class="files"> files modified: </th>
-			            <td class="files"> <span py:for="item in entry.changes.modified">
-			                <span class="filename">${file_link(item.filename, item.file_id, entry.revid)}</span> &nbsp;
-			                <a href="${branch.url([ '/revision', entry.revid ], start_revid=start_revid, file_id=file_id, query=query) + '#' + item.filename}" class="jump">&#8594; diff</a>
-			                <br />
-			            </span> </td>
-			        </tr>
-			        <tr>
-			            <th class="description">description:</th>
-		                <td class="description"><span py:for="line in entry.comment_clean">${XML(line)} <br /></span> </td>
-		            </tr>
-		        </table>
-	    	</div>
-        </div>
-    </div>
-</div>
-
-<div py:if="navigation.prev_page_revid or navigation.next_page_revid" class="bar">
-    <table>
-        <tr>
-        	<td class="buttons">
-            	<a py:if="navigation.prev_page_revid" href="${navigation.prev_page_url}"> &lt;&lt; page </a>
-	 		</td>
- 			<td class="rbuttons" align="right">
-            	<a py:if="navigation.next_page_revid" href="${navigation.next_page_url}"> page &gt;&gt; </a>
- 			</td>
- 		</tr>
- 	</table>
-</div>
-
-</body>
-</html>

=== added file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/changelog.pt	2008-06-20 02:20:05 +0000
@@ -0,0 +1,192 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<tal:block define="onload string:sortCollapseElements()">
+  <html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+    <head>
+      <title metal:fill-slot="title"
+             tal:content="string:${branch/friendly_name} : changes">
+        ${branch.friendly_name} : changes
+      </title>
+      <metal:block fill-slot="header_extras">
+        <link rel="alternate" type="application/atom+xml"
+              tal:attributes="href python:url(['/atom']);
+                              title string:RSS feed for ${branch/friendly_name}"
+              />
+
+        <script type="text/javascript"
+                tal:attributes="src python:branch.static_url('/static/javascript/collapse.js')">
+        </script>
+      </metal:block>
+    </head>
+
+    <body>
+
+      <h1 style="margin-bottom: 1em" metal:fill-slot="heading">
+        <span class="branch-name" tal:content="branch/friendly_name">
+          ${branch.friendly_name}
+        </span>
+        : changes
+        <tal:block condition="filter_file_id">
+          to
+          <span class="filename"
+                tal:content="python:history.get_path(revid, filter_file_id)">
+          </span>
+        </tal:block>
+        <tal:block condition="viewing_from">
+          from <tal:block content="python:history.get_revno(start_revid)" />
+        </tal:block>
+        <tal:block condition="query">
+          matching <tal:block content="query" />
+        </tal:block>
+      </h1>
+
+      <div metal:fill-slot="content">
+
+        <p tal:condition="search_failed">
+          Sorry, no results found for your search.
+        </p>
+
+        <p tal:condition="not:changes">
+          No revisions!
+        </p>
+
+        <p tal:condition="changes"
+           class="changelog">
+          <tal:b content="structure python:collapse_all_button('cl', branch)" />
+        </p>
+
+        <table class="log-entries"
+               tal:define="subcolspan python:4-bool(all_same_author)">
+          <tr class="log-header">
+            <th class="revision-number">
+              Rev
+            </th>
+            <th>
+            </th>
+            <th class="summary">
+              Summary
+            </th>
+            <th tal:condition="not:all_same_author"
+                class="author">
+              Committer
+            </th>
+            <th class="date" colspan="2">
+              Date
+            </th>
+          </tr>
+          <tal:block tal:repeat="entry changes">
+            <a tal:attributes="name string:entry-${entry/revno}" />
+            <tr tal:attributes="class string:revision-header parity${entry/parity}">
+              <td class="revision-number">
+                <a tal:attributes="title python:'Show revision '+entry.revno;
+                                   href  python:url(['/revision', entry.revno])"
+                   tal:content="python:util.trunc(entry.revno)">
+                  text
+                </a>
+              </td>
+              <td class="expand-button" tal:define="name entry/revno"
+                  tal:content="structure python:collapse_button('cl', entry.revno, branch)">
+              </td>
+              <td class="summary">
+                <a tal:attributes="title python:'Show revision '+entry.revno;
+                                   href  python:url(['/revision', entry.revno])"
+                   tal:content="entry/short_comment">
+                  text
+                </a>
+              </td>
+              <td tal:condition="not:all_same_author"
+                  tal:content="python:util.trunc(util.hide_email(entry.author), 20)"
+                  class="author"></td>
+              <td class="date">
+                  <span tal:attributes="title python:util.date_time(entry.date)"
+                        tal:content="python:util._approximatedate(entry.date)"></span>
+              </td>
+              <td class="inventory-link">
+                <a tal:attributes="href python:branch.url(['/files', entry.revno]);
+                                   title string:Files at revision ${entry/revno}">
+                  files
+                </a>
+              </td>
+            </tr>
+
+            <tr tal:attributes="class string:revision-details-block parity${entry/parity}">
+              <td colspan="2">
+              </td>
+              <td tal:attributes="colspan subcolspan">
+                <table tal:attributes="class string:revision-details hidden-details collapse-cl-${entry/revno}-content">
+                  <tr tal:repeat="merge_point entry/merge_points">
+                    <th class="children">
+                      <tal:block condition="repeat/merge_point/start">
+                        merged in:
+                      </tal:block>
+                    </th>
+                    <td class="children">
+                      <a title="Show history"
+                         tal:attributes="href python:url(['/changes'], start_revid=merge_point.revno)"
+                         tal:content="python:revno_with_nick(merge_point)">
+                        class="revlink">
+                        ${text}
+                      </a>
+                    </td>
+                  </tr>
+                  <tr tal:repeat="parent python:entry.parents[1:]">
+                    <th class="parents">
+                      <tal:block condition="repeat/parent/start">
+                        merged from:
+                      </tal:block>
+                    </th>
+                    <td class="parents">
+                      <a title="Show history"
+                         tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
+                         tal:content="python:revno_with_nick(parent)">
+                        class="revlink">
+                        ${text}
+                      </a>
+                    </td>
+                  </tr>
+                  <tr tal:condition="all_same_author">
+                    <th class="author">
+                      committed by:
+                    </th>
+                    <td class="author" tal:content="python:util.hide_email(entry.author)">
+                      ${util.hide_email(entry.author)}
+                    </td>
+                  </tr>
+                  <tr>
+                    <th class="description">
+                      description:
+                    </th>
+                    <td class="description">
+                      <tal:block repeat="line entry/comment_clean"
+                                 content="structure string:${line}&lt;br /&gt;" />
+                    </td>
+                  </tr>
+                  <tal:block content="structure python:file_change_summary(url, entry, modified_file_link_log)" />
+                </table>
+              </td>
+            </tr>
+          </tal:block>
+        </table>
+
+        <div tal:condition="python:navigation.prev_page_revid or navigation.next_page_revid"
+             class="bar">
+          <table>
+            <tr>
+              <td class="buttons">
+                <a tal:condition="navigation/prev_page_revid"
+                   tal:attributes="href navigation/prev_page_url">
+                  &lt;&lt; page
+                </a>
+	      </td>
+ 	      <td class="rbuttons" align="right">
+                <a tal:condition="navigation/next_page_revid"
+                   tal:attributes="href navigation/next_page_url">
+                  page &gt;&gt;
+                </a>
+ 	      </td>
+ 	    </tr>
+          </table>
+        </div>
+      </div>
+    </body>
+  </html>
+</tal:block>

=== added file 'loggerhead/templates/collapse-all-button.pt'
--- loggerhead/templates/collapse-all-button.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/collapse-all-button.pt	2008-06-16 10:13:40 +0000
@@ -0,0 +1,16 @@
+<tal:block>
+  <a tal:attributes="class string:hide-all collapse-${group}-hideall;
+                     href string:javascript:collapseAllDisplay('${group}','none')">
+    <img tal:attributes="src python:branch.static_url('/static/images/nav-small-down.gif')"
+         width="10" height="10" alt="collapse"
+         class="collapse-triangle" />
+    collapse all
+  </a>
+  <a tal:attributes="class string:hide-all collapse-${group}-showall;
+                     href string:javascript:collapseAllDisplay('${group}','${normal}')">
+    <img tal:attributes="src python:branch.static_url('/static/images/nav-small-right.gif')"
+         width="10" height="10" alt="expand"
+         class="collapse-triangle" />
+    expand all
+  </a>
+</tal:block>

=== added file 'loggerhead/templates/collapse-button.pt'
--- loggerhead/templates/collapse-button.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/collapse-button.pt	2008-06-16 10:13:40 +0000
@@ -0,0 +1,16 @@
+<tal:block>
+  <a tal:attributes="href string:javascript:collapseDisplay('${group}','${name}','none');
+                     class string:hide-button collapse-${group}-${name}-hide"
+     title="collapse">
+    <img tal:attributes="src python:branch.static_url('/static/images/nav-small-down.gif')"
+         width="10" height="10" alt="collapse"
+         class="collapse-triangle" />
+  </a>
+  <a tal:attributes="href string:javascript:collapseDisplay('${group}','${name}','${normal}');
+                     class string:show-button collapse-${group}-${name}-show"
+     title="expand">
+    <img tal:attributes="src python:branch.static_url('/static/images/nav-small-right.gif')"
+         witdh="10" height="10" alt="expand"
+         class="collapse-triangle" />
+  </a>
+</tal:block>

=== removed file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2006-12-29 02:24:03 +0000
+++ loggerhead/templates/inventory.kid	1970-01-01 00:00:00 +0000
@@ -1,96 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
-    py:extends="'master.kid'">
-<head>
-    <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> ${branch.friendly_name} : files for revision ${change.revno} </title>
-</head>
-
-<body>
-
-${navbar()}
-
-<h1> <span class="branch-name">${branch.friendly_name}</span> : files for revision ${change.revno}
-	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', start_revid=revid)}"> view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', start_revid=revid)}"> view branch changes </a> </div>
-	</div>
-</h1>
-
-<!-- !FIXME: this is just copied verbatim from revision.kid -->
-<div class="revision-info">
-    <table>
-        <tr>
-            <th class="author">committed by:</th>
-            <td class="author"> ${util.hide_email(change.author)} </td>
-        </tr>
-        <tr>
-            <th class="date">date:</th>
-            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
-        </tr>
-
-        <tr py:if="len(change.merge_points) > 0">
-            <th class="children"> merged in: </th>
-            <td class="children">
-                <span py:for="child in change.merge_points">
-                    ${revlink(child.revid, child.revid, None, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br />
-                </span>
-            </td>
-        </tr>
-        <tr py:if="len(change.parents) > 1">
-        	<th class="parents"> merged from: </th>
-        	<td class="parents">
-        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-        	        ${revlink(parent.revid, parent.revid, None, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
-        	    </span></span>
-        	</td>
-        </tr>
-
-        <tr>
-            <th class="description">description:</th>
-            <td class="description"><span py:for="line in change.comment_clean">${XML(line)} <br /></span></td>
-        </tr>
-    </table>
-</div>
-
-<div class="inventory-path">
-    <b>folder:</b> <span class="folder"> ${path} </span>
-</div>
-
-<table class="inventory" width="100%">
-    <tr class="header">
-        <th class="permissions"> Permissions </th>
-        <th> <a href="${branch.url([ '/files', revid ], file_id=file_id, sort='filename')}">Filename</a> </th>
-        <th> <a href="${branch.url([ '/files', revid ], file_id=file_id, sort='size')}">Size</a> </th>
-        <th> Last change </th>
-        <th> <a href="${branch.url([ '/files', revid ], file_id=file_id, sort='date')}">When</a> </th>
-        <th> History </th>
-        <th> Download </th>
-    </tr>
-    
-    <tr class="parity1" py:if="updir">
-        <td class="permissions">drwxr-xr-x</td>
-        <td class="filename directory"><a href="${branch.url([ '/files', revid ], file_id=updir_file_id)}"> (up) </a></td>
-        <td> </td> <td> </td> <td> </td> <td> </td>
-    </tr>
-
-    <tr py:for="file in filelist" class="parity${file.parity}">
-        <td class="permissions"> ${util.fake_permissions(file.kind, file.executable)} </td>
-        <td class="filename ${file.kind}">
-            <a py:if="file.kind=='directory'" href="${branch.url([ '/files', revid ], file_id=file.file_id)}">${file.filename}/</a>
-            <span py:if="file.kind=='symlink'">${file.filename}@</span>
-            <a py:if="file.kind=='file'" href="${branch.url([ '/annotate', revid ], file_id=file.file_id)}" title="Annotate ${file.filename}">${file.filename}</a>
-        </td>
-        <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
-        <td class="revision"> ${revlink(file.revid, file.revid, file.file_id, util.trunc(file.change.revno, 15))} </td>
-        <td class="date"> ${file.change.date.strftime('%d %b %Y %H:%M')} </td>
-        <td class="changes-link"> 
-            <a href="${branch.url('/changes', start_revid=file.revid, file_id=file.file_id)}" title="Changes from ${file.change.revno} affecting ${file.filename}"> &#8594; changes </a>
-        </td>
-        <td class="download-link">
-            <a href="${branch.url([ '/download', file.revid, file.file_id, file.filename ])}" title="Download ${file.filename} at revision ${file.change.revno}"> &#8594; download </a></td>
-    </tr>
-</table>
-
-</body>
-</html>

=== added file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/inventory.pt	2008-06-20 02:13:34 +0000
@@ -0,0 +1,134 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+  <head>
+    <title metal:fill-slot="title"
+           tal:content="string:${branch/friendly_name} : files for revision ${change/revno}">
+      ${branch.friendly_name} : files for revision ${change.revno}
+    </title>
+  </head>
+  <body>
+
+    <h1 metal:fill-slot="heading">
+      <span class="branch-name" tal:content="branch/friendly_name">
+        ${branch.friendly_name}
+      </span>
+      : files for revision
+      <tal:revno content="change/revno">
+        ${change.revno}
+      </tal:revno>
+    </h1>
+
+    <div metal:fill-slot="content">
+      <div class="links">
+        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/revision', change.revno], clear=1, start_revid=change.revno)">
+	    view revision </a>
+        </div>
+        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/changes', change.revno], clear=1, start_revid=change.revno)">
+	    view branch changes </a>
+        </div>
+      </div>
+
+      <tal:revision-info replace="structure python:revisioninfo(url, branch, change)" />
+
+      <div class="inventory-path">
+        <b>folder:</b> <span class="folder" tal:content="path"> ${path} </span>
+      </div>
+
+      <table class="inventory" width="100%">
+        <tr class="header">
+          <th class="permissions">
+            Permissions
+          </th>
+          <th>
+            <a tal:attributes="href python:url(['/files', revid], sort='filename')">Filename</a>
+          </th>
+          <th>
+            Latest Rev
+          </th>
+          <th>
+            <a tal:attributes="href python:url(['/files', revid], sort='date')">Last Changed</a>
+          </th>
+          <th>
+            <a tal:attributes="href python:url(['/files', revid], sort='size')">Size</a>
+          </th>
+          <th>
+          </th>
+          <th>
+          </th>
+        </tr>
+
+        <tr class="parity1" tal:condition="python:updir">
+          <td class="permissions">drwxr-xr-x</td>
+          <td class="filename directory">
+            <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)">
+              (up)
+            </a>
+          </td>
+          <td>
+          </td>
+          <td>
+          </td>
+          <td>
+          </td>
+          <td>
+          </td>
+        </tr>
+
+        <tr tal:repeat="file filelist"
+            tal:attributes="class string:parity${file/parity}">
+          <td class="permissions" tal:content="python:util.fake_permissions(file.kind, file.executable)">
+            ${}
+          </td>
+          <td tal:attributes="class string:filename ${file/kind}">
+            <a tal:condition="python:file.kind=='directory'"
+               tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)"
+               tal:content="string:${file/filename}/">
+              ${file.filename}/
+            </a>
+            <span tal:condition="python:file.kind=='symlink'"
+                  tal:content="string:${file/filename}@">
+              ${file.filename}@
+            </span>
+            <a tal:condition="python:file.kind=='file'"
+               tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id);
+                               title string:Annotate ${file/filename}"
+               tal:content="string:${file/filename}">
+              ${file.filename}
+            </a>
+          </td>
+          <td class="revision">
+            <a tal:attributes="href python:url(['/revision', file.change.revno], filter_file_id=file.file_id);
+                               title string:Show revision ${file/change/revno}"
+               tal:content="python:util.trunc(file.change.revno, 15)">
+              ${text}
+            </a>
+          </td>
+          <td class="date"
+              tal:content="python:util.date_time(file.change.date)">
+            ${}
+          </td>
+          <td class="size">
+            <span tal:condition="python:file.kind=='file'"
+                  tal:content="python:util.human_size(file.size)">
+              ${util.human_size(file.size)}
+            </span>
+          </td>
+          <td class="changes-link">
+            <a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
+                               title string:Changes affecting ${file/filename}">
+              changes
+            </a>
+          </td>
+          <td class="download-link">
+            <a tal:condition="python:file.kind=='file'"
+               tal:attributes="href python:url(['/download', file.revid, file.file_id, file.filename]);
+                               title string:Download ${file/filename} at revision ${file/change/revno}">
+              download
+            </a>
+          </td>
+        </tr>
+      </table>
+    </div>
+
+  </body>
+</html>

=== removed file 'loggerhead/templates/login.kid'
--- loggerhead/templates/login.kid	2006-12-11 06:44:19 +0000
+++ loggerhead/templates/login.kid	1970-01-01 00:00:00 +0000
@@ -1,113 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
-    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml"
-    xmlns:py="http://purl.org/kid/ns#"
-    py:extends="'master.kid'">
-
-<head>
-    <meta content="text/html; charset=UTF-8"
-        http-equiv="content-type" py:replace="''"/>
-    <title>Login</title>
-    <style type="text/css">
-        #loginBox
-        {
-            width: 30%;
-            margin: auto;
-            margin-top: 10%;
-            padding-left: 10%;
-            padding-right: 10%;
-            padding-top: 5%;
-            padding-bottom: 5%;
-            font-family: verdana;
-            font-size: 10px;
-            background-color: #eee;
-            border: 2px solid #ccc;
-        }
-
-        #loginBox h1
-        {
-            font-size: 42px;
-            font-family: "Trebuchet MS";
-            margin: 0;
-            color: #ddd;
-        }
-
-        #loginBox p
-        {
-            position: relative;
-            top: -1.5em;
-            padding-left: 4em;
-            font-size: 12px;
-            margin: 0;
-            color: #666;
-        }
-
-        #loginBox table
-        {
-            table-layout: fixed;
-            border-spacing: 0;
-            width: 100%;
-        }
-
-        #loginBox td.label
-        {
-            width: 33%;
-            text-align: right;
-        }
-
-        #loginBox td.field
-        {
-            width: 66%;
-        }
-
-        #loginBox td.field input
-        {
-            width: 100%;
-        }
-
-        #loginBox td.buttons
-        {
-            text-align: right;
-        }
-
-    </style>
-</head>
-
-<body>
-    <div id="loginBox">
-        <h1>Login</h1>
-        <p>${message}</p>
-        <form action="${previous_url}" method="POST">
-            <table>
-                <tr>
-                    <td class="label">
-                        <label for="user_name">User Name:</label>
-                    </td>
-                    <td class="field">
-                        <input type="text" id="user_name" name="user_name"/>
-                    </td>
-                </tr>
-                <tr>
-                    <td class="label">
-                        <label for="password">Password:</label>
-                    </td>
-                    <td class="field">
-                        <input type="password" id="password" name="password"/>
-                    </td>
-                </tr>
-                <tr>
-                    <td colspan="2" class="buttons">
-                        <input type="submit" name="login" value="Login"/>
-                    </td>
-                </tr>
-            </table>
-
-            <input py:if="forward_url" type="hidden" name="forward_url"
-                value="${forward_url}"/>
-                
-            <input py:for="name,value in original_parameters.items()"
-                type="hidden" name="${name}" value="${value}"/>
-        </form>
-    </div>
-</body>
-</html>

=== added file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/macros.pt	2008-06-16 11:38:05 +0000
@@ -0,0 +1,86 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
+          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" metal:define-macro="main">
+  <head>
+    <meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
+
+    <title metal:define-slot="title">
+      Title.
+    </title>
+
+    <link rel="stylesheet"
+          tal:attributes="href python:branch.static_url('/static/css/zptstyle.css')" />
+
+    <metal:block metal:define-slot="header_extras" />
+  </head>
+
+  <body tal:attributes="onload onload|nothing">
+
+    <div class="bar" tal:condition="navigation|nothing">
+      <form tal:attributes="action python:branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None), file_id=getattr(navigation, 'file_id', None))">
+        <table>
+          <tr>
+            <td>
+              <span class="buttons">
+                <a tal:attributes="href python:url('/changes', clear=1)"> changes </a>
+                <a tal:attributes="href python:url('/files', clear=1)"> files </a>
+                <span class="search">
+                  search: <input type="text" name="q" />
+                </span>
+              </span>
+            </td>
+            <td align="right" tal:condition="navigation/revid_list|nothing">
+              <span tal:condition="navigation/feed" class="rbuttons feed">
+                <a tal:attributes="href python:url(['/atom'])">
+                  <img tal:attributes="src python:branch.static_url('/static/images/feed-icon-16x16.gif')" />
+                </a>
+              </span>
+              <span class="navbuttons">
+                <a tal:condition="navigation/prev_page_revid"
+                   tal:attributes="href navigation/prev_page_url"
+                   title="Previous page">
+                  &#171;
+                </a>
+                <tal:arrow condition="not:navigation/prev_page_revid">
+                  &#171;
+                </tal:arrow>
+                revision <tal:b content="python:history.get_revno(revid)" />
+                (<tal:b condition="python:navigation.pagesize > 1">page </tal:b>
+                <tal:b content="navigation/page_position" /> / <tal:b content="navigation/page_count" />)
+                <a tal:condition="navigation/next_page_revid"
+                   tal:attributes="href navigation/next_page_url"
+                   title="Next page">
+                  &#187;
+                </a>
+                <tal:arrow condition="not:navigation/next_page_revid">
+                  &#187;
+                </tal:arrow>
+              </span>
+            </td>
+          </tr>
+        </table>
+      </form>
+    </div>
+
+    <h1 metal:define-slot="heading">
+      Heading
+    </h1>
+
+    <div metal:define-slot="content">
+      Content.
+    </div>
+
+    <div class="footer">
+      <span class="banner">
+        <a href="http://www.bazaar-vcs.org/">
+          <img tal:attributes="src python:branch.static_url('/static/images/bazaar-banner.png')" />
+        </a>
+      </span>
+      <span class="banner">
+        <a href="http://www.lag.net/loggerhead/">
+          <img tal:attributes="src python:branch.static_url('/static/images/loggerhead-banner.png')" />
+        </a>
+      </span>
+    </div>
+  </body>
+</html>

=== removed file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2006-12-20 21:17:53 +0000
+++ loggerhead/templates/master.kid	1970-01-01 00:00:00 +0000
@@ -1,67 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<?python import sitetemplate ?>
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#" py:extends="sitetemplate">
-
-<head py:match="item.tag=='{http://www.w3.org/1999/xhtml}head'" py:attrs="item.items()">
-    <meta content="text/html; charset=UTF-8" http-equiv="content-type" py:replace="''"/>
-    <title py:replace="''">Your title goes here</title>
-    <meta py:replace="item[:]"/>
-    <style type="text/css" media="screen">
-@import "${tg.url('/static/css/style.css')}";
-    </style>
-
-<!-- !define common navbar -->
-<span py:def="navbar()">
-    <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
-    <div class="navbar" py:if="navigation is not None">
-        <div class="bar">
-            <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
-            <form action="${branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None), file_id=getattr(navigation, 'file_id', None))}">
-            <table>
-                <tr><td>
-                    <span class="buttons">
-                        <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                        <a href="${branch.url('/changes')}"> changes </a>
-                        <a href="${branch.url('/files')}"> files </a>
-                        <span class="search"> search: <input type="text" name="q" /> </span>
-                    </span>
-                </td><td align="right" py:if="hasattr(navigation, 'revid_list')">
-                    <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
-                        <a href="${branch.url('/atom')}"><img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
-                    </span>
-                    <span class="navbuttons">
-                    	<span py:if="navigation.prev_page_revid"> <a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>	</span>
-                    	<span py:if="not navigation.prev_page_revid"> &#171; </span>
-                        	revision ${history.get_revno(revid)} (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
-                    	<span py:if="navigation.next_page_revid"> <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>	</span>
-                    	<span py:if="not navigation.next_page_revid"> &#187; </span>
-                    </span>
-                </td></tr>
-            </table>
-            </form>
-        </div>
-    </div>
-</span>
-
-<span py:def="revlink(revid, start_revid, file_id, text)">
-    <a title="Show revision ${history.get_revno(revid)}" href="${branch.url([ '/revision', revid ], start_revid=start_revid, file_id=file_id)}" class="revlink"> ${text} </a>
-</span>
-<span py:def="revlink_q(revid, start_revid, file_id, query, text)">
-    <a title="Show revision ${history.get_revno(revid)}" href="${branch.url([ '/revision', revid ], start_revid=start_revid, file_id=file_id, q=query)}" class="revlink"> ${text} </a>
-</span>
-
-</head>
-
-<body py:match="item.tag=='{http://www.w3.org/1999/xhtml}body'" py:attrs="item.items()">
-
-    <div py:replace="[item.text]+item[:]"/>
-
-	<!-- End of main_content -->
-	
-	<div class="footer">
-	    <span class="banner"><a href="http://www.bazaar-vcs.org/"><img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
-	    <span class="banner"><a href="http://www.lag.net/loggerhead/"><img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
-	</div>
-</body>
-
-</html>

=== added file 'loggerhead/templates/modified-file-link-log.pt'
--- loggerhead/templates/modified-file-link-log.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/modified-file-link-log.pt	2008-06-19 23:02:48 +0000
@@ -0,0 +1,6 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<a tal:attributes="href python:'javascript:diff_url(\'' + url(['/revision', entry.revno]) + '#' + item.filename + '\')';
+                   title string:Annotate ${item/filename}"
+   tal:content="item/filename" class="filename">
+  item/filename
+</a>

=== added file 'loggerhead/templates/modified-file-link-rev.pt'
--- loggerhead/templates/modified-file-link-rev.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/modified-file-link-rev.pt	2008-06-11 00:02:50 +0000
@@ -0,0 +1,14 @@
+<tal:block>
+  <a class="collapse-style-sbs-content filename"
+     tal:attributes="href  string:#${item/filename}-s;
+                     title string:Jump to ${item/filename} below"
+     tal:content="item/filename" >
+    item/filename
+  </a>
+  <a class="collapse-style-unified-content filename"
+     tal:attributes="href  string:#${item/filename}-u;
+                     title string:Jump to ${item/filename} below"
+     tal:content="item/filename" >
+    item/filename
+  </a>
+</tal:block>

=== removed file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2006-12-29 02:42:07 +0000
+++ loggerhead/templates/revision.kid	1970-01-01 00:00:00 +0000
@@ -1,141 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
-    py:extends="'master.kid'">
-<head>
-    <meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-    <title> ${branch.friendly_name} : revision ${change.revno} </title>
-    
-    <span py:def="file_link(filename, file_id)">
-        <a href="${branch.url([ '/annotate', revid ], file_id=file_id)}" title="Annotate ${filename}">${filename}</a>
-    </span>
-</head>
-
-<body>
-
-${navbar()}
-
-<h1> <span class="branch-name">${branch.friendly_name}</span> : revision ${change.revno}
-	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ])}">browse files</a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', start_revid=revid)}">view branch changes</a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, 'bundle.txt' ])}">view/download patch</a> </div>
-	</div>
-</h1>
- 
-<div class="revision-info">
-    <table>
-        <tr>
-            <th class="author">committed by:</th>
-            <td class="author"> ${util.hide_email(change.author)} </td>
-        </tr>
-        <tr>
-            <th class="date">date:</th>
-            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
-        </tr>
-
-        <tr py:if="len(change.merge_points) > 0">
-            <th class="children"> merged in: </th>
-            <td class="children">
-                <span py:for="child in change.merge_points">
-                    ${revlink(child.revid, child.revid, None, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br /> 
-                </span>
-            </td>
-        </tr>
-        <tr py:if="len(change.parents) > 1">
-        	<th class="parents"> merged from: </th>
-        	<td class="parents">
-        	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-        	        ${revlink(parent.revid, parent.revid, None, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
-        	    </span></span>
-        	</td>
-        </tr>
-
-        <tr>
-            <th class="description">description:</th>
-            <td class="description"><span py:for="line in change.comment_clean">${XML(line)} <br /></span> </td>
-        </tr>
-        
-        <tr class="divider"> <th></th> <td></td> </tr>
-        
-        <tr py:if="change.changes.added">
-            <th class="files"> files added: </th>
-            <td class="files"> <span py:for="filename, file_id in change.changes.added" class="filename">${file_link(filename, file_id)} <br /></span> </td>
-        </tr>
-        <tr py:if="change.changes.removed">
-            <th class="files"> files removed: </th>
-            <td class="files"> <span py:for="filename, file_id in change.changes.removed" class="filename">${file_link(filename, file_id)} <br /></span> </td>
-        </tr>
-        <tr py:if="change.changes.renamed">
-            <th class="files"> files renamed: </th>
-            <td class="files"> <span py:for="old_filename, new_filename, file_id in change.changes.renamed" class="filename">
-                ${file_link(old_filename, file_id)} => ${file_link(new_filename, file_id)}<br />
-            </span> </td>
-        </tr>
-        <tr py:if="change.changes.modified">
-            <th class="files"> files modified: </th>
-            <td class="files">
-                <span py:for="item in change.changes.modified">
-                    <span class="filename">${file_link(item.filename, item.file_id)}</span> &nbsp; <a href="#${item.filename}" class="jump">&#8594; diff</a><br />
-                </span>
-            </td>
-        </tr>
-    </table>
-</div>
-
-<table class="diff-key" py:if="change.changes.modified"><tr>
-    <td> <div class="diff-key-block diff-insert"></div> <span class="label"> added </span> </td>
-	<td> <div class="diff-key-block diff-delete"></div> <span class="label"> removed </span> </td>
-</tr></table>
-
-<!-- ! nobody is going to care about this...
-<div class="diff-link"> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ], start_revid=start_revid, file_id=file_id, unified=1)}">view as unified diff</a> </div>
--->
-
-<div class="diff" py:if="change.changes.modified">
-    <table class="diff-block">
-        <span py:for="item in change.changes.modified">
-            <tr><th class="filename" colspan="4"> <a href="${branch.url([ '/annotate', change.revid ], file_id=item.file_id)}" name="${item.filename}">${item.filename}</a> </th></tr>
-            <!-- ! unified diff -->
-            <span py:if="not side_by_side" py:for="chunk in item.chunks">
-                <tr class="diff-chunk"> <th class="lineno">old</th> <th class="lineno">new</th> <th></th> <th></th> </tr>
-                <tr py:for="line in chunk.diff" class="diff-chunk">
-                    <td class="lineno">${line.old_lineno}</td>
-                    <td class="lineno">${line.new_lineno}</td>
-                    <td class="diff-${line.type} text">${XML(line.line)}</td>
-                    <td> </td>
-                </tr>
-                <tr class="diff-chunk-spacing"> <td colspan="4"> &nbsp; </td> </tr>
-            </span>
-            <!-- ! side-by-side diff -->
-            <span py:if="side_by_side" py:for="chunk in item.chunks">
-                <tr class="diff-chunk"> <th class="lineno">old</th> <th></th> <th class="lineno">new</th> <th></th> </tr>
-                <tr py:for="line in chunk.diff" class="diff-chunk">
-                    <td py:if="line.old_lineno" class="lineno">${line.old_lineno}</td>
-                    <td py:if="not line.old_lineno" class="lineno-skip">${line.old_lineno}</td>
-                    <td class="diff-${line.old_type}">${XML(line.old_line)}</td>
-                    <td py:if="line.new_lineno" class="lineno">${line.new_lineno}</td>
-                    <td py:if="not line.new_lineno" class="lineno-skip">${line.new_lineno}</td>
-                    <td class="diff-${line.new_type}">${XML(line.new_line)}</td>
-                </tr>
-                <tr class="diff-chunk-spacing"> <td colspan="4"> &nbsp; </td> </tr>
-            </span>
-            <tr class="diff-spacing"> <td colspan="4"> &nbsp; </td> </tr>
-        </span>
-    </table>
-</div>
-
-<div py:if="navigation.prev_page_revid or navigation.next_page_revid" class="bar">
-    <table>
-        <tr>
-        	<td class="buttons">
-            	<a py:if="navigation.prev_page_revid" href="${navigation.prev_page_url}"> &lt; revision ${history.get_revno(navigation.prev_page_revid)} </a>
-	 		</td>
- 			<td class="rbuttons" align="right">
-            	<a py:if="navigation.next_page_revid" href="${navigation.next_page_url}"> revision ${history.get_revno(navigation.next_page_revid)} &gt; </a>
- 			</td>
- 		</tr>
- 	</table>
-</div>
-
-</body>
-</html>

=== added file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/revision.pt	2008-06-20 02:20:05 +0000
@@ -0,0 +1,295 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<tal:block define="onload string:load()">
+  <html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+    <head>
+      <title metal:fill-slot="title"
+             tal:content="string:${branch/friendly_name} : revision ${change/revno}">
+        ${branch.friendly_name} : revision ${change.revno}
+      </title>
+
+      <metal:block fill-slot="header_extras">
+        <script type="text/javascript"
+                tal:attributes="src python:branch.static_url('/static/javascript/collapse.js')">
+        </script>
+      </metal:block>
+    </head>
+
+    <body>
+
+      <h1 metal:fill-slot="heading">
+        <span class="branch-name" tal:content="branch/friendly_name">
+          ${branch.friendly_name}
+        </span>
+        : revision
+        <tal:revno content="change/revno">
+          ${change.revno}
+        </tal:revno>
+        <tal:compare-to condition="python:compare_revid is not None">
+          (compared to revision <tal:b content="python:history.get_revno(compare_revid)" />)
+        </tal:compare-to>
+      </h1>
+
+      <div metal:fill-slot="content">
+        <div class="links">
+          <div>
+            <b>&#8594;</b>
+            <a tal:attributes="href python:url(['/files', change.revno])">
+              browse files at revision <tal:b content="change/revno" />
+            </a>
+          </div>
+          <div>
+            <b>&#8594;</b>
+            <a tal:attributes="href python:url(['/changes'], start_revid=change.revno)">
+              view history from revision <tal:b content="change/revno" />
+            </a>
+          </div>
+          <div tal:condition="python:compare_revid is not None" >
+            <b>&#8594;</b>
+            <a tal:attributes="href python:branch.url(['/bundle', change.revno, history.get_revno(compare_revid), 'bundle.txt'])">
+                download bundle from <tal:b content="python:history.get_revno(compare_revid)" /> to <tal:b content="change/revno" />
+            </a>
+          </div>
+          <div tal:condition="python:(remember is not None) and (compare_revid is None) and remember != revid" >
+            <b>&#8594;</b>
+            <a tal:attributes="href python:url(['/revision', change.revno], compare_revid=history.get_revno(remember))">
+              compare with revision <tal:b content="python:history.get_revno(remember)" />
+            </a>
+          </div>
+          <div  tal:condition="python:remember != revid">
+            <b>&#8594;</b>
+            <a tal:attributes="href python:url(['/revision', change.revno], remember=change.revno, compare_revid=None)">
+              compare with another revision
+            </a>
+          </div>
+          <tal:we-are-comparing condition="python:compare_revid is not None">
+            <div>
+              <b>&#8594;</b>
+              <a tal:attributes="href python:url([ '/revision', history.get_revno(compare_revid) ], remember=change.revno, compare_revid=change.revno)">
+                reverse the comparison (<tal:b content="change/revno" /> to <tal:b content="python:history.get_revno(compare_revid)" />)
+              </a>
+            </div>
+            <div>
+              <b>&#8594;</b>
+              <a tal:attributes="href python:url(['/revision', change.revno], remember=None, compare_revid=None)">
+                stop comparing with revision <tal:b content="python:history.get_revno(compare_revid)" />
+              </a>
+            </div>
+          </tal:we-are-comparing>
+        </div>
+
+        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, modified_file_link_rev)" />
+
+        <table class="diff-option-buttons">
+          <tr>
+            <td>
+              <tal:b content="structure python:collapse_all_button('file', branch, normal='table-row')" />
+            </td>
+
+            <td class="spacey">
+              <a href="javascript:show_sbs()"
+                 class="hide-all collapse-style-sbs-show"
+                 title="collapse">
+                <img tal:attributes="src python:branch.static_url('/static/images/nav-small-out.gif')"
+                     width="22" height="10" class="collapse-triangle" />
+                show side by side
+              </a>
+              <a href="javascript:show_unified()"
+                 class="hide-all collapse-style-unified-show"
+                 title="expand">
+                <img tal:attributes="src python:branch.static_url('/static/images/nav-small-in.gif')"
+                     width="22" height="10" class="collapse-triangle" />
+                show unified diff
+              </a>
+            </td>
+
+            <td class="diff-key-block diff-insert">
+            </td>
+            <td class="label">
+              added
+            </td>
+            <td class="diff-key-block diff-delete">
+            </td>
+            <td class="label">
+              removed
+            </td>
+          </tr>
+        </table>
+
+        <div class="diff"
+             tal:condition="change/changes/modified"
+             tal:define="uniqs python:{}">
+          <!-- ! side-by-side diff -->
+          <table class="diff-block collapse-style-sbs-content">
+            <tal:block repeat="item change/changes/modified">
+              <tal:u define="u python:util.uniq(uniqs, item.file_id)">
+                <tr>
+                  <th class="filename" colspan="4">
+                    <tal:b content="structure python:collapse_button('file', u, branch, normal='table-row')" />
+                    <a tal:attributes="href  python:url(['/annotate', change.revno], file_id=item.file_id);
+                                       name  string:${item/filename}-s;
+                                       title string:Annotate ${item/filename}"
+                       tal:content="item/filename">
+                      ${item.filename}
+                    </a>
+                  </th>
+                </tr>
+
+                <tal:block repeat="chunk item/sbs_chunks">
+                  <tr tal:attributes="class string:diff-chunk collapse-file-${u}-content">
+                    <th class="lineno">
+                      old
+                    </th>
+                    <th>
+                    </th>
+                    <th class="lineno">
+                      new
+                    </th>
+                    <th>
+                    </th>
+                  </tr>
+                  <tr tal:repeat="line chunk/diff"
+                      tal:attributes="class string:diff-chunk collapse-file-${u}-content">
+                    <tal:block condition="line/old_lineno">
+                      <td class="lineno"
+                          tal:content="line/old_lineno">
+                        ${line.old_lineno}
+                      </td>
+                      <td tal:attributes="class string:diff-${line/old_type}"
+                          tal:content="line/old_line">
+                        ${line.old_line}
+                      </td>
+                    </tal:block>
+                    <tal:block condition="not:line/old_lineno">
+                      <td class="lineno-skip"
+                          tal:content="line/old_lineno">
+                        ${line.old_lineno}
+                      </td>
+                      <td tal:attributes="class string:diff-${line/old_type}-skip"
+                          tal:content="line/old_line">
+                        ${line.old_line}
+                      </td>
+                    </tal:block>
+                    <tal:block condition="line/new_lineno">
+                      <td class="lineno"
+                          tal:content="line/new_lineno">
+                        ${line.new_lineno}
+                      </td>
+                      <td tal:attributes="class string:diff-${line/new_type}"
+                          tal:content="line/new_line">
+                        ${line.new_line}
+                      </td>
+                    </tal:block>
+                    <tal:block condition="not:line/new_lineno">
+                      <td class="lineno-skip"
+                          tal:content="line/new_lineno">
+                        ${line.new_lineno}
+                      </td>
+                      <td tal:attributes="class string:diff-${line/new_type}-skip"
+                          tal:content="line/new_line">
+                        ${line.new_line}
+                      </td>
+                    </tal:block>
+                  </tr>
+                  <tr tal:attributes="class string:diff-chunk-spacing collapse-file-${u}-content">
+                    <td colspan="4">
+                      &nbsp;
+                    </td>
+                  </tr>
+                </tal:block>
+                <tr class="diff-spacing">
+                  <td colspan="4">
+                    &nbsp;
+                  </td>
+                </tr>
+              </tal:u>
+            </tal:block>
+          </table>
+
+          <!-- ! unified diff -->
+          <table class="diff-block collapse-style-unified-content">
+            <tal:block repeat="item change/changes/modified">
+              <tal:u define="u python:util.uniq(uniqs, item.file_id)">
+                <tr>
+                  <th class="filename" colspan="4">
+                    <tal:b content="structure python:collapse_button('file', u, branch, normal='table-row')" />
+                    <a tal:attributes="href  python:url(['/annotate', change.revno], file_id=item.file_id);
+                                       name  string:${item/filename}-u;
+                                       title string:Annotate ${item/filename}"
+                       tal:content="item/filename">
+                      ${item.filename}
+                    </a>
+                  </th>
+                </tr>
+
+                <tal:block repeat="chunk item/chunks">
+                  <tr tal:attributes="class string:diff-chunk collapse-file-${u}-content">
+                    <th class="lineno">
+                      old
+                    </th>
+                    <th class="lineno">
+                      new
+                    </th>
+                    <th>
+                    </th>
+                    <th>
+                    </th>
+                  </tr>
+                  <tr tal:repeat="line chunk/diff"
+                      tal:attributes="class string:diff-chunk collapse-file-${u}-content">
+                    <td class="lineno"
+                        tal:content="line/old_lineno">
+                      ${line.old_lineno}
+                    </td>
+                    <td class="lineno"
+                        tal:content="line/new_lineno">
+                      ${line.new_lineno}
+                    </td>
+                    <td tal:attributes="class string:diff-${line/type} text"
+                        tal:content="line/line">
+                      ${line.line}
+                    </td>
+                    <td>
+                    </td>
+                  </tr>
+                  <tr tal:attributes="class string:diff-chunk-spacing collapse-file-${u}-content">
+                    <td colspan="4">
+                      &nbsp;
+                    </td>
+                  </tr>
+                </tal:block>
+                <tr class="diff-spacing">
+                  <td colspan="4">
+                    &nbsp;
+                  </td>
+                </tr>
+              </tal:u>
+            </tal:block>
+          </table>
+        </div>
+
+        <div tal:condition="python:navigation.prev_page_revid or navigation.next_page_revid"
+             class="bar">
+          <table>
+            <tr>
+              <td class="buttons">
+                <a tal:condition="navigation/prev_page_revid"
+                   tal:attributes="href navigation/prev_page_url">
+                  &lt; revision
+                  <tal:r content="python:history.get_revno(navigation.prev_page_revid)" />
+                </a>
+	      </td>
+ 	      <td class="rbuttons" align="right">
+                <a tal:condition="navigation/next_page_revid"
+                   tal:attributes="href navigation/next_page_url">
+                  revision
+                  <tal:r content="python:history.get_revno(navigation.next_page_revid)" />
+                  &gt;
+                </a>
+ 	      </td>
+ 	    </tr>
+          </table>
+        </div>
+      </div>
+    </body>
+  </html>
+</tal:block>

=== added file 'loggerhead/templates/revisionfilechanges.pt'
--- loggerhead/templates/revisionfilechanges.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/revisionfilechanges.pt	2007-09-05 18:40:01 +0000
@@ -0,0 +1,67 @@
+<tal:block>
+  <tr tal:repeat="added entry/changes/added">
+    <th class="files">
+      <tal:block condition="repeat/added/start">
+        files added:
+      </tal:block>
+    </th>
+    <td class="files"
+        tal:define="filename python:added[0];
+                    file_id  python:added[1]">
+      <a tal:attributes="href  python:url(['/annotate', entry.revid], file_id=file_id);
+                         title string:Annotate ${filename}"
+         tal:content="filename" class="filename">
+        filename
+      </a>
+    </td>
+  </tr>
+  <tr tal:repeat="removed entry/changes/removed">
+    <th class="files">
+      <tal:block condition="repeat/removed/start">
+        files removed:
+      </tal:block>
+    </th>
+    <td class="files"
+        tal:define="filename python:removed[0];
+                    file_id  python:removed[1]">
+      <a tal:attributes="href  python:url(['/annotate', entry.revid], file_id=file_id);
+                         title string:Annotate ${filename}"
+         tal:content="filename" class="filename">
+        filename
+      </a>
+    </td>
+  </tr>
+  <tr tal:repeat="renamed entry/changes/renamed">
+    <th class="files">
+      <tal:block condition="repeat/renamed/start">
+        files renamed:
+      </tal:block>
+    </th>
+    <td class="files"
+        tal:define="old_filename python:renamed[0];
+                    new_filename python:renamed[1];
+                    file_id      python:renamed[2]">
+      <a tal:attributes="href  python:url(['/annotate', entry.revid], file_id=file_id);
+                         title string:Annotate ${old_filename}"
+         tal:content="old_filename" class="filename">
+        old_filename
+      </a>
+      =>
+      <a tal:attributes="href  python:url(['/annotate', entry.revid], file_id=file_id);
+                         title string:Annotate ${new_filename}"
+         tal:content="new_filename">
+        new_filename
+      </a>
+    </td>
+  </tr>
+  <tr tal:repeat="item entry/changes/modified" class="filename">
+    <th class="files">
+      <tal:block condition="repeat/item/start">
+        files modified:
+      </tal:block>
+    </th>
+    <td class="files">
+        <tal:b content="structure python:modified_file_link(url, entry, item)" />
+    </td>
+  </tr>
+</tal:block>

=== added file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/revisioninfo.pt	2008-06-20 02:13:34 +0000
@@ -0,0 +1,89 @@
+<div class="revision-info">
+  <table>
+    <tr>
+      <th class="author">
+        committed by:
+      </th>
+      <td class="author"
+          tal:content="python:util.hide_email(change.author)">
+        author@email
+      </td>
+    </tr>
+    <tr>
+      <th class="date">
+        date:
+      </th>
+      <td class="date"
+          tal:content="python:util.date_time(change.date)">
+        date
+      </td>
+    </tr>
+
+    <tr tal:repeat="merge_point change/merge_points">
+      <th class="children">
+        <tal:block condition="repeat/merge_point/start">
+          merged in:
+        </tal:block>
+      </th>
+      <td class="children">
+        <a title="Show history"
+           tal:attributes="title string:Show revision ${merge_point/revno};
+                                        href python:url(['/revision', merge_point.revno], clear=1,
+                                                        start_revid=merge_point.revid)"
+           tal:content="python:revno_with_nick(merge_point)">
+          ${text}
+        </a>
+      </td>
+    </tr>
+
+    <tr tal:repeat="parent python:change.parents[1:]">
+      <th class="parents">
+        <tal:block condition="repeat/parent/start">
+          merged from:
+        </tal:block>
+      </th>
+      <td class="parents">
+        <a title="Show history"
+           tal:attributes="title string:Show revision ${parent/revno};
+                           href python:url(['/revision', parent.revno], clear=1, start_revid=parent.revno)"
+           tal:content="python:revno_with_nick(parent)">
+          class="revlink">
+          ${text}
+        </a>
+      </td>
+    </tr>
+
+    <tr>
+      <th class="description">
+        description:
+      </th>
+      <td class="description">
+        <span tal:repeat="line change/comment_clean">
+          <tal:line replace="structure line" />
+          <br />
+        </span>
+      </td>
+    </tr>
+
+    <tr>
+      <th class="revid">
+        revision id:
+      </th>
+      <td class="revid">
+          <span tal:content="python:change.revid">
+              revid
+        </span>
+      </td>
+    </tr>
+
+    <tal:block condition="nocall:modified_file_link">
+      <tr class="divider">
+        <th>
+        </th>
+        <td>
+        </td>
+      </tr>
+      <tal:block content="structure python:file_change_summary(url, change, modified_file_link)" />
+    </tal:block>
+  </table>
+</div>

=== removed file 'loggerhead/templates/welcome.kid'
--- loggerhead/templates/welcome.kid	2006-12-11 06:44:19 +0000
+++ loggerhead/templates/welcome.kid	1970-01-01 00:00:00 +0000
@@ -1,50 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
-    py:extends="'master.kid'">
-<head>
-<meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
-<title>Welcome to TurboGears</title>
-</head>
-<body>
-<div id="header">&nbsp;</div>
-<div id="main_content">
-  <div id="status_block">Your TurboGears application is now running.</div>
-  <!--h1>Take steps to dive right in:</h1-->
-  <div id="sidebar">
-    <h2>Learn more</h2>
-    Learn more about TurboGears and take part in its
-    development
-    <ul class="links">
-      <li><a href="http://www.turbogears.org">Official website</a></li>
-      <li><a href="http://docs.turbogears.org">Documentation</a></li>
-      <li><a href="http://trac.turbogears.org/turbogears/">Trac
-        (bugs/suggestions)</a></li>
-      <li><a href="http://groups.google.com/group/turbogears"> Mailing list</a> </li>
-    </ul>
-  </div>
-  <div id="getting_started">
-    <ol id="getting_started_steps">
-      <li class="getting_started">
-        <h3>Model</h3>
-        <p> <a href="http://docs.turbogears.org/1.0/GettingStarted/DefineDatabase">Design models</a> in the <span class="code">model.py</span>.<br/>
-          Edit <span class="code">dev.cfg</span> to <a href="http://docs.turbogears.org/1.0/GettingStarted/UseDatabase">use a different backend</a>, or start with a pre-configured SQLite database. <br/>
-          Use script <span class="code">tg-admin sql create</span> to create the database tables.</p>
-      </li>
-      <li class="getting_started">
-        <h3>View</h3>
-        <p> Edit <a href="http://docs.turbogears.org/1.0/GettingStarted/Kid">html-like templates</a> in the <span class="code">/templates</span> folder;<br/>
-        Put all <a href="http://docs.turbogears.org/1.0/StaticFiles">static contents</a> in the <span class="code">/static</span> folder. </p>
-      </li>
-      <li class="getting_started">
-        <h3>Controller</h3>
-        <p> Edit <span class="code"> controllers.py</span> and <a href="http://docs.turbogears.org/1.0/GettingStarted/CherryPy">build your
-          website structure</a> with the simplicity of Python objects. <br/>
-          TurboGears will automatically reload itself when you modify your project. </p>
-      </li>
-    </ol>
-    <div class="notice"> If you create something cool, please <a href="http://groups.google.com/group/turbogears">let people know</a>, and consider contributing something back to the <a href="http://groups.google.com/group/turbogears">community</a>.</div>
-  </div>
-  <!-- End of getting_started -->
-</div>
-</body>
-</html>

=== added file 'loggerhead/tests/simple.pt'
--- loggerhead/tests/simple.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/simple.pt	2008-06-18 06:34:10 +0000
@@ -0,0 +1,8 @@
+<html>
+<head>
+<title tal:content="title">simple test page title</title>
+</head>
+<body>
+<div>Hello, <span tal:replace="name">name</span></div>
+</body>
+</html>

=== removed file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2006-12-11 06:44:19 +0000
+++ loggerhead/tests/test_controllers.py	1970-01-01 00:00:00 +0000
@@ -1,16 +0,0 @@
-from turbogears import testutil
-from loggerhead.controllers import Root
-import cherrypy
-
-cherrypy.root = Root()
-
-def test_method():
-    "the index method should return a string called now"
-    import types
-    result = testutil.call(cherrypy.root.index)
-    assert type(result["now"]) == types.StringType
-
-def test_indextitle():
-    "The mainpage should have the right title"
-    testutil.createRequest("/")
-    assert "<TITLE>Welcome to TurboGears</TITLE>" in cherrypy.response.body[0]

=== added file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_corners.py	2008-06-20 02:20:05 +0000
@@ -0,0 +1,68 @@
+import os
+
+from loggerhead.tests.test_simple import BasicTests
+
+
+class TestCornerCases(BasicTests):
+    """Tests that excercise various corner cases."""
+
+    def addFileAndCommit(self, filename, commit_msg):
+        """Make a trivial commit that has 'msg' as its commit message.
+
+        The commit adds a file called 'myfilename' containing the string
+        'foo'.
+        """
+        f = open(os.path.join(self.bzrbranch, filename), 'w')
+        try:
+            f.write("foo")
+        finally:
+            f.close()
+        self.tree.add(filename)
+        self.tree.commit(message=commit_msg)
+
+    def test_revision_only_changing_execute_bit(self):
+        """Check that a commit that only changes the execute bit of a file
+        does not break the rendering."""
+        self.createBranch()
+
+        # Just a commit to have a file to change the execute bit of.
+        msg = 'a very exciting commit message'
+        self.addFileAndCommit('myfilename', msg)
+
+        # Make a commit that changes the execute bit of 'myfilename'.
+        os.chmod(os.path.join(self.bzrbranch, 'myfilename'), 0755)
+        newrevid = self.tree.commit(message='make something executable')
+
+        # Check that it didn't break things.
+        app = self.setUpLoggerhead()
+        res = app.get('/revision/'+newrevid)
+        res.mustcontain('executable')
+
+    def test_empty_commit_message(self):
+        """Check that an empty commit message does not break the rendering."""
+        self.createBranch()
+
+        # Make a commit that has an empty message.
+        self.addFileAndCommit('myfilename', '')
+
+        # Check that it didn't break things.
+        app = self.setUpLoggerhead()
+        res = app.get('/changes')
+        # It's not much of an assertion, but we only really care about
+        # "assert not crashed".
+        res.mustcontain('myfilename')
+
+    def test_whitespace_only_commit_message(self):
+        """Check that a whitespace-only commit message does not break the
+        rendering."""
+        self.createBranch()
+
+        # Make a commit that has a whitespace only message.
+        self.addFileAndCommit('myfilename', '   ')
+
+        # Check that it didn't break things.
+        app = self.setUpLoggerhead()
+        res = app.get('/changes')
+        # It's not much of an assertion, but we only really care about
+        # "assert not crashed".
+        res.mustcontain('myfilename')

=== added file 'loggerhead/tests/test_filechangecache.py'
--- loggerhead/tests/test_filechangecache.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_filechangecache.py	2007-09-10 12:51:42 +0000
@@ -0,0 +1,95 @@
+"""Tests for the FileChangeCache in loggerhead.changecache."""
+
+import shutil
+import tempfile
+
+from loggerhead.changecache import FileChangeCache
+
+class MockEntry:
+    def __init__(self, revid):
+        self.revid = revid
+
+
+class MockHistory:
+    def __init__(self):
+        self.fetched_revids = set()
+    def get_file_changes_uncached(self, entries):
+        output = []
+        for entry in entries:
+            self.fetched_revids.add(entry.revid)
+            output.append(entry.revid)
+        return output
+
+
+class TestFileChangeCache(object):
+
+    # setup_method and teardown_method are so i can run the tests with
+    # py.test and take advantage of the error reporting.
+    def setup_method(self, meth):
+        self.setUp()
+
+    def teardown_method(self, meth):
+        self.tearDown()
+
+    def setUp(self):
+        self.cache_folders = []
+
+    def tearDown(self):
+        for folder in self.cache_folders:
+            shutil.rmtree(folder)
+
+
+    def makeHistoryAndEntriesForRevids(self, revids, fill_cache_with=[]):
+        cache_folder = tempfile.mkdtemp()
+        self.cache_folders.append(cache_folder)
+        self.history = MockHistory()
+        self.cache = FileChangeCache(self.history, cache_folder)
+
+        self.entries = [MockEntry(revid) for revid in revids]
+
+        self.cache.get_file_changes([entry for entry in self.entries
+                                     if entry.revid in fill_cache_with])
+        self.history.fetched_revids.clear()
+
+
+    def test_empty_cache(self):
+        """An empty cache passes all the revids through to the history object.
+        """
+        revids = ['a', 'b']
+        self.makeHistoryAndEntriesForRevids(revids)
+
+        result = self.cache.get_file_changes(self.entries)
+
+        assert result == revids
+        assert self.history.fetched_revids == set(revids)
+
+    def test_full_cache(self):
+        """A full cache passes none of the revids through to the history
+        object.
+        """
+        revids = ['a', 'b']
+        self.makeHistoryAndEntriesForRevids(revids, fill_cache_with=revids)
+
+        result = self.cache.get_file_changes(self.entries)
+
+        assert result == revids
+        assert self.history.fetched_revids == set()
+
+    def test_partial_cache(self):
+        """A partially full cache passes some of the revids through to the
+        history object, and preserves the ordering of the argument list.
+        """
+        # To test the preservation of argument order code, we put the uncached
+        # revid at the beginning, middle and then end of the list of revids
+        # being asked for.
+        for i in range(3):
+            cached_revids = ['a', 'b']
+            revids = cached_revids[:]
+            revids.insert(i, 'uncached')
+            self.makeHistoryAndEntriesForRevids(
+                revids, fill_cache_with=cached_revids)
+
+            result = self.cache.get_file_changes(self.entries)
+            assert result == revids
+
+            assert self.history.fetched_revids == set(['uncached'])

=== removed file 'loggerhead/tests/test_model.py'
--- loggerhead/tests/test_model.py	2006-12-11 06:44:19 +0000
+++ loggerhead/tests/test_model.py	1970-01-01 00:00:00 +0000
@@ -1,22 +0,0 @@
-# If your project uses a database, you can set up database tests
-# similar to what you see below. Be sure to set the db_uri to
-# an appropriate uri for your testing database. sqlite is a good
-# choice for testing, because you can use an in-memory database
-# which is very fast.
-
-from turbogears import testutil, database
-# from loggerhead.model import YourDataClass, User
-
-# database.set_db_uri("sqlite:///:memory:")
-
-# class TestUser(testutil.DBTest):
-#     def get_model(self):
-#         return User
-#     def test_creation(self):
-#         "Object creation should set the name"
-#         obj = User(user_name = "creosote",
-#                       email_address = "spam@python.not",
-#                       display_name = "Mr Creosote",
-#                       password = "Wafer-thin Mint")
-#         assert obj.display_name == "Mr Creosote"
-

=== added file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_simple.py	2008-06-18 12:27:04 +0000
@@ -0,0 +1,123 @@
+import cgi
+import unittest
+import os
+import tempfile
+import shutil
+import logging
+
+import bzrlib.bzrdir
+import bzrlib.osutils
+from configobj import ConfigObj
+
+from loggerhead.history import History
+from loggerhead.apps.branch import BranchWSGIApp
+from paste.fixture import TestApp
+
+
+def test_config_root():
+    from loggerhead.apps.config import Root
+    config = ConfigObj()
+    app = TestApp(Root(config))
+    res = app.get('/')
+    res.mustcontain('loggerhead branches')
+
+
+class BasicTests(object):
+
+    # setup_method and teardown_method are so i can run the tests with
+    # py.test and take advantage of the error reporting.
+    def setup_method(self, meth):
+        self.setUp()
+
+    def teardown_method(self, meth):
+        self.tearDown()
+
+    def setUp(self):
+        logging.basicConfig(level=logging.DEBUG)
+        self.bzrbranch = None
+        self.old_bzrhome = None
+
+    def createBranch(self):
+        self.old_bzrhome = bzrlib.osutils.set_or_unset_env('BZR_HOME', '')
+        self.bzrbranch = tempfile.mkdtemp()
+        self.branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
+            self.bzrbranch, force_new_tree=True)
+        self.tree = self.branch.bzrdir.open_workingtree()
+
+    config_template = """
+    [project]
+        [[branch]]
+            branch_name = 'branch'
+            folder = '%(branch)s'
+    """
+
+    def makeHistory(self):
+        return History.from_folder(self.bzrbranch)
+
+    def setUpLoggerhead(self):
+        app = TestApp(BranchWSGIApp(self.bzrbranch).app)
+        return app
+
+    def tearDown(self):
+        if self.bzrbranch is not None:
+            shutil.rmtree(self.bzrbranch)
+        bzrlib.osutils.set_or_unset_env('BZR_HOME', self.old_bzrhome)
+
+
+class TestWithSimpleTree(BasicTests):
+
+    def setUp(self):
+        BasicTests.setUp(self)
+        self.createBranch()
+
+        f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
+        self.filecontents = ('some\nmultiline\ndata\n'
+                             'with<htmlspecialchars\n')
+        try:
+            f.write(self.filecontents)
+        finally:
+            f.close()
+        self.tree.add('myfilename')
+        self.fileid = self.tree.path2id('myfilename')
+        self.msg = 'a very exciting commit message <'
+        self.revid = self.tree.commit(message=self.msg)
+
+
+    def test_changes(self):
+        app = self.setUpLoggerhead()
+        res = app.get('/changes')
+        res.mustcontain(cgi.escape(self.msg))
+
+    def test_changes_search(self):
+        app = self.setUpLoggerhead()
+        res = app.get('/changes', params={'q': 'foo'})
+        res.mustcontain('Sorry, no results found for your search.')
+
+    def test_annotate(self):
+        app = self.setUpLoggerhead()
+        res = app.get('/annotate', params={'file_id':self.fileid})
+        for line in self.filecontents.splitlines():
+            res.mustcontain(cgi.escape(line))
+
+    def test_inventory(self):
+        app = self.setUpLoggerhead()
+        res = app.get('/files')
+        res.mustcontain('myfilename')
+
+    def test_revision(self):
+        app = self.setUpLoggerhead()
+        res = app.get('/revision/1')
+        res.mustcontain('myfilename')
+
+
+class TestEmptyBranch(BasicTests):
+
+    def setUp(self):
+        BasicTests.setUp(self)
+        self.createBranch()
+
+    def test_changes(self):
+        app = self.setUpLoggerhead()
+        res = app.get('/changes')
+        res.mustcontain('No revisions!')
+

=== added file 'loggerhead/tests/test_templating.py'
--- loggerhead/tests/test_templating.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_templating.py	2008-06-18 06:34:10 +0000
@@ -0,0 +1,12 @@
+from loggerhead.zptsupport import load_template
+
+RENDERED = u"<html>\n<head>\n<title>%s</title>\n</head>\n<body>\n<div>Hello, %s</div>\n</body>\n</html>"
+
+def test_template_lookup():
+    template = load_template("loggerhead.tests.simple")
+    assert template
+    TITLE="test"
+    NAME="World"
+    info = dict(title=TITLE, name=NAME)
+    s = template.expand(**info)
+    assert s.startswith(RENDERED % (TITLE, NAME))

=== removed file 'loggerhead/textindex.py'
--- loggerhead/textindex.py	2007-01-02 07:14:03 +0000
+++ loggerhead/textindex.py	1970-01-01 00:00:00 +0000
@@ -1,233 +0,0 @@
-#
-# Copyright (C) 2006  Robey Pointer <robey@lag.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""
-indexing of the comment text of revisions, for fast searching.
-
-two separate 'shelve' files are created:
-
-    - recorded: revid -> 1 (if the revid is indexed)
-    - index: 3-letter substring -> list(revids)
-"""
-
-import logging
-import os
-import re
-import shelve
-import threading
-import time
-
-from loggerhead import util
-from loggerhead.util import decorator
-from loggerhead.lockfile import LockFile
-
-# if any substring index reaches this many revids, replace the entry with
-# an ALL marker -- it's not worth an explicit index.
-ALL_THRESHOLD = 1000
-ALL = 'ALL'
-
-
-with_lock = util.with_lock('_lock')
-
-
-def normalize_string(s):
-    """
-    remove any punctuation and normalize all whitespace to a single space.
-    """
-    s = util.to_utf8(s).lower()
-    # remove apostrophes completely.
-    s = re.sub(r"'", '', s)
-    # convert other garbage into space
-    s = re.sub(r'[^\w\d]', ' ', s)
-    # compress multiple spaces into one.
-    s = re.sub(r'\s{2,}', ' ', s)
-    # and finally remove leading/trailing whitespace
-    s = s.strip()
-    return s
-
-
-class TextIndex (object):
-    def __init__(self, history, cache_path):
-        self.history = history
-        self.log = history.log
-        
-        if not os.path.exists(cache_path):
-            os.mkdir(cache_path)
-        
-        self._recorded_filename = os.path.join(cache_path, 'textindex-recorded')
-        self._index_filename = os.path.join(cache_path, 'textindex')
-        
-        # use a lockfile since the cache folder could be shared across different processes.
-        self._lock = LockFile(os.path.join(cache_path, 'index-lock'))
-        self._closed = False
-        
-        self.log.info('Using search index; %d entries.', len(self))
-    
-    def _is_indexed(self, revid, recorded):
-        return recorded.get(util.to_utf8(revid), None) is not None
-        
-    @with_lock
-    def is_indexed(self, revid):
-        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
-        try:
-            return self._is_indexed(revid, recorded)
-        finally:
-            recorded.close()
-    
-    @with_lock
-    def __len__(self):
-        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
-        try:
-            return len(recorded)
-        finally:
-            recorded.close()
-
-    @with_lock
-    def close(self):
-        self._closed = True
-    
-    @with_lock
-    def closed(self):
-        return self._closed
-    
-    @with_lock
-    def flush(self):
-        pass
-    
-    @with_lock
-    def full(self):
-        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
-        try:
-            return (len(recorded) >= len(self.history.get_revision_history())) and (util.to_utf8(self.history.last_revid) in recorded)
-        finally:
-            recorded.close()
-
-    def _index_change(self, change, recorded, index):
-        """
-        currently, only indexes the 'comment' field.
-        """
-        comment = normalize_string(change.comment)
-        if len(comment) < 3:
-            return
-        for i in xrange(len(comment) - 2):
-            sub = comment[i:i + 3]
-            revid_set = index.get(sub, None)
-            if revid_set is None:
-                revid_set = set()
-            elif revid_set == ALL:
-                # this entry got too big
-                continue
-            revid_set.add(change.revid)
-            if len(revid_set) > ALL_THRESHOLD:
-                revid_set = ALL
-            index[sub] = revid_set
-        
-        recorded[util.to_utf8(change.revid)] = True
-
-    @with_lock
-    def index_changes(self, revid_list):
-        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
-        index = shelve.open(self._index_filename, 'c', protocol=2)
-        try:
-            revid_list = [r for r in revid_list if not self._is_indexed(r, recorded)]
-            change_list = self.history.get_changes(revid_list)
-            for change in change_list:
-                self._index_change(change, recorded, index)
-        finally:
-            index.close()
-            recorded.close()
-    
-    @with_lock
-    def find(self, text, revid_list=None):
-        index = shelve.open(self._index_filename, 'c', protocol=2)
-        try:
-            text = normalize_string(text)
-            if len(text) < 3:
-                return []
-    
-            total_set = None
-            if revid_list is not None:
-                total_set = set(revid_list)
-            seen_all = False
-            
-            for i in xrange(len(text) - 2):
-                sub = text[i:i + 3]
-                revid_set = index.get(sub, None)
-                if revid_set is None:
-                    # zero matches, stop here.
-                    return []
-                if revid_set == ALL:
-                    # skip
-                    seen_all = True
-                    continue
-                if total_set is None:
-                    total_set = revid_set
-                else:
-                    total_set.intersection_update(revid_set)
-                if len(total_set) == 0:
-                    return []
-        finally:
-            index.close()
-        
-        # tricky: if seen_all is True, one of the substring indices was ALL
-        # (in other words, unindexed), so our results are actually a superset
-        # of the exact answer.
-        #
-        # if we cared, we could do a direct match on the result set and cull
-        # out any that aren't actually matches.  for now, i'm gonna say that
-        # we DON'T care, and if one of the substrings hit ALL, there's a small
-        # chance that we'll give a few false positives.
-        return total_set
-    
-    def check_rebuild(self, max_time=3600):
-        """
-        check if there are any un-indexed revisions, and if so, index them.
-        but don't spend longer than C{max_time} on it.
-        """
-        if self.closed() or self.full():
-            # all done
-            return
-
-        self.log.info('Building search index...')
-        work = list(self.history.get_revision_history())
-        start_time = time.time()
-        last_update = time.time()
-        count = 0
-
-        jump = 100
-        for i in xrange(0, len(work), jump):
-            r = work[i:i + jump]
-            self.index_changes(r)
-            if self.closed():
-                return
-
-            count += jump
-            now = time.time()
-            if now - start_time > 3600:
-                # there's no point working for hours.  eventually we might even
-                # hit the next re-index interval, which would suck mightily.
-                self.log.info('Search indexing has worked for an hour; giving up for now.')
-                return
-            if now - last_update > 60:
-                self.log.info('Search indexing continues: %d/%d' % (min(count, len(work)), len(work)))
-                last_update = time.time()
-            # give someone else a chance at the lock
-            time.sleep(1)
-        self.log.info('Search index completed.')
-        self.flush()
-

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2006-12-24 07:02:43 +0000
+++ loggerhead/util.py	2008-06-20 02:20:05 +0000
@@ -17,56 +17,26 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+try:
+    from xml.etree import ElementTree as ET
+except ImportError:
+    from elementtree import ElementTree as ET
+
+import base64
 import cgi
 import datetime
 import logging
 import re
 import sha
+import struct
 import sys
 import threading
+import time
 import traceback
 
-import turbogears
-
 
 log = logging.getLogger("loggerhead.controllers")
 
-
-def timespan(delta):
-    if delta.days > 730:
-        # good grief!
-        return '%d years' % (int(delta.days // 365.25),)
-    if delta.days >= 3:
-        return '%d days' % delta.days
-    seg = []
-    if delta.days > 0:
-        if delta.days == 1:
-            seg.append('1 day')
-        else:
-            seg.append('%d days' % delta.days)
-    hrs = delta.seconds // 3600
-    mins = (delta.seconds % 3600) // 60
-    if hrs > 0:
-        if hrs == 1:
-            seg.append('1 hour')
-        else:
-            seg.append('%d hours' % hrs)
-    if delta.days == 0:
-        if mins > 0:
-            if mins == 1:
-                seg.append('1 minute')
-            else:
-                seg.append('%d minutes' % mins)
-        elif hrs == 0:
-            seg.append('less than a minute')
-    return ', '.join(seg)
-
-
-def ago(timestamp):
-    now = datetime.datetime.now()
-    return timespan(now - timestamp) + ' ago'
-
-
 def fix_year(year):
     if year < 70:
         year += 2000
@@ -74,6 +44,82 @@
         year += 1900
     return year
 
+# Display of times.
+
+# date_day -- just the day
+# date_time -- full date with time
+#
+# displaydate -- for use in sentences
+# approximatedate -- for use in tables
+#
+# displaydate and approximatedate return an elementtree <span> Element
+# with the full date in a tooltip.
+
+def date_day(value):
+    return value.strftime('%Y-%m-%d')
+
+
+def date_time(value):
+    return value.strftime('%Y-%m-%d %T')
+
+
+def _displaydate(date):
+    delta = abs(datetime.datetime.now() - date)
+    if delta > datetime.timedelta(1, 0, 0):
+        # far in the past or future, display the date
+        return 'on ' + date_day(date)
+    return _approximatedate(date)
+
+
+def _approximatedate(date):
+    delta = datetime.datetime.now() - date
+    if abs(delta) > datetime.timedelta(1, 0, 0):
+        # far in the past or future, display the date
+        return date_day(date)
+    future = delta < datetime.timedelta(0, 0, 0)
+    delta = abs(delta)
+    days = delta.days
+    hours = delta.seconds / 3600
+    minutes = (delta.seconds - (3600*hours)) / 60
+    seconds = delta.seconds % 60
+    result = ''
+    if future:
+        result += 'in '
+    if days != 0:
+        amount = days
+        unit = 'day'
+    elif hours != 0:
+        amount = hours
+        unit = 'hour'
+    elif minutes != 0:
+        amount = minutes
+        unit = 'minute'
+    else:
+        amount = seconds
+        unit = 'second'
+    if amount != 1:
+        unit += 's'
+    result += '%s %s' % (amount, unit)
+    if not future:
+        result += ' ago'
+        return result
+
+
+def _wrap_with_date_time_title(date, formatted_date):
+    elem = ET.Element("span")
+    elem.text = formatted_date
+    elem.set("title", date_time(date))
+    return elem
+
+
+def approximatedate(date):
+    #FIXME: Returns an object instead of a string
+    return _wrap_with_date_time_title(date, _approximatedate(date))
+
+
+def displaydate(date):
+    return _wrap_with_date_time_title(date, _displaydate(date))
+
 
 class Container (object):
     """
@@ -85,7 +131,7 @@
                 setattr(self, key, value)
         for key, value in kw.iteritems():
             setattr(self, key, value)
-    
+
     def __repr__(self):
         out = '{ '
         for key, value in self.__dict__.iteritems():
@@ -140,7 +186,7 @@
         return '%s at %s' % (username, domains[-2])
     return '%s at %s' % (username, domains[0])
 
-    
+
 def triple_factors(min_value=1):
     factors = (1, 3)
     index = 0
@@ -158,10 +204,10 @@
     """
     given a position in a maximum range, return a list of negative and positive
     jump factors for an hgweb-style triple-factor geometric scan.
-    
+
     for example, with pos=20 and max=500, the range would be:
     [ -10, -3, -1, 1, 3, 10, 30, 100, 300 ]
-    
+
     i admit this is a very strange way of jumping through revisions.  i didn't
     invent it. :)
     """
@@ -178,6 +224,7 @@
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
 
+# FIXME: get rid of this method; use fixed_width() and avoid XML().
 def html_clean(s):
     """
     clean up a string for html display.  expand any tabs, encode any html
@@ -185,11 +232,31 @@
     in displaying monospace text.
     """
     s = cgi.escape(s.expandtabs())
-#    s = _BADCHARS_RE.sub(lambda x: '&#%d;' % (ord(x.group(0)),), s)
     s = s.replace(' ', '&nbsp;')
     return s
 
 
+
+NONBREAKING_SPACE = u'\N{NO-BREAK SPACE}'
+
+def fixed_width(s):
+    """
+    expand tabs and turn spaces into "non-breaking spaces", so browsers won't
+    chop up the string.
+    """
+    if not isinstance(s, unicode):
+        # this kinda sucks.  file contents are just binary data, and no
+        # encoding metadata is stored, so we need to guess.  this is probably
+        # okay for most code, but for people using things like KOI-8, this
+        # will display gibberish.  we have no way of detecting the correct
+        # encoding to use.
+        try:
+            s = s.decode('utf-8')
+        except UnicodeDecodeError:
+            s = s.decode('iso-8859-15')
+    return s.expandtabs().replace(' ', NONBREAKING_SPACE)
+
+
 def fake_permissions(kind, executable):
     # fake up unix-style permissions given only a "kind" and executable bit
     if kind == 'directory':
@@ -208,6 +275,27 @@
     return format % value
 
 
+def b64(s):
+    s = base64.encodestring(s).replace('\n', '')
+    while (len(s) > 0) and (s[-1] == '='):
+        s = s[:-1]
+    return s
+
+
+def uniq(uniqs, s):
+    """
+    turn a potentially long string into a unique smaller string.
+    """
+    if s in uniqs:
+        return uniqs[s]
+    uniqs[type(None)] = next = uniqs.get(type(None), 0) + 1
+    x = struct.pack('>I', next)
+    while (len(x) > 1) and (x[0] == '\x00'):
+        x = x[1:]
+    uniqs[s] = b64(x)
+    return uniqs[s]
+
+
 KILO = 1024
 MEG = 1024 * KILO
 GIG = 1024 * MEG
@@ -227,7 +315,7 @@
         divisor = MEG
     else:
         divisor = KILO
-    
+
     dot = size % divisor
     base = size - dot
     dot = dot * 10 // divisor
@@ -235,7 +323,7 @@
     if dot >= 10:
         base += 1
         dot -= 10
-    
+
     out = str(base)
     if (base < 100) and (dot != 0):
         out += '.%d' % (dot,)
@@ -246,38 +334,47 @@
     elif divisor == GIG:
         out += 'G'
     return out
-    
-
-def fill_in_navigation(history, navigation):
+
+
+def fill_in_navigation(navigation):
     """
     given a navigation block (used by the template for the page header), fill
     in useful calculated values.
     """
-    navigation.position = history.get_revid_sequence(navigation.revid_list, navigation.revid)
-    if navigation.position is None:
+    if navigation.revid in navigation.revid_list: # XXX is this always true?
+        navigation.position = navigation.revid_list.index(navigation.revid)
+    else:
         navigation.position = 0
     navigation.count = len(navigation.revid_list)
     navigation.page_position = navigation.position // navigation.pagesize + 1
     navigation.page_count = (len(navigation.revid_list) + (navigation.pagesize - 1)) // navigation.pagesize
-    
+
     def get_offset(offset):
         if (navigation.position + offset < 0) or (navigation.position + offset > navigation.count - 1):
             return None
         return navigation.revid_list[navigation.position + offset]
-    
+
     navigation.prev_page_revid = get_offset(-1 * navigation.pagesize)
     navigation.next_page_revid = get_offset(1 * navigation.pagesize)
-    
-    params = { 'file_id': navigation.file_id }
+    prev_page_revno = navigation.branch.history.get_revno(
+            navigation.prev_page_revid)
+    next_page_revno = navigation.branch.history.get_revno(
+            navigation.next_page_revid)
+    start_revno = navigation.branch._history.get_revno(navigation.start_revid)
+
+    params = { 'filter_file_id': navigation.filter_file_id }
     if getattr(navigation, 'query', None) is not None:
         params['q'] = navigation.query
-    else:
-        params['start_revid'] = navigation.start_revid
-        
+
+    if getattr(navigation, 'start_revid', None) is not None:
+        params['start_revid'] = start_revno
+
     if navigation.prev_page_revid:
-        navigation.prev_page_url = navigation.branch.url([ navigation.scan_url, navigation.prev_page_revid ], **params)
+        navigation.prev_page_url = navigation.branch.context_url(
+            [navigation.scan_url, prev_page_revno], **params)
     if navigation.next_page_revid:
-        navigation.next_page_url = navigation.branch.url([ navigation.scan_url, navigation.next_page_revid ], **params)
+        navigation.next_page_url = navigation.branch.context_url(
+            [navigation.scan_url, next_page_revno], **params)
 
 
 def log_exception(log):
@@ -305,13 +402,102 @@
     @decorator
     def _decorator(unbound):
         def locked(self, *args, **kw):
-            #self.log.debug('-> %r lock %r', id(threading.currentThread()), debug_name)
             getattr(self, lockname).acquire()
             try:
                 return unbound(self, *args, **kw)
             finally:
                 getattr(self, lockname).release()
-                #self.log.debug('<- %r unlock %r', id(threading.currentThread()), debug_name)
         return locked
     return _decorator
 
+
+@decorator
+def strip_whitespace(f):
+    def _f(*a, **kw):
+        out = f(*a, **kw)
+        orig_len = len(out)
+        out = re.sub(r'\n\s+', '\n', out)
+        out = re.sub(r'[ \t]+', ' ', out)
+        out = re.sub(r'\s+\n', '\n', out)
+        new_len = len(out)
+        log.debug('Saved %sB (%d%%) by stripping whitespace.',
+                  human_size(orig_len - new_len),
+                  round(100.0 - float(new_len) * 100.0 / float(orig_len)))
+        return out
+    return _f
+
+
+@decorator
+def lsprof(f):
+    def _f(*a, **kw):
+        from loggerhead.lsprof import profile
+        import cPickle
+        z = time.time()
+        ret, stats = profile(f, *a, **kw)
+        log.debug('Finished profiled %s in %d msec.' % (f.__name__, int((time.time() - z) * 1000)))
+        stats.sort()
+        stats.freeze()
+        now = time.time()
+        msec = int(now * 1000) % 1000
+        timestr = time.strftime('%Y%m%d%H%M%S', time.localtime(now)) + ('%03d' % msec)
+        filename = f.__name__ + '-' + timestr + '.lsprof'
+        cPickle.dump(stats, open(filename, 'w'), 2)
+        return ret
+    return _f
+
+
+# just thinking out loud here...
+#
+# so, when browsing around, there are 5 pieces of context, most optional:
+#     - current revid
+#         current location along the navigation path (while browsing)
+#     - starting revid (start_revid)
+#         the current beginning of navigation (navigation continues back to
+#         the original revision) -- this defines an 'alternate mainline'
+#         when the user navigates into a branch.
+#     - file_id
+#         the file being looked at
+#     - filter_file_id
+#         if navigating the revisions that touched a file
+#     - q (query)
+#         if navigating the revisions that matched a search query
+#     - remember
+#         a previous revision to remember for future comparisons
+#
+# current revid is given on the url path.  the rest are optional components
+# in the url params.
+#
+# other transient things can be set:
+#     - compare_revid
+#         to compare one revision to another, on /revision only
+#     - sort
+#         for re-ordering an existing page by different sort
+
+t_context = threading.local()
+_valid = ('start_revid', 'file_id', 'filter_file_id', 'q', 'remember',
+          'compare_revid', 'sort')
+
+
+def set_context(map):
+    t_context.map = dict((k, v) for (k, v) in map.iteritems() if k in _valid)
+
+
+def get_context(**overrides):
+    """
+    Soon to be deprecated.
+
+
+    return a context map that may be overriden by specific values passed in,
+    but only contains keys from the list of valid context keys.
+
+    if 'clear' is set, only the 'remember' context value will be added, and
+    all other context will be omitted.
+    """
+    map = dict()
+    if overrides.get('clear', False):
+        map['remember'] = t_context.map.get('remember', None)
+    else:
+        map.update(t_context.map)
+    overrides = dict((k, v) for (k, v) in overrides.iteritems() if k in _valid)
+    map.update(overrides)
+    return map

=== added file 'loggerhead/zptsupport.py'
--- loggerhead/zptsupport.py	1970-01-01 00:00:00 +0000
+++ loggerhead/zptsupport.py	2008-06-18 06:34:10 +0000
@@ -0,0 +1,66 @@
+"""Support for Zope Page Templates using the simpletal library."""
+
+import logging
+import os
+import pkg_resources
+import StringIO
+
+from simpletal import simpleTAL, simpleTALES
+
+logging.getLogger("simpleTAL").setLevel(logging.INFO)
+logging.getLogger("simpleTALES").setLevel(logging.INFO)
+
+
+_zpt_cache = {}
+def zpt(tfile):
+    tinstance = _zpt_cache.get(tfile)
+    stat = os.stat(tfile)
+    if tinstance is None or tinstance.stat != stat:
+        tinstance = _zpt_cache[tfile] = TemplateWrapper(
+            simpleTAL.compileXMLTemplate(open(tfile)), tfile, stat)
+    return tinstance
+
+
+class TemplateWrapper(object):
+
+    def __init__(self, template, filename, stat):
+        self.template = template
+        self.filename = filename
+        self.stat = stat
+
+    def expand(self, **info):
+        context = simpleTALES.Context(allowPythonPath=1)
+        for k, v in info.iteritems():
+            context.addGlobal(k, v)
+        s = StringIO.StringIO()
+        self.template.expandInline(context, s)
+        return s.getvalue()
+
+    def expand_into(self, f, **info):
+        context = simpleTALES.Context(allowPythonPath=1)
+        for k, v in info.iteritems():
+            context.addGlobal(k, v)
+        self.template.expand(context, f, 'utf-8')
+
+    @property
+    def macros(self):
+        return self.template.macros
+
+
+def load_template(classname):
+    """Searches for a template along the Python path.
+
+    Template files must end in ".pt" and be in legitimate packages.
+    Templates are automatically checked for changes and reloaded as
+    neccessary.
+    """
+    divider = classname.rfind(".")
+    if divider > -1:
+        package = classname[0:divider]
+        basename = classname[divider+1:]
+    else:
+        raise ValueError, "All templates must be in a package"
+
+    tfile = pkg_resources.resource_filename(
+        package, "%s.%s" % (basename, "pt"))
+    return zpt(tfile)

=== removed file 'push-website'
--- push-website	2006-12-29 21:51:12 +0000
+++ push-website	1970-01-01 00:00:00 +0000
@@ -1,7 +0,0 @@
-#!/bin/bash
-#
-# this is only useful for robey.  it updates the public website.
-#
-
-rsync -avr homepage/ robey@tavi.lag.net:/web/loggerhead
-

=== removed file 'sample-prod.cfg'
--- sample-prod.cfg	2006-12-11 06:44:19 +0000
+++ sample-prod.cfg	1970-01-01 00:00:00 +0000
@@ -1,71 +0,0 @@
-[global]
-# This is where all of your settings go for your production environment.
-# You'll copy this file over to your production server and provide it
-# as a command-line option to your start script.
-# Settings that are the same for both development and production
-# (such as template engine, encodings, etc.) all go in 
-# loggerhead/config/app.cfg
-
-# pick the form for your database
-# sqlobject.dburi="postgres://username@hostname/databasename"
-# sqlobject.dburi="mysql://username:password@hostname:port/databasename"
-# sqlobject.dburi="sqlite:///file_name_and_path"
-
-# If you have sqlite, here's a simple default to get you started
-# in development
-sqlobject.dburi="sqlite://%(current_dir_uri)s/devdata.sqlite"
-
-
-# if you are using a database or table type without transactions
-# (MySQL default, for example), you should turn off transactions
-# by prepending notrans_ on the uri
-# sqlobject.dburi="notrans_mysql://username:password@hostname:port/databasename"
-
-# for Windows users, sqlite URIs look like:
-# sqlobject.dburi="sqlite:///drive_letter:/path/to/file"
-
-
-# SERVER
-
-server.environment="production"
-
-# Sets the number of threads the server uses
-# server.thread_pool = 1
-
-# if this is part of a larger site, you can set the path
-# to the TurboGears instance here
-# server.webpath=""
-
-# session_filter.on = True
-
-# Set to True if you'd like to abort execution if a controller gets an
-# unexpected parameter. False by default
-# tg.strict_parameters = False
-
-# LOGGING
-# Logging configuration generally follows the style of the standard
-# Python logging module configuration. Note that when specifying
-# log format messages, you need to use *() for formatting variables.
-# Deployment independent log configuration is in loggerhead/config/log.cfg
-[logging]
-
-[[handlers]]
-
-[[[access_out]]]
-# set the filename as the first argument below
-args="('server.log',)"
-class='FileHandler'
-level='INFO'
-formatter='message_only'
-
-[[loggers]]
-[[[loggerhead]]]
-level='ERROR'
-qualname='loggerhead'
-handlers=['error_out']
-
-[[[access]]]
-level='INFO'
-qualname='turbogears.access'
-handlers=['access_out']
-propagate=0

=== added file 'serve-branches.py'
--- serve-branches.py	1970-01-01 00:00:00 +0000
+++ serve-branches.py	2008-06-23 02:23:46 +0000
@@ -0,0 +1,30 @@
+#!/usr/bin/env python
+import sys
+
+from paste import httpserver
+from paste.httpexceptions import HTTPExceptionHandler
+from paste.translogger import TransLogger
+
+from loggerhead.apps.filesystem import BranchesFromFileSystemRoot
+
+if len(sys.argv) > 1:
+    path = sys.argv[1]
+else:
+    path = '.'
+
+app = BranchesFromFileSystemRoot(path)
+
+app = HTTPExceptionHandler(app)
+app = TransLogger(app)
+
+try:
+    from paste.deploy.config import PrefixMiddleware
+except ImportError:
+    pass
+else:
+    app = PrefixMiddleware(app)
+
+#from paste.evalexception import EvalException
+#app = EvalException(app)
+
+httpserver.serve(app, host='0.0.0.0', port='8080')

=== modified file 'setup.py'
--- setup.py	2006-12-23 19:29:05 +0000
+++ setup.py	2008-02-28 04:34:51 +0000
@@ -15,17 +15,20 @@
     url=url,
     download_url=download_url,
     license=license,
+    maintainer="Michael Hudson",
+    maintainer_email="michael.hudson@canonical.com",
     
     install_requires = [
         "TurboGears >= 1.0b1",
-        "bzr >= 0.13",
+# for some reason, distutils can't find bzr.
+#        "bzr >= 0.13",
     ],
-    scripts = ["start-loggerhead.py"],
+    scripts = ["start-loggerhead.py", "stop-loggerhead.py"],
     zip_safe=False,
     packages=find_packages(),
     package_data = find_package_data(where='loggerhead',
                                      package='loggerhead'),
-    data_files = find_package_data(where='loggerhead', package='loggerhead'),
+#    data_files = find_package_data(where='loggerhead', package='loggerhead'),
     keywords = [
         'turbogears.app',
     ],

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2006-12-20 09:29:42 +0000
+++ start-loggerhead.py	2008-06-23 01:40:28 +0000
@@ -1,28 +1,144 @@
-#!/usr/bin/env python2.4
-import pkg_resources
-pkg_resources.require("TurboGears")
-
-import turbogears
-import cherrypy
-cherrypy.lowercase_api = True
-
-from os.path import *
+#!/usr/bin/env python
+
+import logging
+import logging.handlers
+from optparse import OptionParser
+import os
 import sys
-
-# first look on the command line for a desired config file,
-# if it's not on the command line, then
-# look for setup.py in this directory. If it's not there, this script is
-# probably installed
-if len(sys.argv) > 1:
-    turbogears.update_config(configfile=sys.argv[1], 
-        modulename="loggerhead.config")
-elif exists(join(dirname(__file__), "setup.py")):
-    turbogears.update_config(configfile="dev.cfg",
-        modulename="loggerhead.config")
-else:
-    turbogears.update_config(configfile="prod.cfg",
-        modulename="loggerhead.config")
-
-from loggerhead.controllers import Root
-
-turbogears.start_server(Root)
+import urlparse
+
+from configobj import ConfigObj
+
+from paste import httpserver
+from paste.httpexceptions import make_middleware
+from paste.translogger import make_filter
+
+from loggerhead import daemon, release
+from loggerhead.apps.config import Root
+
+
+def make_handler(config, filename):
+    roll = config.get('log.roll', 'never')
+    if roll == 'daily':
+        h = logging.handlers.TimedRotatingFileHandler(filename, 'midnight', 0, 100)
+    elif roll == 'weekly':
+        h = logging.handlers.TimedRotatingFileHandler(filename, 'W0', 0, 100)
+    else:
+        h = logging.FileHandler(filename)
+    return h
+
+
+def setup_logging(home, config, foreground):
+    # i hate that stupid logging config format, so just set up logging here.
+
+    log_folder = os.path.join(home, 'logs')
+    if not os.path.exists(log_folder):
+        os.mkdir(log_folder)
+
+    f = logging.Formatter('%(levelname)-.3s [%(asctime)s.%(msecs)03d] %(name)s: %(message)s',
+                          '%Y%m%d-%H:%M:%S')
+    debug_log = make_handler(config, os.path.join(log_folder, 'debug.log'))
+    debug_log.setLevel(logging.DEBUG)
+    debug_log.setFormatter(f)
+    if foreground:
+        stdout_log = logging.StreamHandler(sys.stdout)
+        stdout_log.setLevel(logging.DEBUG)
+        stdout_log.setFormatter(f)
+    f = logging.Formatter('[%(asctime)s.%(msecs)03d] %(message)s',
+                          '%Y%m%d-%H:%M:%S')
+    access_log = make_handler(config, os.path.join(log_folder, 'access.log'))
+    access_log.setLevel(logging.INFO)
+    access_log.setFormatter(f)
+
+    logging.getLogger('').addHandler(debug_log)
+    logging.getLogger('turbogears.access').addHandler(access_log)
+    logging.getLogger('turbogears.controllers').setLevel(logging.INFO)
+
+    if foreground:
+        logging.getLogger('').addHandler(stdout_log)
+
+
+
+def main():
+    parser = OptionParser(usage='usage: %prog [options]', version='%prog ' + release.version)
+    parser.add_option('-f', '--foreground', action='store_true', dest='foreground', default=False,
+                      help="run in the foreground; don't daemonize")
+    parser.add_option('-C', '--check', action='store_true', dest='check', default=False,
+                      help="only start if not already running (useful for cron jobs)")
+    options, args = parser.parse_args()
+    if len(args) > 0:
+        parser.error('No filename arguments are used, only options.')
+
+
+    home = os.path.realpath(os.path.dirname(__file__))
+    pidfile = os.path.join(home, 'loggerhead.pid')
+
+    if options.check:
+        if daemon.is_running(pidfile):
+            sys.exit(0)
+        sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (pidfile,))
+
+    # read loggerhead config
+
+    config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
+    extra_path = config.get('bzrpath', None)
+    if extra_path:
+        sys.path.insert(0, extra_path)
+
+    #turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
+
+    potential_overrides = [ ('server.socket_port', int),
+                            ('server.webpath', str),
+                            ('server.thread_pool', int),
+                            ('server.socket_host' ,str) ]
+    server_port = int(config.get('server.socket_port', 8080))
+    nworkers = int(config.get('server.thread_pool', 10))
+    server_host = config.get('server.socket_host', '0.0.0.0')
+    webpath = config.get('server.webpath', None)
+
+    for key, keytype in potential_overrides:
+        value = config.get(key, None)
+        if value is not None:
+            value = keytype(value)
+            #turbogears.config.update({ key: value })
+
+    if not options.foreground:
+        sys.stderr.write('\n')
+        sys.stderr.write('Launching loggerhead into the background.\n')
+        sys.stderr.write('PID file: %s\n' % (pidfile,))
+        sys.stderr.write('\n')
+
+        daemon.daemonize(pidfile, home)
+
+    setup_logging(home, config, foreground=options.foreground)
+
+    log = logging.getLogger('loggerhead')
+    log.info('Starting up...')
+
+    app = Root(config)
+
+    app = app
+    app = make_middleware(app)
+    app = make_filter(app, None)
+
+    if webpath:
+        scheme, netloc, path, blah, blah, blah = urlparse.urlparse(webpath)
+        def app(environ, start_response, orig=app):
+            environ['SCRIPT_NAME'] = path
+            environ['HTTP_HOST'] = netloc
+            return orig(environ, start_response)
+
+    try:
+        httpserver.serve(
+            app, host=server_host, port=server_port,
+            threadpool_workers=nworkers)
+    finally:
+        log.info('Shutdown.')
+        try:
+            os.remove(pidfile)
+        except OSError:
+            pass
+
+
+if __name__ == '__main__':
+    main()

=== added file 'stop-loggerhead.py'
--- stop-loggerhead.py	1970-01-01 00:00:00 +0000
+++ stop-loggerhead.py	2008-06-18 04:30:50 +0000
@@ -0,0 +1,31 @@
+#!/usr/bin/env python
+
+import pkg_resources
+pkg_resources.require("TurboGears")
+
+import os
+import sys
+
+home = os.path.realpath(os.path.dirname(__file__))
+pidfile = os.path.join(home, 'loggerhead.pid')
+
+try:
+    f = open(pidfile, 'r')
+except IOError, e:
+    print 'No pid file found.'
+    sys.exit(1)
+
+pid = int(f.readline())
+
+try:
+    os.kill(pid, 0)
+except OSError, e:
+    print 'Stale pid file; server is not running.'
+    sys.exit(1)
+
+print
+print 'Shutting down previous server @ pid %d.' % (pid,)
+print
+
+import signal
+os.kill(pid, signal.SIGINT)

